<?php

/* 
 *	W-AGORA 4.0
 *	-----------
 *	$Id: admin_forum.php,v 1.28 2002/04/05 13:49:25 mdruilhe Exp $
 *	Usage:		Administration of a forum
 *	Authors:	Marc Druilhe <mdruilhe@w-agora.net>
 *				Franky <mailto:liedekef@pandora.be>
 */	

require ("init_admin.inc");

# ------------------------------------------------
# list forums if none has been selected, then exit
# ------------------------------------------------
if (empty($bn)) {
	require ("$site_cfg_file");
	display_header (sprintf (TITLE_FORUM_ADMINISTRATION, $site) );
	if ($auth->level >= ADMIN ) {
#	get all forums if user is administrator
		$forums = $db->listForums ($site);
	} else {
#	gets only forums for which we are moderator
		$forums = $db->listForums ($site, $auth->userid);
	}
	if (is_array($forums)) {
		list_forums ($forums, LABEL_CHOOSE_FORUM, "_top");
	} else {
		if ($auth->level >= ADMIN ) {
			msgForm (sprintf(ERROR_NO_FORUM_ADMIN, $site), "create_forum.${ext}?site=$site");
		} else {
			msgForm (str_replace("{SITE}", $site, ERROR_NO_FORUM), "", "exit");
		}
	}
	exit;
}

$action = isset($action) ? $action : "main";

switch ($action) {

#	--------------------
#	LEFT FRAME - MENU 
#	--------------------
	case "menu":

		$forum = $db->getForum($site, $bn);

		if ($auth->level >= ADMIN ) {
			$forums = $db->getForums ($site);
		} else {
			$forums = $db->getForums ($site, $auth->userid);
		} 
		if (is_array($forums) && count ($forums)>1) {
			$choose_forum_box = getListBox ("bn", $forums, "$bn", 0,  "top.location=('admin_forum.$ext?site=$site&bn='+this.options[this.selectedIndex].value)");
			$choose_forum_form = "<form action='admin_forum.$ext' target='_top'><input type='hidden' name='site' value='$site'>". LABEL_JUMP_TO . $choose_forum_box. '</form>';
		}

		print '<link rel="stylesheet" href="style.css">';
		print '<center><a href="http://www.w-agora.net" target="_top">';
		print '<IMG SRC="images/logo1_admin.jpg" border=0 alt="' .LABEL_AGORA_WEBSITE.'"></a></center>';

		left_menu_header (LABEL_FORUM . ':<br>'.anchor ("admin_site.${ext}?site=$site&bn=","_top", "$site", LABEL_ADMINISTRATION_MAIN).' &gt;  <b><font color="red">'.  $forum['bn_title'].'</font></b>');
		echo "<tr><td class=info colspan=2>" . LABEL_LOGGED_AS.': <b>'.$auth->userid.'</b></td></tr>';
		echo "<tr><td class=info colspan=2>" . LABEL_PRIVILEGE.': <b>'.$user_privs[$auth->type].'</b><hr noshade color="#a0aab6" width="90%"></td></tr>';

		left_menu_item ("admin_site.$ext?site=$site&force_login=1", "_top", LABEL_LOGIN, LABEL_RELOGIN);
		left_menu_item ("admin.$ext?site=agora&bn=", "_top", LABEL_SITES, LABEL_ADMINISTRATION_MAIN);
		left_menu_item ("admin.$ext?site=$site&bn=", "_top", LABEL_SITE." $site", sprintf(ALT_ADMINISTRATION_SITE, $site) );
		left_menu_item ("$main_page?site=$site&bn=$bn", "$bn", LABEL_ACCESS_THIS_FORUM, ALT_ACCESS_FORUM); 
		if (is_array($forums) && count ($forums)>1) {
			print '<TR><TD valign="top" align="right">&nbsp;&nbsp;<img src="images/fleche-s.gif" width=5 height=5 align="center" alt=".">&nbsp;</td><td width="100%" valign="top" class="item">'.$choose_forum_form;
		}
		left_menu_footer();

		include "$cfg_file";

		// NOTES
		left_menu_header (TITLE_NOTES_MANAGEMENT);
		left_menu_item ("moderate_notes.$ext?site=$site&bn=$bn","edit_frame", LABEL_VALIDATE_NOTES, ALT_VALIDATE_NOTES);
		left_menu_item ("delete_notes.$ext?site=$site&bn=$bn","edit_frame", LABEL_EDIT_NOTES, ALT_EDIT_NOTES);
		left_menu_item ("delete_threads.$ext?site=$site&bn=$bn","edit_frame",LABEL_MANAGE_THREADS, ALT_MANAGE_THREADS);
		left_menu_item ("post.$ext?site=$site&bn=$bn","edit_frame",LABEL_POST, ALT_POST);
		left_menu_footer();

		//USERS
		left_menu_header (LABEL_USERS);
		left_menu_item ("edit_user.$ext?site=$site&bn=$bn&state=all","edit_frame", COLUMN_SHOWEDIT, ALT_USER_SHOWEDIT);
		left_menu_item ("add_user.$ext?site=$site","edit_frame", LABEL_ADD_USER, ALT_USER_ADD);
		left_menu_item ("create_user.$ext?site=$site&bn=$bn","edit_frame", COLUMN_CREATE, ALT_USER_CREATE);
		left_menu_item ("delete_user.$ext?site=$site", "edit_frame", COLUMN_DELETE, ALT_USER_DELETE);
		left_menu_item ("mail_users.$ext?site=$site&bn=$bn", "edit_frame", COLUMN_MAIL_USERS, ALT_MAIL_USERS);
		left_menu_footer();

		//CONFIGURATION
		if ($auth->level >= ADMIN ) {
			left_menu_header (LABEL_CONFIGURATION);
			left_menu_item ("editconf.$ext?site=$site&bn=$bn&mode=basic","edit_frame", LABEL_BASIC, ALT_BASIC);
			left_menu_item ("editconf.$ext?site=$site&bn=$bn&mode=advanced","edit_frame", LABEL_ADVANCED, ALT_ADVANCED);
			left_menu_item ("edit_forum.$ext?site=$site&bn=$bn","edit_frame", LABEL_PROPERTIES, ALT_PROPERTIES);
			left_menu_footer();
		}

		//LAYOUTS
		if ($auth->level > ADMIN ) {
			left_menu_header (LABEL_LAYOUT);
			left_menu_item ("editlist.$ext?site=$site&bn=$bn","edit_frame", COLUMN_NOTES_LISTING, ALT_NOTES_LISTING);
			left_menu_item ("editmsg.$ext?site=$site&bn=$bn","edit_frame", COLUMN_MESSAGES, ALT_AGORA_MESSAGES);
			left_menu_item ("editform.$ext?site=$site&bn=$bn&file=form","edit_frame", COLUMN_FORM, ALT_FORM);
			left_menu_item ("editform.$ext?site=$site&bn=$bn&file=search_form","edit_frame", COLUMN_SEARCH_FORM, ALT_SEARCH_FORM);
			left_menu_item ("editfields.$ext?site=$site&bn=$bn","edit_frame", COLUMN_FIELDS, ALT_FIELDS);
			left_menu_item ("edittemplate.$ext?site=$site&bn=$bn","edit_frame", COLUMN_TEMPLATE, ALT_TEMPLATE);
			left_menu_item ("editform.$ext?site=$site&bn=$bn&file=header","edit_frame", LABEL_HEADER, ALT_HEADER);
			left_menu_item ("editform.$ext?site=$site&bn=$bn&file=footer","edit_frame", LABEL_FOOTER, ALT_FOOTER);
			left_menu_item ("editform.$ext?site=$site&bn=$bn&file=style","edit_frame", LABEL_STYLESHEET, ALT_MODIFY_STYLESHEET);
			left_menu_item ("editform.$ext?site=$site&bn=$bn&file=before_access","edit_frame", COLUMN_INCLUDED, ALT_INCLUDED);
			left_menu_item ("editform.$ext?site=$site&bn=$bn&file=login_form","edit_frame", COLUMN_LOGIN, ALT_LOGIN);
			left_menu_item ("editform.$ext?site=$site&bn=$bn&file=register_form","edit_frame", COLUMN_REGISTER, ALT_REGISTER);
			left_menu_item ("editform.$ext?site=$site&bn=$bn&file=show_profile","edit_frame", COLUMN_PROFILE_FORM, ALT_PROFILE);
			left_menu_item ("editform.$ext?site=$site&bn=$bn&file=change_password_form","edit_frame", COLUMN_CHANGE_PASSWORD, ALT_CHANGE_PASSWORD);
			left_menu_item ("editform.$ext?site=$site&bn=$bn&file=forgot_password_form","edit_frame", COLUMN_FORGOT_PASSWORD, ALT_FORGOT_PASSWORD);
			left_menu_item ("editmail.$ext?site=$site&bn=$bn&file=mail_template","edit_frame",COLUMN_MAIL, ALT_MAIL);
			left_menu_item ("editform.$ext?site=$site&bn=$bn&file=subscribe_form","edit_frame", COLUMN_SUBSCRIBING, ALT_SUBSCRIBING);
			left_menu_footer();
		}
	break;

#	-----------------------------------------
#	MAIN PAGE - ENTRY POINT
#	display frames : top menu + configuration
#	-----------------------------------------
	default:
		print '<HEAD><TITLE>'. LABEL_FORUM_ADMINISTRATION . $forum_name. '</TITLE></HEAD>';
		frameset ("$WA_SELF?action=menu&site=$site&bn=$bn", "moderate_notes.$ext?site=$site&bn=$bn");
	break;

}

?>
</HTML>

