<?php

/*
 *	W-AGORA 4.0
 *	-----------
 *	$Id: delete.php,v 1.12 2002/03/10 22:13:53 mdruilhe Exp $
 *	Usage:		Delete note in forum
 *	Author:		Marc Druilhe <mdruilhe@w-agora.com>
 *
 */

# initialization stuff
# --------------------
 	$bn_action="delete";
	$bn_action_mode="W";
	include "init.inc";

# if note to delete is not defined then return to the list
# --------------------------------------------------------
	if (!$key) {
		display_header (LABEL_DELETE_NOTE, $header_footer);
		MsgForm (Msg(3), "list.$ext", "");
		display_footer ($header_footer);
	}

# Check that the "allow delete" option is set on this forum
# If it is not, then only the moderator of this board can delete a message
# ------------------------------------------------------------------------
	if (!$bn_delete && !$is_moderator) {
		display_header (LABEL_DELETE_NOTE, $header_footer);
		MsgForm (msg(48), "view.$ext?key=$key", "");
		display_footer ($header_footer);
	}

# read note in order to insure that this note exists and to get userid/password of the owner
# ---------------------------------------------------------------------------------------
	$note = $db->getNote ($bn_db, $key);
	if (!$note) {
		display_header (LABEL_DELETE_NOTE, $header_footer);
		MsgForm (Msg(10), "list.$ext", "");
		display_footer ($header_footer);
	}

# Check that this user is either a moderator or the original poster of this note
# -------------------------------------------------------------------------------
	if ($is_moderator) {
		$is_owner=true;
	} else {
		if ($is_authenticated) {		// authenticated user but not a moderator
			if ($auth->user["userid"] == $note["userid"]) {
				$is_owner = true;
			} else {
				display_header (LABEL_DELETE_NOTE, $header_footer);
				MsgForm (msg(48), "view.$ext?key=$key", 'back'); // access forbidden
				display_footer ($header_footer);
			}
		} else {
			$is_owner = false;
		}
	} 

# ----------------------------------------------
# delete FORM has been submitted -> do the stuff
# ----------------------------------------------
	if ($do_delete) {
		
# Execute before_access program
# ------------------------------
		if (!empty($bn_before_access)) {
			if (file_exists ("$bn_dir/$bn_before_access") ) {
				include "$bn_dir/$bn_before_access";
			} else {
				include "$bn_dir_default/$bn_before_access";
			}
		} elseif (file_exists ("$bn_dir_default/before_access.$ext") ) {
			include ("$bn_dir_default/before_access.$ext");
		}

		display_header (LABEL_DELETE_NOTE, $header_footer);

# Check that either this user is owner of this note or has entered the password
# -----------------------------------------------------------------------------
		if (!$is_owner && (md5($password) != $note["password"])) {
			MsgForm (msg(12), "view.$ext?key=$key", 'back'); // invalid password
			display_footer ($header_footer);
		}

# delete the note from the database
# ---------------------------------
		$ret = $db->deleteNote ($bn_db, $key, $bn_dir_notes);
		if ($ret < 0) {
			MsgForm (Msg (13), "list.$ext?bn=$bn&first=$first&last=$last&expnd=$expnd", "");
			display_footer ($header_footer);
		}

# Start search indexation if a search engine is configured
# --------------------------------------------------------
		if ($bn_search && ($bn_doc_type == "static") && ($bn_search_engine != "none") ) {
			include "$inc_dir/$bn_search_engine.$ext";
			$search->indexNotes();
		}

# Displays success message then exit
# ----------------------------------
		MsgForm (Msg (14), "list.$ext?bn=$bn&expnd=$expnd&sort=$sort&force_refresh=1", "");
		display_footer ($header_footer);
		exit;
	} // do_delete


# ----------------------------------------------------------
# First ACCESS => displays confirmation FORM + displays note
# ----------------------------------------------------------

# do_delete not set => set all fields as global variables
# -------------------------------------------------------
	extract($note);

# Execute before_access program
# ------------------------------
 	$bn_action="view";
	if (!empty($bn_before_access)) {
		if (file_exists ("$bn_dir/$bn_before_access") ) {
			include "$bn_dir/$bn_before_access";
		} else {
			include "$bn_dir_default/$bn_before_access";
		}
	} elseif (file_exists ("$bn_dir_default/before_access.$ext") ) {
		include ("$bn_dir_default/before_access.$ext");
	}

# displays form (OK to delete)
# ----------------------------
	display_header ("Delete note", $header_footer);

	beginForm();
	hiddenField ("key", $key);
	if ($first != $key) {
		hiddenField ("first", $first);
	}
	if ($last != $key) {
		hiddenField ("last", $last);
	}
	hiddenField ("expnd", $expnd);
	hiddenField ("do_delete", 1);

	dspMsg(49); // Ask for confirmation

# in case of public forum, ask for password (if authenticated user is not the
# original poster)
# ----------------------------------------------------------------------------
	if (!$is_owner && ($forum["type"] == "pub") ) {
		dspMsg(41); // password
		passwordField ("password", "", 10);
		br();
	}
	print '<CENTER>';
	submitButton ('do_delete', BUTTON_DELETE);
	backButton ('', BUTTON_BACK );
	print '</CENTER><hr size=2>';
	endForm();


# displays note
# -------------
	$viewkey = $key;
	include "$inc_dir/viewnote.$ext";

# Display footer
# --------------
	display_footer ($header_footer);
?>
