<?

/*
 *	W-AGORA 4.0
 *	-----------
 *	$Id: delete_inact_users.php,v 1.10 2002/06/10 17:41:23 mdruilhe Exp $
 *	 Usage:		delete inactive users
 *	 date:		June 2000
 *	 version:	4.0.0
 *	 Author:	Marc Druilhe <mdruilhe@w-agora.com>
 *
 */

require ("init_admin.inc");

$period_units = array (
	"1" => LABEL_DAYS,
	"7" => LABEL_WEEKS,
	"30" => LABEL_MONTHS
);

# Load site/forum administration configuration
# --------------------------------------------
if (empty ($bn) ) {
	include ("$site_cfg_file");
} else {
	include ("$cfg_file");
}

# --------------------------------------------------
# check if this user is authorized to delete users
# --------------------------------------------------
if ($auth->level < ADMIN) {
	MsgForm (ERROR_MUST_BE_ADMIN_TO_REMOVE_USERS, "admin_site.$ext?site=$site&force_login=1", "", "_top");
	echo "</body></html>";
	exit;
}

if (!$silent) {
	display_header (TITLE_DELETE_INACTIVE_USERS);
}

# Users to be deleted have been selected, do the stuff
# ----------------------------------------------------
if (isset($go) && is_array($delusers)) {
	$go=0;

	reset($delusers);
	while (list(,$userid) = each ($delusers) ) {
		$ret = $db->deleteUser ($site, $userid);
		if ($ret < 0) {
			MsgForm (sprintf(ERROR_SITE_USER_DELETE, $userid, $site), "$WA_SELF?site=$site&bn=$bn", 'back');
			exit;
		}
	}
}

# Presents FORM to select the date
# --------------------------------
$period = (isset($period)) ? $period : 3;
$unit = (isset($unit)) ? $unit : 30;
$show_users = (isset($show_users)) ? $show_users : "didntlogin";

beginForm();
echo "&nbsp;&nbsp;";
radioButton ("show_users", "didntpost", $show_users, LABEL_SHOW_DIDNT_POST);
echo "<br>&nbsp;&nbsp;";
radioButton ("show_users", "didntlogin", $show_users, LABEL_SHOW_DIDNT_LOGIN);
echo "<br><br>&nbsp;";
textField ("period", $period, 2);
listBox ("unit", $period_units, $unit);
submitButton ("select", LABEL_SHOW);
?> </dd></p></form> <?

# Compute the date
# ----------------
$timeframe = $period * $unit * 24*60*60;
$date = time() - $timeframe;

# Shows selected users
# --------------------

if ($show_users == "didntpost") {
	$users = $db->getInactiveUsers($site, $date, "post");
} else {
	$users = $db->getInactiveUsers($site, $date, "login");
}
$ftdate = date ($bn_date_format, $date+($bn_tz_offset*3600));
$context = (empty($bn)) ? strtolower(COLUMN_SITE) . " '$site'" : strtolower(COLUMN_FORUM)  . " '$forum_name'";

if (is_array($users)) {
	table_header (sprintf(LABEL_DELETE_USERS,  $context,  $period , strtolower($period_units[$unit]), $ftdate));
	list_users($users, "delete_user.$ext");
	table_footer();
	beginForm();
	hiddenfield ("show_users", $show_users);
	// FJP - needed a reset to set internal pointer to first element
	reset ($users);
	while (list(,$user) = each ($users) ) {
		hiddenField ("delusers[]", $user["userid"]);
	}
	echo "<center>";
	submitButton ("go", LABEL_DELETE_THIS_USERS);
	echo "</center></form>";
} else {
	msgWarning (sprintf(LABEL_NO_DELETE_USERS,  $context,  $period , strtolower($period_units[$unit]), $ftdate));
}
?>
</BODY>
</HTML>
