<?php

/* 
 *	W-AGORA 4.0
 *	-----------
 *	$Id: delete_notes.php,v 1.18 2002/03/12 21:19:19 tbannist Exp $
 *	Usage:		Delete /edit individual note(s) in forum
 *	Author:		Marc Druilhe <mdruilhe@w-agora.com>
 */

require ("init_admin.inc");
require ("$cfg_file");

# include messages
# ----------------
	if (!empty($bn_msgs) && file_exists ("$bn_dir/$bn_msgs") ) {
		include "$bn_dir/$bn_msgs";
	} elseif (file_exists ("$bn_dir_default/msgs.$ext") ) {
		include ("$bn_dir_default/msgs.$ext");
	}

# fields definition
# -----------------
	if (!empty($bn_fields) && file_exists ("$bn_dir/$bn_fields") ) {
		include "$bn_dir/$bn_fields";
	} elseif (file_exists ("$bn_dir_default/fields.$ext") ) {
		include ("$bn_dir_default/fields.$ext");
	}

# Set core variables (managed by w-agora)
# this code is here for compatibility w/ old fields def. files (bn_var is reset)
# ------------------------------------------------------------------------------
	if (isset ($bn_var)) {
		unset ($bn_var);
	}
	$bn_var = array (
		"unixdate",		// timestamp (creation date)
		"userid",		// user ID
		"password",		// MD5 encoded password
		"filename",		// name of HTML note
		"mail_reply",	// set to "1" if replies to this note must be sent by email
		"hidden",		// set to 1 if note must be approved by the moderator
		"hits",			// hits count 
		"closed",		// closed thread (RFU)
		"ip"			// logged IP address of sender
	);

# force w-agora variables to be listed
# ------------------------------------
	reset ($bn_var);
	while ( list(, $var) = each($bn_var) ) {
		$list_var[$var] = 1;
	}

# listing outline
# ---------------
	if (!empty($bn_list_vars) && file_exists ("$bn_dir/$bn_list_vars") ) {
		include "$bn_dir/$bn_list_vars";
	} elseif (file_exists ("$bn_dir_default/list.$ext") ) {
		include ("$bn_dir_default/list.$ext");
	}

# redefine listing
# ----------------
	if (empty($bn_delete_even_first_line) ) { // even first line should not be empty if defined
		$list_var["username"] = 1;
		$list_var["subject"] = 1;

		$bn_delete_header = "<table>";
		$bn_delete_odd_first_line = "<tr><td><ul><li><INPUT TYPE='checkbox' NAME=keys[] VALUE=\$key><i>\$formated_date</i> <b>\$subject</b> (\$username) <a href='delete.$ext?bn=\$bn&key=\$key'>" . COLUMN_DELETE . "</a>&nbsp;|&nbsp;<a href='edit.$ext?bn=\$bn&key=\$key'>" . COLUMN_EDIT . "</a>";
		$bn_delete_even_first_line = $bn_delete_odd_first_line;
		$bn_delete_begin_level = "<ul>";
		$bn_delete_odd_line = "<li><INPUT TYPE='checkbox' NAME=keys[] VALUE=\$key><i>\$formated_date</i> <b>\$subject</b> (\$username) <a href='delete.$ext?bn=\$bn&key=\$key'>" . COLUMN_DELETE . "</a>&nbsp;|&nbsp;<a href='edit.$ext?bn=\$bn&key=\$key'>" . COLUMN_EDIT . "</a>";
		$bn_delete_even_line = $bn_delete_odd_line;
		$bn_delete_end_level = "</UL>";
		$bn_delete_end_thread = "</ul></td></tr>";
		$bn_delete_footer = "</table>";
	}

# Note template
# -------------
	if (!empty($bn_template) && file_exists ("$bn_dir/$bn_template") ) {
		include "$bn_dir/$bn_template";
	} elseif (file_exists ("$bn_dir_default/template.$ext") ) {
		include ("$bn_dir_default/template.$ext");
	}

	$this_forum = $db->getForum($site, $bn);
	$bn_db = $this_forum["bn_db"];
	$totalthreads = $this_forum["totalthreads"];
	$totalnotes = $this_forum["totalnotes"];

	switch ($action) {

		case "edit":
			// read note from database, exit if error
			$note = $db->getNote ($bn_db, $key);
			if ($note < 0) {
				die (msg(10));
			}

			// set all fields as global variables
			while ( list( $var, $val ) = each( $note)) {
				if (is_string ($var)) {
					$$var = kill_quotes(stripSlashes(my_br2nl(strip_smileys($val))));
				}
			}

			// Execute before_access program
			$bn_action="edit";
			if (!empty($bn_before_access)) {
				if (file_exists ("$bn_dir/$bn_before_access") ) {
					include "$bn_dir/$bn_before_access";
				} else {
					include "$bn_dir_default/$bn_before_access";
				}
			} elseif (file_exists ("$bn_dir_default/before_access.$ext") ) {
				include ("$bn_dir_default/before_access.$ext");
			}

			// Display form
			$setUserField = false;		// Don't set username and password from cookies, get it from the note
			$form_action = "update.$ext";
			$back_form="delete_notes";
			include "$inc_dir/form.$ext";
			?></body></html><?
			exit;
		break;

		case "confirm":
			display_header (msg(40, TITLE_DELETE_NOTES));
			$count = Count ($keys);
			if ($count <1) {
				MsgForm (CAPTION_SELECT_NOTES, "$WA_SELF?site=$site", 'back');
				echo "</body></html>";
				exit;
			}

			beginForm();
			hiddenField ("action", "dodelete");

			for ($i=0; $i < $count; $i++) {
				echo "<INPUT TYPE='hidden' NAME=keys[$i] VALUE='$keys[$i]'>";
			}

			echo "$count "; DspMsg(24);
			echo "<CENTER>";
			submitButton ("submit", LABEL_CONFIRM);
			backButton ("back", msg(36) );
			?></CENTER><?
			endForm();
			?></body></html><?
			exit;
		break;

		case "dodelete":
			$count = Count ($keys);
			if ($count <1) {
				MsgForm (CAPTION_SELECT_NOTES, "$WA_SELF?site=$site", 'back');
				echo "</body></html>";
				exit;
			}

			// Execute before_access program
			$bn_action="delete";
			if (!empty($bn_before_access)) {
				if (file_exists ("$bn_dir/$bn_before_access") ) {
					include "$bn_dir/$bn_before_access";
				} else {
					include "$bn_dir_default/$bn_before_access";
				}
			} elseif (file_exists ("$bn_dir_default/before_access.$ext") ) {
				include ("$bn_dir_default/before_access.$ext");
			}

			// delete selected notes
			$ret = $db->mDeleteNotes ($bn_db, $keys, $bn_dir_notes);
			if ($ret < 0) {
				MsgForm (Msg (13), "$WA_SELF", 'back');
				echo "</body></html>";
				exit;
			}

			// start search indexation
			if ($bn_search && ($bn_doc_type == "static") && ($bn_search_engine != "none") ) {
				include "$inc_dir/$bn_search_engine.$ext";
				$search->indexNotes();
			}
		break;

		default:
		break;

	}


# FORM has not been sent Displays notes to be deleted
# ---------------------------------------------------

	display_header (msg(40, "<h2 align='center'>" . LABEL_DELETE_THIS . "\$msg[0]</h2>"));
	$expnd="all";

	if ($totalnotes == 0) {
		msgWarning (msg(16));
		exit;
	}

	$ret = $db->listThreads ($bn_db, $first, $last, "", 1, $bn_maxthreads);
	if (!is_array ($ret) || ($ret < 0)) {
		msgWarning (msg(6));
		exit;
	}

	table_header (CAPTION_SELECT_NOTES_DELETED);
	beginForm();
	hiddenField ("action", "confirm");

	$last= $ret["last"];
	$first = $ret["first"];
	$l=addSlashes(stripSlashes($bn_delete_header));
	eval ("echo stripSlashes(\"$l\");");

	$db->getChild (0, "delete"); 

	$l=addSlashes(stripSlashes($bn_delete_footer));
	eval ("echo stripSlashes(\"$l\");");

	if (!isset($ret["prev"])) $ret["prev"] = 0;
	if (!isset($ret["next"])) $ret["next"] = 0;

	if ($ret["prev"] || $ret["next"]) {
		echo "<HR><CENTER><TABLE><TR><TD width='60'>";
		if ($ret["prev"]) {
			displayURL ("$WA_SELF?bn=$bn&site=$site&last=$first", "", $msg[79], msg(65) );
		}
		echo "</TD><TD width='60'>";
		if ($ret["next"]) {
			displayURL ("$WA_SELF?bn=$bn&site=$site&first=$last", "", $msg[80], msg(66) );
		}
		echo "</TD></TR></TABLE></CENTER>\n";
	}

	echo "<br><br><CENTER>";
	submitButton ("submit", msg(42) );
	resetButton ("reset", msg(23) );
	table_footer ();
	echo "</CENTER></FORM>";

?>
</BODY>
</HTML>
