<?php

/*
 *	W-AGORA 4.0
 *	-----------
 *	$Id: delete_user.php,v 1.10 2002/03/10 22:13:53 mdruilhe Exp $
 *	Usage:		delete a user 
 *	Author:		Marc Druilhe <mdruilhe@w-agora.com>
 */

require ("init_admin.inc");

# Load site administration configuration
# --------------------------------------
require ("$site_cfg_file");	
if (empty($bn_msgs) ) {
	include ("$bn_dir_default/site_msgs.$ext");
} else {
	include "$bn_dir/$bn_msgs";
}

display_header (TITLE_DELETE_USER);

# Display form to select a user
# -----------------------------
function form_user ($title, $formuser) {
	global $site, $WA_SELF;
	
	table_header ($title, 400);
	beginForm($WA_SELF, "get");
	echo "<TABLE BORDER=0 WIDTH='100%'>";
	echo "<TR><TD VALIGN='middle' class=label>" . LABEL_DELETE_TYPE_USER_ID . "</TD></tr><tr><TD align='center' nowrap>";
	textField ("formuser", $formuser, 20);
	submitButton ("", LABEL_SEARCH);
	echo "</TD></TR></TABLE></form>";
	table_footer();
	echo "</body></html>";
	exit;
}

# ---------------------------------------
# Select a user if none has been selected
# ---------------------------------------
if (empty($userid)) {
	if (isset($formuser)) {
		// form has been filled : search users
		$sort = (empty($sort)) ? "userid" : $sort;
		$users = $db->getUsers($site, "", "", $formuser, "", $sort);
		if (is_array($users)) {
			if (count($users) > 1) {
				// More than one user => list users
				if ($first == "")	{
					$first = 0;
					$last = $first + $nb_users_list;
				}
				table_header (LABEL_USER_DELETE . $site);
				list_users($users, "", $first, $last, $sort);
				table_footer();
				?></body></html><?
				exit;
			} else {
				// One user returned => select this user
				$user = reset($users);
				$userid = $user["userid"];
			}
		} else {
			// No user returned => display form
			form_user (ERROR_NO_USER_MATCHING . " : $formuser", $formuser);
			exit;
		}
	} else {
		// No user selected => display form
		form_user (LABEL_CHOOSE_USER_DELETE, "");
		exit;
	}
}


# -----------------------------------------
# userid has been selected => get this user
# -----------------------------------------
$userid = stripslashes($userid);
$user = $db->getUser($site, $userid);
if (!is_array($user)) {
	MsgForm (sprintf(ERROR_NO_MATCHING_USER, $userid), "$WA_SELF?site=$site", 'back');
	echo "</body></html>";
	exit;
}

# -----------------------------------------
# check if authorized to delete this user
# -----------------------------------------
if ($user["userid"] == "admin") {
	MsgForm (str_replace("{USER}", $userid, ERROR_NO_USER_DELETE_PERMISSION), "$WA_SELF?site=$site", 'back');
	echo "</body></html>";
	exit;
}

switch ($user["userpriv"]) {
	case "root":
		if ($auth->userid!="admin") {
			MsgForm (str_replace("{USER}", $userid, ERROR_NO_USER_DELETE_PERMISSION), "$WA_SELF?site=$site", 'back');
			echo "</body></html>";
			exit;
		}
	case "admin":
		if ($auth->level < ROOT) {
			MsgForm (str_replace("{USER}", $userid, ERROR_NO_USER_DELETE_PERMISSION), "$WA_SELF?site=$site", 'back');
			echo "</body></html>";
			exit;
		}
	break;
	case "moder":
		if ($auth->level < ADMIN) {
			MsgForm (str_replace("{USER}", $userid, ERROR_NO_USER_DELETE_PERMISSION), "$WA_SELF?site=$site", 'back');
			echo "</body></html>";
			exit;
		}
	break;
}

# gets all forums in this site
# ----------------------------
	$forums = $db->listForums ($site);

# Check if user to be deleted has access to forums not owned by the logged user
# -----------------------------------------------------------------------------
	if (is_array ($forums) && ($auth->type == "moder")) {

# gets all forums owned by the moderator
# --------------------------------------
		$my_forums = $db->listForums ($site, $auth->userid);

		// for each forum in this site
		reset ($forums);
		while (list($name) = each ($forums) ) {
			if (!is_array($my_forums[$name])) {
				// this forum is not owned by this user
				$forum = $forums[$name]["bn_name"];
# get privileges for this userid on this forum
				$privs = $db->getPrivs($site, $forum, $userid);
				if (is_array ($privs) ) {
					MsgForm (sprintf(ERROR_NO_REMOVE_PERMISSION,$userid, $name), "$WA_SELF?site=$site", 'back');
					echo "</body></html>";
					exit;
				}
			}
		}
	}


# ------------------------------------------------------
# If FORM have been submitted -> delete user from database
# ------------------------------------------------------
if (isset($go)) {

	$go=0;

	$ret = $db->deleteUser ("$site", $userid);
	if ($ret < 0) {
		MsgForm (sprintf(ERROR_SITE_USER_DELETE,$userid,$site), "$WA_SELF?site=$site&userid=$userid", 'back');
		exit;
	}


# Display Success message (return to same page)
# ---------------------------------------------
	MsgForm (LABEL_USER_CONFIRM_DELETE, "$WA_SELF?site=$site");
	exit;
} // End $go

#  display FORM
#  ------------

#  evaluate all fields from $user
#  ------------------------------
	while ( list( $var, $val ) = each( $user)) {
		if (is_string ($var)) {
			$$var = stripSlashes($val);
		}
	}

	echo "<CENTER>";
	beginForm($WA_SELF, "get");
	hiddenField("userid", $userid);
	hiddenField("go", 1);
	table_header (sprintf(LABEL_SITE_USER_DELETE, $userid, $site), "90%");
?>

 <TABLE BORDER="0" WIDTH="100%">
  <CAPTION><B><?echo CAPTION_USER_DELETE ?></B></CAPTION>
  <TR>
   <TD WIDTH="30%" ALIGN="RIGHT" VALIGN="MIDDLE" class=label><?echo COLUMN_USER_NAME ?>: </TD>
   <TD class=label><font color="blue"><? echo $username ?></font></TD>
  </TR>
  <TR>
   <TD WIDTH="30%" ALIGN="RIGHT" VALIGN="MIDDLE" class=label><?echo COLUMN_USER_EMAIL ?>: </TD>
   <TD class=label><font color="blue"><? echo $useraddress ?></font></TD>
  </TR>
  <TR>
   <TD WIDTH="30%" ALIGN="RIGHT" VALIGN="MIDDLE" class=label><?echo COLUMN_USER_WEBPAGE ?>: </TD>
   <TD class=label><font color="blue"><? echo $homepage ?></font></TD>
  </TR>
  <TR>
   <TD WIDTH="30%" ALIGN="RIGHT" VALIGN="TOP" class=label><?echo COLUMN_USER_DESCRIPTION ?><em>: </TD>
   <TD class=label><font color="blue"><? echo $details ?></font></TD>
  </TR>
  <TR>
   <TD WIDTH="30%" ALIGN="RIGHT" VALIGN="TOP" class=label><?echo COLUMN_USER_LAST_LOGIN ?>: </TD>
   <TD class=label><?php print ( ($lastlogin >0 ) ? date($bn_date_format , $lastlogin + ($bn_tz_offset*3600)) : LABEL_NEVER ); ?></TD>
	</tr>
  <TR>
   <TD WIDTH="30%" ALIGN="RIGHT" VALIGN="TOP" class=label><?echo CAPTION_USER_PRIVILEGE ?>: </TD>
   <TD class=label><? echo $user_privs[$userpriv] ?></TD>
  </TR>
 </TABLE>

<?

# Now display user privileges on forums
# -------------------------------------
	if ($user["userpriv"]=="user" || $user["userpriv"]=="moder") {
		$forums = $db->listForums ($site);

		if (is_array ($forums)) {
			echo "<p><TABLE border=0 cellspacing=1 cellpadding=3 WIDTH='100%'>";
			caption (CAPTION_USER_FORUM_PRIVILEGES, "b");
			echo "<tr bgcolor='#cccccc'><td class=label>" . COLUMN_FORUM . "</td><td class=label>" . COLUMN_TITLE . "</td><td class=label>" . COLUMN_CAN_LIST . "</td>
				<td class=label>" . COLUMN_CAN_READ . "</td><td class=label>" . COLUMN_CAN_WRITE . "</td><td class=label>" . LABEL_MODERATOR . "</td><td class=label>" . LABEL_ACTIVE . "</td></tr>";

# for each owned forum
# ---------------------
			reset ($forums);
			$list = false;
			while (list($name) = each ($forums) ) {
				$topic = $forums[$name]["bn_title"];
				$forum = $forums[$name]["bn_name"];
# get privileges for this user on this forum
				$privs = $db->getPrivs($site, $forum, $userid);
				if (is_array ($privs) ) {
# if the selected user have access to this forum, then display privileges
					printf ("<tr align=center><td align=left class=label>%s</td><td align=left class=label>%s</td><td class=label>%s</td><td class=label>%s</td><td class=label>%s</td><td class=label>%s</td><td class=label>%s</td></tr>",
						$name, $topic,
						$privs["listpriv"]==1 ? LABEL_YES : "&nbsp;",
						$privs["readpriv"]==1 ? LABEL_YES : "&nbsp;",
						$privs["writepriv"]==1 ? LABEL_YES : "&nbsp;",
						$privs["modpriv"]==1 ? LABEL_YES : LABEL_NO,
						$privs["state"]==1 ? LABEL_YES : LABEL_NO);
					$list=true;
				}
			}
			if (!$list) {
				print ("<tr align=center><td colspan=7><b>" . LABEL_USER_NO_ACCESS . "</b></td></tr>");
			}
			echo " </TABLE>";
		}
	}

	echo "<br><center>";
	submitButton("", LABEL_DELETE_THIS_USER);
	echo "</center>";
	table_footer();
?>
</CENTER>
</FORM>
</BODY>
</HTML>
