<?php

/*
 *	W-AGORA 4.0
 *	-----------
 *	$Id: edit.php,v 1.10 2002/05/15 13:33:11 mdruilhe Exp $
 *	Usage:		Display Update form
 *	Author:		Marc Druilhe <mdruilhe@w-agora.com>
 *
 */	

# Initialization stuff
# --------------------
	$bn_action="edit";
	$bn_action_mode="W";
	$popup=1;
	require ("init.inc");

	// Some installations (multimania.fr..) seems to lose/unset $key
	if (isset ($HTTP_POST_VARS['key'])) {
		$key = $HTTP_POST_VARS['key'];
	} elseif (isset ($HTTP_GET_VARS['key'])) {
		$key = $HTTP_GET_VARS['key'];
	}

# if note to edit is not defined then return to the list
# ------------------------------------------------------
	if (empty($key)) {
		display_header (LABEL_EDIT_MESSAGE, $header_footer);
		MsgForm (msg(3), "list.$ext", LABEL_CLOSE);
		display_footer ($header_footer);
	}

# read note from database, exit if error
# --------------------------------------
	$note = $db->getNote ($bn_db, $key);
	if ($note < 0) {
		display_header (LABEL_EDIT_MESSAGE, $header_footer);
		MsgForm (Msg(10), "list.$ext", LABEL_CLOSE);
		display_footer ($header_footer);
	}

# set all fields as global variables
# ----------------------------------
	while ( list( $var, $val ) = each( $note)) {
		if (is_string ($var)) {
			if ($bn_html_var[$var]) {
				if ($bn_use_smileys) {
					$val = strip_smileys($val);
				}
				if ($bn_auto_url) {
					$val = strip_url($val);
				}
			}
			$$var = kill_quotes(stripSlashes(my_br2nl($val)));
		}
	}

# If thread is closed : only moderator can edit it 
# ------------------------------------------------
	if (($note["closed"]==1) && !$is_moderator) {
		display_header ("Post", $header_footer);
		msgForm (msg(140, LABEL_THREAD_ALREADY_CLOSED), "view.$ext?bn=$bn&key=$key", LABEL_CLOSE);
		display_footer ($header_footer);
	}

# If this is not a public forum (authenticated user) then we check that the user
# is the original poster of this note or that he is a moderator
# ----------------------------------------------------------------------------
	if ($is_moderator) {
		$is_owner=true;
	} else {
		if ($is_authenticated) {		// authenticated user but not a moderator
			if ($auth->user["userid"] == $note["userid"]) {
				$is_owner = true;
			} else {
				MsgForm (msg(48), "view.$ext?key=$key", LABEL_CLOSE); // access forbidden
				exit;
			}
		} else {
			$is_owner = false;
		}
	} 

#	Exit with error if this note is hidden
# --------------------------------------
	if (!$is_owner && ($note["$hidden"] == "1") ) {
		display_header ("forbidden", $header_footer);
		MsgForm (Msg(48), "list.$ext", ""); // access forbidden to this page
		display_footer ($header_footer);
	}

# Check that the "allow modify" option is set on this forum
# If not set then only the moderator of this board can edit a message
# -------------------------------------------------------------------
	if (!$bn_modify && !$is_moderator) {
		display_header (LABEL_EDIT_MESSAGE, $header_footer);
		MsgForm (msg(48), "view.$ext?key=$key", LABEL_CLOSE);
		display_footer ($header_footer);
	}

	// DELETE
	$delete_url = "";
	if ($bn_delete) {
		$delete_url = "delete.$ext?bn=$bn&key=$key&first=$first&last=$last&sort=$sort&where=$where&expnd=$thread";
		$delete_text = msg(42, "delete");
		$delete_link = anchor ($delete_url, "", $delete_text, LABEL_DELETE_THIS_MESSAGE);
	}

	// CLOSE
	$close_url = "";
	if ($is_moderator) {
		$close_url = "close.$ext?bn=$bn&key=$key&first=$first&last=$last&sort=$sort&where=$where&expnd=$thread";
		$close_text = msg(141, LABEL_CLOSE_OPEN_THREAD);
		$close_link = anchor ($close_url, "", $close_text);
	}

# Execute before_access program
# -----------------------------
	if (!empty($bn_before_access)) {
		if (file_exists ("$bn_dir/$bn_before_access") ) {
			include "$bn_dir/$bn_before_access";
		} else {
			include "$bn_dir_default/$bn_before_access";
		}
	} elseif (file_exists ("$bn_dir_default/before_access.$ext") ) {
		include ("$bn_dir_default/before_access.$ext");
	}

# Display form
# ------------
	display_header (LABEL_EDIT_MESSAGE, $header_footer);

	$setUserField = false;		// Don't set username and password from cookies, get it from the note
	$form_action = "update.$ext";
	$back_form="edit";

	include "$inc_dir/form.$ext";

# Display footer
# --------------
	display_footer ($header_footer);
?>
