<?php

/*
 *	W-AGORA 4.0
 *	-----------
 *	$Id: edit_site.php,v 1.10 2002/06/10 17:41:23 mdruilhe Exp $
 *	Usage:		Edit  parameters of a forum
 *	Author:		Marc Druilhe <mdruilhe@w-agora.net>
 *
 */

# main agora site cannot be edited
# --------------------------------
if (isset($site) && ($site=="agora") ) {
	unset ($site);
}

require ("init_admin.inc");

# read site administration configuration
# --------------------------------------
require ("$site_cfg_file");	
require ("$bn_dir/site_fields.$ext");

display_header (TITLE_SITE_EDIT);

# --------------------------------------------------
# check if this user is authorized to edit a site
# --------------------------------------------------
if ($auth->level < ADMIN) {
	MsgForm (ERROR_NO_ADMIN, "admin_site.$ext?site=$site&force_login=1", "", "_top");
	echo "</body></html>";
	exit;
}

# ---------------------------------------------------------------------------------------
# Open a DB connection for the main agora database
#		$db = site database
#		$bn_access = site DB access
#		$agora_access = agora access 
#		$agora_db = agora "system" database
# ---------------------------------------------------------------------------------------
$agora_dbparam = getDBaccess("$cfg_dir/site_agora.$ext");
$agora_access = $agora_dbparam["bn_access"];
$agora_dbname = $agora_dbparam["dbname"];
$agora_dbhost = $agora_dbparam["dbhost"];
$agora_dbport = $agora_dbparam["dbport"];
$agora_dbuser = $agora_dbparam["dbuser"];
$agora_dbpassword = $agora_dbparam["dbpassword"];
$agora_dbadmuser = $agora_dbparam["dbadmuser"];
$agora_dbadmpassword = $agora_dbparam["dbadmpassword"];

if ($agora_access != $bn_access) {
	include ("$inc_dir/$agora_access.$ext");
}

$agora_dbclass = "${agora_access}_access";
$agora_db = new $agora_dbclass;

$db->closeDB();
$ret = $agora_db->openDB($agora_dbhost, $agora_dbport, $agora_dbadmuser, $agora_dbadmpassword, $agora_dbname, "agora");

# --------------------------------------------
# get site infos
# --------------------------------------------
$siteinfo = $agora_db->getForum("agora", $site);
if (!is_array($siteinfo)) {
	MsgForm (str_replace("{SITE}", $site, ERROR_NO_READ_SITE_PROPERTIES), "$WA_SELF?site=$site", "back");
	echo "</body></html>";
	exit;
}

# -----------------------------------------------------
#  Creation form have been submitted => do installation
# -----------------------------------------------------
if (isset($go)) {

	$go=0;

#  Check required fields
# ----------------------
	if (empty ($bn_title)) {
		msgForm (FORM_NO_SITE, "$WA_SELF", "back");
	}

#  update this site in the sites table (agora)
#  -------------------------------------------
	for (reset ($bn_var); $form_field=current($bn_var); next($bn_var)) {
		if (isset($$form_field)) {
			$$field=stripSlashes(my_nl2br($$form_field));
			$siteinfo[$form_field]=$$field;
			$update_fields[$form_field]=$$field;
		}
	}

	$ret = $agora_db->updateForum ("agora", $site, $update_fields);
	if ($ret < 0) {
		msgForm (str_replace("{SITE}", $site, ERROR_NO_WRITE_SITE_PROPERTIES), "$WA_SELF?site=$site&bn=$bn", "back");
		exit;
	}

# Gets owner infos (used later)
# -----------------------------
	if (!empty($owner) ) {
		$owner_record = $agora_db->getUser("agora", $owner);
	}

# Re-open database connection into this site
# ---------------------------------------
	$agora_db->closeDB();
	$ret = $db->openDB($site_dbhost, $site_dbport, $site_dbadmuser, $site_dbadmpassword, $site_dbname, $site);

# Update entry in the site table (used as main category)
# ------------------------------------------------------
	$update_fields["newest"] = $now;	// used as update time
	$ret = $db->updateTable($site, $update_fields, "cle=0");
	$cnt = $db->affected_rows();
	if ( ($ret==0) && ($db->affected_rows()!=1) ) {
		$update_fields["parent"] = 0;
		$update_fields["thread"] = 0;
		$update_fields["childs"] = 0;
		$update_fields["unixdate"] = $now;
		$update_fields["cle"] = 0;
		$update_fields["category"] = 1;
		$update_fields["rank"] = 1;
		$update_fields["bn_name"] = $site;
		$update_fields["bn_db"] = $site;
		$ret = $db->insertRow($site, $update_fields);
	}

# Update or insert owner site users table
# ---------------------------------------
	if (is_array($owner_record) ) {
		$u = $db->getUser($site, $owner);
		if (is_array ($u)) {
			$db->updateUser ($site, $owner, $owner_record);
		} else {
			$db->insertUser ($site, $owner_record);
		}
	}

# Reopen system database connection
# ---------------------------------
	$db->closeDB();
	$ret = $agora_db->openDB($agora_dbhost, $agora_dbport, $agora_dbadmuser, $agora_dbadmpassword, $agora_dbname, "agora");

} // End $go

#  evaluate all fields and display form
#  ------------------------------------

while ( list( $var, $val ) = each( $siteinfo)) {
	if (is_string ($var)) {
		$$var = kill_quotes(stripSlashes(my_br2nl($val)));
	}
}

beginForm ();
table_header(LABEL_SITE_EDITING . "$site");
?>
 <TABLE BORDER="0" WIDTH="100%">
  <CAPTION><B><?echo LABEL_SITE_PROPERTIES ?></B></CAPTION>
  <TR>
   <TD WIDTH="40%" ALIGN="RIGHT" VALIGN="MIDDLE"><strong><?echo COLUMN_TITLE?>:</strong></TD>
   <TD><?textField ("bn_title", $bn_title, 40, 255);?></TD>
  </TR>
  <TR>
   <TD WIDTH="40%" ALIGN="RIGHT" VALIGN="TOP"><strong><?echo COLUMN_DESCRIPTION ?>:</strong></TD>
   <TD><?textArea ("descr", $descr, 3, 40);?></TD>
  </TR>
  <TR>
   <TD WIDTH="40%" ALIGN="RIGHT" VALIGN="TOP"><strong><?echo COLUMN_ORDER ?> :</strong></TD>
   <TD><?textField ("rank", $rank, 3);?></TD>
  </TR>
 </TABLE>
 <BR>
 <TABLE BORDER="0" CELLPADDING="2" WIDTH="100%">
<?php
	$users = $agora_db->getUsers ("agora", "", "admin,root");
	if (is_array($users)) {
# fill in combo box with all site administrators
# ----------------------------------------------
		reset($users);
		while (list(,$user) = each ($users) ) {
			$userid = $user["userid"];
			$admins[$userid] = $user["username"];
		}
		echo "<TR><TD ALIGN='RIGHT' colspan=2><strong>" . LABEL_CHANGE_SITE_ADMINISTRATOR . "</strong> :</TD>";
		echo "<TD colspan=2>";
		listBox ("owner", $admins, $owner);
		echo "</TD></TR>";
	}
	echo "</TABLE>\n";
?>
<br>
<CENTER>
 <INPUT NAME="go" TYPE="submit" VALUE="<?echo LABEL_SAVE?>">
 <INPUT TYPE="reset"  VALUE="<?echo LABEL_RESET?>">
</CENTER>
<?php	table_footer(); ?>
</FORM>
</BODY>
</HTML>
