<?php

/*
 *	W-AGORA 4.0
 *	-----------
 *	$Id: edit_user.php,v 1.24 2002/06/10 17:41:23 mdruilhe Exp $
 *	Usage:		Edit a user 
 *	Author:		Marc Druilhe <mdruilhe@w-agora.com>
 */

require ("init_admin.inc");

if ( empty($bn)) {
	display_header (str_replace("{SITE}", $site, TITLE_SITE_USER_EDIT));
} else {
	$name = ereg_replace ("^${site}_", "", $bn);
	display_header (str_replace("{FORUM}", $name, TITLE_FORUM_USER_EDIT));
}
# Load site administration configuration
# --------------------------------------
require ("$site_cfg_file");	
if (empty($bn_msgs) ) {
	include ("$bn_dir_default/site_msgs.$ext");
} else {
	include "$bn_dir/$bn_msgs";
}

# Display form to select a user
# -----------------------------
function form_user ($title, $formuser) {
	global $site, $bn, $WA_SELF;

	table_header ($title, 400);
	beginForm($WA_SELF, "get");
	echo "<TABLE BORDER=0 WIDTH='100%'>";
	echo "<TR><TD VALIGN='middle' class=label>" . LABEL_TYPE_USERID . ": </TD></tr><tr><TD align='center' nowrap>";
	textField ("formuser", $formuser, 20);
	submitButton ("", LABEL_SEARCH);
	echo "</TD></TR></TABLE></form>";
	table_footer();
	echo "</body></html>";
	exit;
}

# ---------------------------------------
# Select a user if none has been selected
# ---------------------------------------
if (empty($userid)) {
	$sort = (empty($sort) ) ? "userid" : $sort;
	if ($first == "")	{
		$first = 0;
		$last = $first + $nb_users_list;
	}
	if (!empty($bn) && isset($state)) {
# list all users in a given state :
# ---------------------------------
		beginForm();
		echo "<center>" . LABEL_SHOW_USERS ;
		$user_states["all"]=LABEL_ALL;
		listBox ("state", $user_states, $state);
		submitButton ("", LABEL_GO);
		echo "</center></form>";
		$users = $db->getUsers($site, "$bn", "", "", ($state=="all") ? "" : $state, $sort);
		if (is_array($users)) {
			table_header (LABEL_REGISTERED_USERS . " $bn (" . LABEL_STATUS . " : <b>$user_states[$state]</b>)");
			list_users($users, '', $first, $last, $sort);
			table_footer();
		} else {
			$context =  ($state == "all") ? "" : LABEL_WITH_STATUS . "<b>$user_states[$state]</b>";
			msgWarning (ERROR_NO_REGISTERED_USERS . "<b>$forum_name</b> $context");
		}
		?></body></html><?
		exit;

	} elseif (isset($formuser)) {
# form has been filled : search matching users 
# --------------------------------------------
		$users = $db->getUsers($site, "$bn", "", $formuser, $state, $sort);
		if (is_array($users)) {
			if (count($users) > 1) {
				// More than one user => list users
				table_header (CAPTION_USER_SITE_SELECT .  $site);
				list_users($users, '', $first, $last, $sort);
				table_footer();
				?></body></html><?
				exit;
			} else {
				// One user returned => select this user
				$user = reset($users);
				$userid = $user["userid"];
			}
		} else {
			// No user returned => display form
			if (empty($formuser)) {
				msgForm (str_replace("{SITE}", $site , ERROR_NO_SITE_USERS), "create_user.${ext}?site=$site");
			} else {
				form_user (ERROR_NO_MATCHING_USERS . " : $formuser", $formuser);
				
			}
			exit;
		}
	} else {
		// No user selected => display form
		form_user (CAPTION_USER_SELECT, "");
		exit;
	}
}

# -----------------------------------------
# userid has been selected => get this user
# -----------------------------------------
if (!is_array($user)) {
	$user = $db->getUser($site, stripslashes($userid) );
	if (!is_array($user)) {
		MsgForm (sprintf(ERROR_NO_MATCHING_USER, $userid), "$WA_SELF?site=$site", 'back');
		echo "</body></html>";
		exit;
	}
}

# -----------------------------------------
# check if authorized to modify this user
# -----------------------------------------
switch ($user["userpriv"]) {
	case "root":
		if ($auth->userid!="admin") {
			MsgForm (str_replace("{USER}", $userid, ERROR_NO_USER_EDIT_PERMISSION), "$WA_SELF?site=$site", 'back');
			echo "</body></html>";
			exit;
		}
	case "admin":
		if ($auth->level < ROOT) {
			MsgForm (str_replace("{USER}", $userid, ERROR_NO_USER_EDIT_PERMISSION), "$WA_SELF?site=$site", 'back');
			echo "</body></html>";
			exit;
		}
	break;
	case "moder":
		if ($auth->level < ADMIN) {
			MsgForm (str_replace("{USER}", $userid, ERROR_NO_USER_EDIT_PERMISSION), "$WA_SELF?site=$site", 'back');
			echo "</body></html>";
			exit;
		}
	break;
	default:
		if ($auth->level < MODER) {
			MsgForm (str_replace("{USER}", $userid, ERROR_NO_USER_EDIT_PERMISSION), "$WA_SELF?site=$site", 'back');
			echo "</body></html>";
			exit;
		}
	break;
}

# -------------------------------------------------------------------
# gets all forums in this site for which the logged user is moderator
# -------------------------------------------------------------------

$forums = array();
if ($auth->level > MODER) {
#	get all forums if user is administrator
	$forums = $db->listForums ($site);
} else {
	$forums = $db->listForums ($site, $auth->userid);
}

# We list only forums that needs registration (private or restricted)
# If selected user is moderator then show all forums so that we can grant him moderation privilege
# ------------------------------------------------------------------------------------------------
if ( is_array($forums) ) {
	reset($forums);
	while (list($name) = each ($forums) ) {
		if ( ($forums[$name]["type"] != "rest") && ($forums[$name]["type"] != "priv") ) {
			if ($user["userpriv"] != 'moder') {
			    unset ($forums[$name]);
			}
		}
	}
}

# ------------------------------------------------------
# If FORM have been submitted -> update user in database
# ------------------------------------------------------
if (isset($go)) {

	$go=0;
	echo "<HEAD><TITLE>" . ADMINISTRATION_TITLE . " - " . TITLE_EDIT_USER . "</TITLE></HEAD>\n<BODY>\n";

#	-------------------------
#	Check for required fields
#	-------------------------
	include "$tmpl_dir/admin/user_fields.$ext";
	if (is_array ($bn_bind_var)) {
		reset($bn_bind_var);
		while (list($field, $required) = each($bn_bind_var)) {
			if ($required && !$$field) {
				$mess = "$field : " . Msg(5);
				MsgForm ("$mess", "$WA_SELF?site=$site&userid=".urlencode($userid), 'back');
				exit;
			}
		}
	}

# Check that email address is not already used
# --------------------------------------------
	if ($useraddress!=$user["useraddress"]) {
		$tmp = $db->getUser($site, $useraddress, "useraddress");
		if (is_array($tmp)) {
			msgForm (msg(177, str_replace("{EMAIL}", $useraddress, ERROR_EMAIL_EXISTS)), "$WA_SELF", 'back');
			echo "</body></html>";
			exit;
		}
	}

# ------------------------------------------------------------------------
# Create/edit user->forums relation(s) (for each forum) in userforum table
# ------------------------------------------------------------------------

# For each forum in this site
# ---------------------------
	if (is_array ($forums)) {
		reset ($forums);
		while (list($name) = each ($forums) ) {
			$forum = $forums[$name]["bn_name"];

# if moderator privilege has been revoked for this user
#   then we check that he was not owner of this forum
# ----------------------------------------------------------
			if (($userpriv!="moder") && ($forums[$name]["owner"] == $userid)) {
				$forums[$name]["owner"] = "admin";
				$ret = $db->updateForum ($site, $forum, $forums[$name]);
			}

# if user privs have been set on this forum
# -----------------------------------------
			if (is_array($$forum)) {
				// initialize default values
				$uf_fields["listpriv"] = 0;
				$uf_fields["readpriv"] = 0;
				$uf_fields["writepriv"] = 0;
				$uf_fields["modpriv"] = 0;
				$uf_fields["state"] = 0;

# gets all privileges set on this forum for this user
#-----------------------------------------------------
				while ( list($priv, $val) = each($$forum) ) {
					$uf_fields[$priv] = $val;
				}

# if moderator privilege has been set over this forum
# we check he has moderator privilege then force read/write access
# ---------------------------------------------------------------
				if ($uf_fields["modpriv"] == 1) {
					// check he is a moderator
					if ($userpriv=="moder") {
						// force all privileges
						$uf_fields["listpriv"]=1;
						$uf_fields["readpriv"]=1;
						$uf_fields["writepriv"]=1;
# If moderator has been choosen, set forum's owner if not already set
# ------------------------------------------------------------------
						if (empty($forums[$name]["owner"]) ) {
							$forums[$name]["owner"] = $userid;
							$ret = $db->updateForum ($site, $forum, $forums[$name]);
							if ($ret < 0) {
								MsgForm (sprintf(ERROR_NO_OWNER_UPDATE,$forum, $site), "$WA_SELF?site=$site", 'back');
								exit;
							}
						}
					} else {
						$uf_fields["modpriv"] = 0;
					}
				}

# ---------------------------------------
# Now we update privileges into userforum
# ---------------------------------------
				$ret = 0;
				if ($uf_fields["state"]=="D") {
					// remove access for this user
					$ret = $db->deletePrivs ("$site", $forum, $userid);
				} elseif ( ($userpriv!="admin") && ($userpriv!="root") ) {
					$ret = $db->updatePrivs ("$site", $forum, $userid, $uf_fields);
				}

				if ($ret < 0) {
					MsgForm ("Could not update privileges for user $userid over forum $forum", "$WA_SELF?site=$site&userid=$userid", "back");
					exit;
				}
			}
		}

# Now we check if new privs have been selected for a new forum
# We don't insert entry if user has admin privilege
# ---------------------------------------------------------
		if (!empty($new_forum) && ($new_forum!="none") && ($userpriv!="admin")  && ($userpriv!="root")) {
			// initialize default values
			$uf_fields["unixdate"]=$unixdate;
			$uf_fields["userid"]=$userid;
			$uf_fields["bn_name"]=$new_forum;
			$uf_fields["listpriv"] = 0;
			$uf_fields["readpriv"] = 0;
			$uf_fields["writepriv"] = 0;
			$uf_fields["modpriv"] = 0;
			$uf_fields["totalpost"]=0;
			$uf_fields["lastpost"]=0;
			$uf_fields["state"] = 0;
			while ( list($priv, $val) = each($new_privs) ) {
				$uf_fields[$priv] = $val;
			}
# moderator can also read, write, list => force all privileges
# ------------------------------------------------------------
			if ($uf_fields["modpriv"] == 1) {
				// check he is a moderator
				if ($userpriv=="moder") {
					// force all privileges
					$uf_fields["listpriv"]=1;
					$uf_fields["readpriv"]=1;
					$uf_fields["writepriv"]=1;
# If moderator has been choosen, set forum's owner if not already set
# ------------------------------------------------------------------
					$forum_fields = $db->getForum ($site, $new_forum);
					if (empty($forum_fields["owner"]) ) {
						$forum_fields["owner"] = $userid;
						$ret = $db->updateForum ($site, $new_forum, $forum_fields);
						if ($ret < 0) {
							MsgForm (sprintf(ERROR_NO_OWNER_UPDATE,$forum, $site), "$WA_SELF?site=$site", 'back');
							exit;
						}
					}
				} else {
					// user is not a moderator
					$uf_fields["modpriv"] = 0;
				}
			}

# insert into userforum
# ---------------------
			$ret = $db->insertPrivs ($site, $new_forum, $userid, $uf_fields);
			if ($ret < 0) {
				MsgForm (sprintf(ERROR_NO_ADD_PRIVILEGES, $userid,$new_forum), "$WA_SELF?site=$site&userid=$userid", 'back');
				exit;
			}
		}
	}

#  Now update this user in the users table
#  ---------------------------------------
	for (reset ($bn_var); $form_field=current($bn_var); next($bn_var)) {
		if (isset($$form_field)) {
			$$field=stripSlashes($$form_field);
			$user[$form_field]=$$field;
		}
	}

	$ret = $db->updateUser ("$site", $userid, $user);

	if ($ret < 0) {
		MsgForm (str_replace("{USER}", $userid, str_replace("{SITE}", $site, ERROR_NO_SITE_USER_UPDATE)), "$WA_SELF?site=$site&userid=$userid", 'back');
		exit;
	}


# If new user has administrator privilege =>  insert into main database
# ---------------------------------------------------------------------
	if ( ($userpriv == "admin" || $userpriv == "root") ) {

		$agora_dbparam = getDBaccess("$cfg_dir/site_agora.$ext");
		$agora_access = $agora_dbparam["bn_access"];
		$agora_dbname = $agora_dbparam["dbname"];
		$agora_dbhost = $agora_dbparam["dbhost"];
		$agora_dbport = $agora_dbparam["dbport"];
		$agora_dbuser = $agora_dbparam["dbuser"];
		$agora_dbpassword = $agora_dbparam["dbpassword"];

		if ($site_access != $agora_access) {
			include ("$inc_dir/$agora_access.$ext");
		}
		$agora_db_class = "${agora_access}_access";
		$agora_db = new $agora_db_class;
		$ret = $agora_db->openDB($agora_dbhost, $agora_dbport, $agora_dbuser, $agora_dbpassword, $agora_dbname, "agora");

		$agora_user = $agora_db->getUser("agora", $userid);
		if (is_array ($agora_user)) {
			$agora_db->updateUser ("agora", $userid, $user);
		} else {
			$agora_db->insertUser ("agora", $user);
		}
	}

} // End $go

#  display FORM
#  ------------

#  evaluate all fields from $user
#  ------------------------------
	while ( list( $var, $val ) = each( $user)) {
		if (is_string ($var)) {
			$$var = kill_quotes(stripSlashes(my_br2nl($val)));
		}
	}

?>

<HEAD>
 <TITLE>w-agora administration - create user </TITLE>
 <SCRIPT type="text/javascript" LANGUAGE="JavaScript">
<!-- // Hide for old browsers
  function CheckForm(form) {
<?
	include "$tmpl_dir/admin/user_fields.$ext";
	/* Check for required fields */
	if (isset($bn_bind_var)) {
		reset($bn_bind_var);
		while (list($field, $required) = each($bn_bind_var)) {
			if ($required) {
?>
    if (form.<?echo $field?>.value.length == 0) {
      alert ("<?DspMsg(56)?>");
      form.<?echo $field?>.focus();
      return false;
    }
<?
			}
		}
	}
?>
    return true;
  }
// End of script -->
 </SCRIPT>
</HEAD>
<BODY>
<FORM METHOD="post" ACTION="<?echo $WA_SELF?>" onSubmit="return CheckForm(this);" >

<INPUT TYPE="hidden" NAME="site" VALUE="<?echo $site?>">
<INPUT TYPE="hidden" NAME="go" VALUE="1">
<INPUT TYPE="hidden" NAME="userid" VALUE="<?echo $userid?>">

<?php	table_header (TITLE_EDITING_USER . "<em>'$userid'</em> " . LABEL_IN_SITE .  ": <em>$site</em>"); ?>
 <TABLE BORDER="0" WIDTH="100%">
  <CAPTION><B><?echo CAPTION_USER_INFO ?></B></CAPTION>
  <TR>
   <TD WIDTH="30%" ALIGN="RIGHT" VALIGN="MIDDLE" class=label><?echo COLUMN_USER_NAME ?>: </TD>
   <TD><?textField ("username", $username, 30, 64);?></TD>
  </TR>
  <TR>
   <TD WIDTH="30%" ALIGN="RIGHT" VALIGN="MIDDLE" class=label><?echo COLUMN_USER_EMAIL ?>: </TD>
   <TD><?textField ("useraddress", $useraddress, 30, 255);?></td>
  </TR>
  <TR>
   <TD WIDTH="30%" ALIGN="RIGHT" VALIGN="MIDDLE" class=label><?echo COLUMN_USER_WEBPAGE ?>: </TD>
   <TD><?textField ("homepage", $homepage, 30, 255);?></TD>
  </TR>
  <TR>
   <TD WIDTH="30%" ALIGN="RIGHT" VALIGN="TOP" class=label><?echo COLUMN_USER_DESCRIPTION ?>: </TD>
   <TD><?textArea ("details", $details, 2, 30);?></TD>
  </TR>
  <TR>
   <TD WIDTH="40%" ALIGN="RIGHT" VALIGN="TOP" class=label><?echo COLUMN_USER_COUNTRY ?>: </TD>
   <TD><?textField (COLUMN_USER_COUNTRY, $country, 30, 255);?></TD>
  </TR>
  <TR>
   <TD WIDTH="40%" ALIGN="RIGHT" VALIGN="MIDDLE" class=label><?echo COLUMN_USER_MAILOK ?></td>
   <TD bgcolor=#e0eaf6 class=label><? radioButton ("mailok", "Y", $mailok, LABEL_YES);
		radioButton ("mailok", "N", $mailok, LABEL_NO); ?></TD>
  </TR>
  <TR>
   <td ALIGN="RIGHT" VALIGN="TOP">
    <?displayUrl ("change_password.$ext?site=$site&userid=$userid", "", LABEL_CHANGE_PASSWORD, ALT_CHANGE_PASSWORD)?>
   </td>
  </tr>
 </TABLE>
 <TABLE BORDER="1" WIDTH="100%" CELLPADDING="5">
  <CAPTION><B><?echo LABEL_USER_STATISTICS?></B></CAPTION>
   <TR>
   <TD WIDTH="40%" ALIGN="RIGHT" VALIGN="TOP" class=label><?echo COLUMN_USER_REGISTERED?>: </TD>
   <TD class=label><? printf ("<B>%s</B>", formated_date($unixdate))?></TD>
  </TR>
  <TR>
   <TD WIDTH="40%" ALIGN="RIGHT" VALIGN="TOP" class=label><?echo COLUMN_USER_LOGIN_COUNT?>: </TD>
   <TD class=label>
<?php 
	printf ("<B>%s</B> ", $totallogins);
	if ($totallogins >0) {
	    printf (" (%s : <B>%s</B>)", COLUMN_USER_LAST_LOGIN, formated_date($lastlogin));
	}
?>
   </TD>
  </TR>
  <TR>
   <TD WIDTH="40%" ALIGN="RIGHT" VALIGN="TOP" class=label><?echo COLUMN_USER_POST_COUNT?>: </TD>
   <TD class=label>
<?php
	printf ("<B>%s</B> ", $totalposts);
	if ($totalposts >0) {
	    printf ("(last post : <B>%s</B> in forum <B>%s</B>)", formated_date($lastpost), $lastforumpost);
	}
?>
   </TD>
  </TR>
</TABLE>

<?
# Initialize user privileges choices
# ----------------------------------
	$granted_privs["user"] = $user_privs["user"];

# super user/administrator can grant moderator privilege
	if (($auth->type=="root") || ($auth->type=="admin") ) {
		$granted_privs["moder"] = $user_privs["moder"];
	}

# super user can grant administrator privilege
	if ($auth->type=="root") {
		$granted_privs["admin"] = $user_privs["admin"];
	}
	
# Only 'admin' can grant sysadmin privilege
	if ($auth->userid=="admin") {
		$granted_privs["root"] = $user_privs["root"];
	}

# if logged as admin or root : we allow to change user privileges
# ---------------------------------------------------------------
	if (count($granted_privs) > 1) {
		echo "<TABLE BORDER=0 WIDTH='100%'>";
		caption (CAPTION_USER_PRIVILEGE."<font color='blue'>$user_privs[$userpriv]</font>", "b");
		if ($userid != "admin") {
			echo "<TR><TD WIDTH='40%' ALIGN='RIGHT' VALIGN='MIDDLE' class=label>" . LABEL_CHANGE_USER_PRIVILEGE . "</TD><TD class=label>";
			listBox ("userpriv", $granted_privs, $userpriv);
		} else {
			echo "<TR><TD colspan='2' align='center' VALIGN='MIDDLE' class=label>" . ERROR_NO_ADMIN_CHANGE_PRIVILEGE . "";
			hiddenField ("userpriv", $userpriv); 
		}
		echo "</TD></TR></TABLE>";
	} else {
		hiddenField ("userpriv", $userpriv); 
	}

# Now, display all forums for which the logged user is responsible for
#	We don't display forums for an administrator (have rights over all forums)
# --------------------------------------------------------------------------


	if ( ($forums[$name]["type"] != "rest") && ($forums[$name]["type"] != "priv") ) {
		unset ($forums[$name]);
	}

	if ( (($userpriv=="moder") || ($userpriv=="user")) && (count($forums)>0) ) {
		echo '<hr><TABLE border=0 cellpadding=3 WIDTH="100%">';
  		caption ('<b>'.CAPTION_CHANGE_USER_FORUM_PRIVILEGES.'</b><br>'.
			LABEL_AS.'<u>'.$user_privs[$auth->type].'</u>,' . LABEL_GRANT_PRIVILEGES.$userid, '');
  		echo '<tr bgcolor="#cccccc">'.
			'<td class=label>' . COLUMN_FORUM . '</td>'.
			'<td class=label>' . COLUMN_TITLE . '</td>'.
			'<td class=label>' . COLUMN_CAN_LIST . '</td>'.
			'<td class=label>' . COLUMN_CAN_READ . '</td>'.
			'<td class=label>' . COLUMN_CAN_WRITE . '</td>';
		if ($userpriv=="moder") {
			echo '<td class=label>' . LABEL_MODERATOR . '</td>';
		}
		echo '<td class=label>' . LABEL_STATUS . '</td></tr>';

		$sel_forums["none"] = LABEL_NONE;
		$addforum=0;

# for each owned forum
# ---------------------
		reset ($forums);
		while (list($name) = each ($forums) ) {
			$bn_title = $forums[$name]["bn_title"];
			$forum = $forums[$name]["bn_name"];
# get privileges for this user on this forum
			$privs = $db->getPrivs($site, $forum, $userid);
			if (is_array ($privs) ) {
# if the selected user have access to this forum, then display privileges
				$type = $forums[$name]['type'];
				printf ('<tr bgcolor="#e0eaf6"><td class="label"><b>%s</b></td><td class=label>%s</td>', $name.' ('.$forum_types[$type].')', $bn_title);
				if ( ($type == 'rest') || ($type == 'priv') ) {
					echo '<td class=label align="center">'. getCheckBox ($forum.'[readpriv]', '1', $privs['readpriv']).'</td>';
					echo '<td class=label align="center">'. getCheckBox ($forum.'[listpriv]', '1', $privs['listpriv']).'</td>';
					echo '<td class=label align="center">'. getCheckBox ($forum.'[writepriv]', '1', $privs['writepriv']).'</td>';
				} else {
					echo '<td class=label align="center"> x </td>';
					echo '<td class=label align="center"> x </td>';
					echo '<td class=label align="center"> x </td>';
				}
				if ($userpriv=="moder") {
					echo '<td class=label align="center">'. getCheckBox ($forum.'[modpriv]', '1', $privs['modpriv']).'</td>';
				}

				if ($privs["state"] != "P") {
					unset($user_states["P"]);
				}
				$user_states["D"] = "REMOVE ACCESS!!";
				echo '<td class=label align="center">' . getListBox ($forum.'[state]', $user_states, $privs['state']). '</td></tr>';
			} else {
# else add this forum to the combo box for later selection
				$sel_forums[$forum] = $bn_title;
				$addforum=1;
			}
		}
		
# Now list forums for which the selected user doesn't have privilege
# -------------------------------------------------------------
		if ($addforum==1) {
			print ("<tr><td><b>" . LABEL_ADD_FORUM . "</b></td><td>");
			listBox ("new_forum", $sel_forums);
			print ("</td><td>");
			checkBox ("new_privs[listpriv]", "1", "1");
			print ("</td><td>");
			checkBox ("new_privs[readpriv]", "1", "1");
			print ("</td><td>");
	 		checkBox ("new_privs[writepriv]", "1", "1");
			print ("</td><td>");
			if ($userpriv=="moder") {
				checkBox ("new_privs[modpriv]", "1", "0");
				print ("</td><td>");
			}
			unset($user_states["P"]);
			unset($user_states["D"]);
			listBox ("new_privs[state]", $user_states, "1");
			print ("</td></tr>");
		}
		echo " </TABLE>";
	}
?>
<br><center>
 <INPUT TYPE="submit" VALUE="<?echo LABEL_SAVE?>">&nbsp;
 <INPUT TYPE="reset"  VALUE="<?echo LABEL_RESET?>">
<? table_footer(); ?>
</FORM>
</BODY>
</HTML>

