<?php

/*
 *	W-AGORA 4.0
 *	-----------
 *	$Id: editmail.php,v 1.11 2002/05/07 15:08:12 mdruilhe Exp $
 *	Usage:		Edit mail template
 *	Author:		Marc Druilhe <mdruilhe@w-agora.net>
 *
 */

	require ("init_admin.inc");

# Only a site administrator can edit layout
# -----------------------------------------
	if ($auth->level < ADMIN) {
		MsgForm (ERROR_NO_ADMIN, "admin_site.$ext?site=$site&force_login=1", "", "_top");
		echo "</body></html>";
		exit;
	}

# reads configuration
# -------------------
	include ("$cfg_file");

# set pathname of file to be edited : if variable $bn_xxx is empty then set path to default
# -----------------------------------------------------------------------------------------
	$page_title = TITLE_EDITING_MAIL;
	$page_info = '';
	if ($editdefault==1) {
		$var_file = "$bn_dir_default/mail_template.$ext";
		$page_info = WARNING_EDITING_DEFAULT;
	} elseif (empty ($bn_mail_template) ) {
		if ($editsite==1) {
			$var_file="$bn_dir/mail_template.$ext"; // default file for site listing
		} else {
			$var_file = "$bn_dir_default/mail_template.$ext";
			$page_info = WARNING_EDITING_DEFAULT;
			if (!empty($bn) ) {
				$page_info .= "<br>" . sprintf(LABEL_SPECIFIC_TEMPLATE, "editconf.$ext?site=$site&bn=$bn&mode=advanced#include");
			}
		}
	} else {
		$var_file="$bn_dir/$bn_mail_template";
	}

# Save file if submit has been sent
# ---------------------------------
	if (isset($save)) {
		$conf = new Config;
		$ret = $conf->open($var_file);
		if (!$ret) {
			die (str_replace("{FILE}", $var_file, ERROR_OPEN_FILE));
		}

		$conf->writeInt ("bn_send_user_address", $bn_send_user_address);
		$conf->writeString ("bn_mail_from", $bn_mail_from);
		$conf->writeString ("bn_return_path", $bn_return_path);
		$conf->writeString ("bn_reply_to", $bn_reply_to);
		$conf->writeString ("bn_mail_to", $bn_mail_to);
		$conf->writeString ("mail_no_subject", $mail_no_subject);
		$conf->writeString ("mail_subject", $mail_subject);
		$conf->writeString ("mail_newpost_body", $mail_newpost_body);
		$conf->writeString ("mail_update_body", $mail_update_body);
		$conf->writeString ("mail_register_subject", $mail_register_subject);
		$conf->writeString ("mail_register_body", $mail_register_body);
		$conf->writeString ("mail_approve_user_subject", $mail_approve_user_subject);
		$conf->writeString ("mail_approve_user_body", $mail_approve_user_body);
		$conf->writeString ("mail_approve_body", $mail_approve_body);
		$conf->writeString ("mail_password_subject", $mail_password_subject);
		$conf->writeString ("mail_password_body", $mail_password_body);
		$conf->writeString ("mail_change_profile_subject", $mail_change_profile_subject);
		$conf->writeString ("mail_change_profile_body", $mail_change_profile_body);
		$conf->close();

# Else : Restore file if UNDO has been requested
# ---------------------------------------
	} elseif (isset($undo)) {
		if (file_exists ("$var_file.bak.$ext"))
			Copy ("$var_file.bak.$ext", "$var_file");
	}

# Now reads the file (PHP variables)
# ----------------------------------
	if (file_exists ($var_file)) {
		include "$var_file";
		$form_title = "<em>" . LABEL_FILE_EDITING . ": $var_file </em>";
	} else {
		if (file_exists ("$bn_dir_default/mail_template.$ext")) {
			@copy ("$bn_dir_default/mail_template.$ext", "$var_file");
			include "$var_file";
		}
		$form_title = "<em>" . LABEL_NEW_FILE_EDITING . ": $var_file </em>";
	}

# Formats the editable fields (converts PHP variables to Template variables)
# --------------------------------------------------------------------------
	$mail_no_subject = ereg_replace("\\$"."([a-zA-Z0-9_]+)", "{\\1}", $mail_no_subject);
	$mail_no_subject = ereg_replace ("\\\\n","\n", $mail_no_subject);

	$mail_subject = ereg_replace("\\$"."([a-zA-Z0-9_]+)", "{\\1}", $mail_subject);
	$mail_subject = ereg_replace ("\\\\n","\n", $mail_subject);

	$mail_newpost_body = ereg_replace("\\$"."([a-zA-Z0-9_]+)", "{\\1}", $mail_newpost_body);
	$mail_newpost_body = ereg_replace ("\\\\n","\n", $mail_newpost_body);
	
	$mail_update_body = ereg_replace("\\$"."([a-zA-Z0-9_]+)", "{\\1}", $mail_update_body);
	$mail_update_body = ereg_replace ("\\\\n","\n", $mail_update_body);

	$mail_register_subject = ereg_replace("\\$"."([a-zA-Z0-9_]+)", "{\\1}", $mail_register_subject);
	$mail_register_subject = ereg_replace ("\\\\n","\n", $mail_register_subject);

	$mail_register_body = ereg_replace("\\$"."([a-zA-Z0-9_]+)", "{\\1}", $mail_register_body);
	$mail_register_body = ereg_replace ("\\\\n","\n", $mail_register_body);

	$mail_approve_user_subject = ereg_replace("\\$"."([a-zA-Z0-9_]+)", "{\\1}", $mail_approve_user_subject);
	$mail_approve_user_subject = ereg_replace ("\\\\n","\n", $mail_approve_user_subject);

	$mail_approve_user_body = ereg_replace("\\$"."([a-zA-Z0-9_]+)", "{\\1}", $mail_approve_user_body);
	$mail_approve_user_body = ereg_replace ("\\\\n","\n", $mail_approve_user_body);

	$mail_approve_body = ereg_replace("\\$"."([a-zA-Z0-9_]+)", "{\\1}", $mail_approve_body);
	$mail_approve_body = ereg_replace ("\\\\n","\n", $mail_approve_body);

	$mail_password_subject = ereg_replace("\\$"."([a-zA-Z0-9_]+)", "{\\1}", $mail_password_subject);
	$mail_password_subject = ereg_replace ("\\\\n","\n", $mail_password_subject);

	$mail_password_body = ereg_replace("\\$"."([a-zA-Z0-9_]+)", "{\\1}", $mail_password_body);
	$mail_password_body = ereg_replace ("\\\\n","\n", $mail_password_body);

	$mail_change_profile_subject = ereg_replace("\\$"."([a-zA-Z0-9_]+)", "{\\1}", $mail_change_profile_subject);
	$mail_change_profile_subject = ereg_replace ("\\\\n","\n", $mail_change_profile_subject);

	$mail_change_profile_body = ereg_replace("\\$"."([a-zA-Z0-9_]+)", "{\\1}", $mail_change_profile_body);
	$mail_change_profile_body = ereg_replace ("\\\\n","\n", $mail_change_profile_body);

# Displays the FORM
# -----------------

	$bn_send_user_address = (empty ($bn_send_user_address) ) ? "0" : "1";
	$bn_mail_from = (empty ($bn_mail_from) ) ? "forums@$SERVER_NAME" : $bn_mail_from;
	
	display_header ($page_title);
	echo "<center>$page_info</center><br>";
	table_header ($form_title);
	beginForm();
	hiddenField ('editdefault', $editdefault);

	print "<CENTER><TABLE WIDTH=\"100%\" cellpadding=5>";

	print "<TR><TD align='right' valign=top class=label>" . LABEL_SEND_OUT_EMAILS . ":</TD><TD class=label>";
	radioButton ("bn_send_user_address", "1", $bn_send_user_address, LABEL_USER_EMAIL . "<br>");
	radioButton ("bn_send_user_address", "0", $bn_send_user_address, LABEL_THIS_EMAIL . ":<br>");
	textField ("bn_mail_from", $bn_mail_from, 50);
	print "</blockquote></TD></TR>\n";

	print "<TR><TD width=\"40%\" align='right' valign=top class=label>" . LABEL_FIRST_RECIPIENT . ":</TD><TD>";
	textField ("bn_mail_to", $bn_mail_to, 50);
	print "</TD></TR>\n";

	print "<TR><TD width=\"40%\" align='right' valign=top class=label>" . LABEL_RETURN_PATH . ":</TD><TD>";
	textField ("bn_return_path", $bn_return_path, 50);
	print "</TD></TR>\n";
	
	print "<TR><TD width=\"40%\" align='right' valign=top class=label>" . LABEL_REPLY_TO . ":</TD><TD>";
	textField ("bn_reply_to", $bn_reply_to, 50);
	print "</TD></TR>\n";

	print "<TR><TD width=\"40%\" align='right' valign=top class=label>" . LABEL_NO_MAIL_SUBJECT . ":</TD><TD>";
	textField ("mail_no_subject", $mail_no_subject, 50);
	print "</TD></TR>\n";

	print "<TR><TD width=\"40%\" align='right' valign=top class=label>" . LABEL_MAIL_SUBJECT . ":</TD><TD>";
	textField ("mail_subject", $mail_subject, 50);
	print "</TD></TR>\n";

	print "<TR><TD width=\"40%\" align='right' valign=top class=label>" . LABEL_MAIL_NEW_MESSAGES. ":</TD><TD>";
	textArea ("mail_newpost_body", $mail_newpost_body, 5, 50);
	print "</TD></TR>\n";

	print "<TR><TD align='right' valign=top class=label>" . LABEL_MAIL_UPDATED_MESSAGES . ":</TD><TD class=label>";
	textArea ("mail_update_body", $mail_update_body, 5, 50);
	print "<HR></TD></TR>\n";

	print "<TR><TD width=\"40%\" align='right' valign=top class=label>" . LABEL_MAIL_APPROVAL . ":</TD><TD class=label> ";
	textArea ("mail_approve_body", $mail_approve_body, 5, 50);
	print "<hr></TD></TR>\n";

	print "<TR><TD width=\"40%\" align='right' valign=top class=label>" . LABEL_MAIL_REGISTRATION . ":</TD><TD class=label> ";
	print LABEL_SUBJECT . "<BR>";
	textField ("mail_register_subject", $mail_register_subject, 50);
	print "<BR>" . LABEL_MAIL_BODY . "<BR>";
	textArea ("mail_register_body", $mail_register_body, 5, 50);
	print "<hr></TD></TR>\n";

	print "<TR><TD width=\"40%\" align='right' valign=top class=label>" . LABEL_MAIL_USER_APPROVAL . ":</TD><TD class=label> ";
	print LABEL_SUBJECT . "<BR>";
	textField ("mail_approve_user_subject", $mail_approve_user_subject, 50);
	print "<BR>" . LABEL_MAIL_BODY . "<BR>";
	textArea ("mail_approve_user_body", $mail_approve_user_body, 5, 50);
	print "<hr></TD></TR>\n";

	print "<TR><TD width=\"40%\" align='right' valign=top class=label>" . LABEL_MAIL_USER_MODIFICATION . ":</TD><TD class=label> ";
	print LABEL_SUBJECT . "<BR>";
	textField ("mail_change_profile_subject", $mail_change_profile_subject, 50);
	print "<BR>" . LABEL_MAIL_BODY . "<BR>";
	textArea ("mail_change_profile_body", $mail_change_profile_body, 5, 50);
	print "<hr></TD></TR>\n";

	print "<TR><TD width=\"40%\" align='right' valign=top class=label>" . LABEL_MAIL_FORGOT_PASSWORD . ":</TD><TD class=label> ";
	print LABEL_SUBJECT . "<BR>";
	textField ("mail_password_subject", $mail_password_subject, 50);
	print "<BR>" . LABEL_MAIL_BODY . "<BR>";
	textArea ("mail_password_body", $mail_password_body, 5, 50);
	print "<HR></TD></TR>\n";

	print "</TABLE><CENTER>";
	submitButton ("save", LABEL_SAVE);
	resetButton ("reset", LABEL_RESET);
	submitButton ("undo", LABEL_UNDO);
	print "</CENTER>";
	endForm();
	table_footer();

?>
