<?php

/* 
 *	W-AGORA 4.0
 *	-----------
 *	$Id: rss.php,v 1.1 2001/08/28 21:58:38 mdruilhe Exp $
 *	Usage:			RSS/My Netscape Network channel box generator
 *	Authors:		Ron Friedman (friedman@filmmaker.com)
 *					Marc Druilhe <mdruilhe@w-agora.com>
 */

#-----------------------------------------------------------------------
# RSS/My Netscape Network channel box generator for W-Agora (4.x)
#
# By Ron Friedman (friedman@filmmaker.com)
#
# Reference:  http://my.netscape.com/publish/help/mnn20/quickstart.html         
#
# WHAT THIS DOES:
#
# If you've ever used Slashdot (www.slashdot.org), Mozilla, or Netscape
# Netcenter, you've probably seen those "boxes" with links to news from
# other sites.  How are they done?  They're special files that
# use a format called RSS.  Read about it at the link above.  The Mozilla
# sidebar panels use a similar format called RDF, but you can convert from
# RSS to RDF pretty easily.
#
# Anyway, this php script creates a "dynamic" RSS file using a w-agora
# forum.  The most recent posts are treated as "news items" in the RSS code.
#
# Here's an example:  http://my.netscape.com/addchannel.tmpl?service=net.2960
#
# To use, just fill out the variables below, throw this up on your site,
# maybe rename it to index.php so that you can just use a directory,
# check the validity with the validity checker (see the page above),
# and register with Netcenter.  You might also register with DMOZ
# (http://www.dmoz.org).  Read the reference link above for more info.
#
# Note-- Not *everything* in the RSS spec is used here.  The program is
# fairly simple to figure out, so you can add or modify stuff very
# quickly.
#
# Once you're done with your RSS file, you can register it with
# My Netscape here:
# http://my.netscape.com/publish  
#
# And you can make it into a Mozilla/Netscape 6 sidebar here:
# http://www.theonering.net/staff/corvar/cgi-bin/sidebar-inst.pl
#
# By the way, **THE MYSQL CODE IS COMPLETELY UNTESTED!!!**
#
# If someone should fix it or verify it works, please update this file's
# version # in CVS (if this ever makes it to CVS)
#
# Thanks,  Ron
#-----------------------------------------------------------------------

# STUFF YOU SHOULD CHANGE

# Basic info:
$title = "My Great Website";
$link = "http://www.mysite.com";
$description = "This is a site for me and doing my stuff";
$language = "en-us";

# This is the URL of your /agora/view.php page.
$wagoraurl = "http://www.mysite.com/w-agora/view.php";

# The name of the "news forum" W-Agora 
$bn = "my_news_forum";

# How many news stories to show (max 15)
$itemcount = 10;

# OPTIONAL:  add copyright information here (...or just comment out)
$copyright = "Copyright " . Date("Y") . ", Me";

# OPTIONAL:  Fill the below (and uncomment) if you have an image
# The maximum allowed image size is 144 pixels (width) x 400 pixels
# (height).  The description will be a caption.

#$imageurl = "";
#$imagetitle = "";
#$imagelink = "";
#$imageheight = 0;
#$imagewidth = 0;
#$imagedescription = "";

# OPTIONAL:  If you want to add a little form at the bottom of your slashbox,
#            customize the following.  Otherwise, comment it out
#            or set $button = "";

$button = "
     <textinput>
       <title>Search</title>
       <description>Enter String</description>
       <name>search</name>
       <link>http://www.mysite.com/search.php</link>
     </textinput>
";

#-----------------------------------
# Don't touch anything below
# unless you know what you're doing
#-----------------------------------

include "init.inc";

$select = "select subject, unixdate, childs from $dbname where parent = 0 order by unixdate DESC";
$ret = $db->listNotes ($bn_db, 0, 0, "", "parent=0", $itemcount);

# First connect to database
if ($db == "postgres") {
   $conn = pg_connect($dbconnectstring);
   if (!$conn) exit;
   $result = pg_exec($conn, $select);
# note should limit to the $itemcount but LIMIT doesn't work too well in postgres
   if (!$result) exit;
   pg_close($conn);
   $pubdate = Date("D M j g:i:s T Y", @pg_Result($result, 0, "unixdate"));
   }

#This is totally untested!
if ($db == "mysql") {
   $select .= " LIMIT $itemcount";
   $conn = mysql_connect($dbconnectstring);
   if (!$conn) exit;
   $result = mysql_query($select, $conn);
   if (!$result) exit;
   $pubdate =  Date("D M j g:i:s T Y", @mysql_result($result, 0, "unixdate"));
   }

echo "<" . "?xml version=\"1.0\"?" . ">";
?>

 <!DOCTYPE rss PUBLIC "-//Netscape Communications//DTD RSS 0.91//EN"
             "http://my.netscape.com/publish/formats/rss-0.91.dtd">

 <rss version="0.91">

   <channel>
   
     <title><?echo $title;?></title>
     <link><?echo $link;?></link>
     <description><?echo $description;?></description>
     <language><?echo $language;?></language>

<?
if ($copyright) { echo "<copyright>$copyright</copyright>\n";}

#most recent message posted to forum at...
echo "<pubDate>$pubdate</pubDate>\n";

#this rss file created at...
echo "<lastBuildDate>". Date("D M j g:i:s T Y", $now) . "</lastBuildDate>\n";

if ($imageurl)
    echo "
    <image>
       <title>$imagetitle</title>
       <url>$imageurl</url>
       <link>$imagelink</link>
       <width>$imagewidth</width>
       <height>$imageheight</height>
       <description>$imagedescription</description>
     </image>
";

$i = 0;

#loop for items

while ($i < $itemcount) {

if ($db == "postgres")
  {
   $title   =   htmlspecialchars(@pg_Result($result, $i, "subject"));
   $key     =   @pg_Result($result, $i, "unixdate");
   $replies =   @pg_Result($result, $i, "childs");
  }

# below is untested!

if ($db == "mysql")
  {
   $title   =   htmlspecialchars(@mysql_Result($result, $i, "subject"));
   $key     =   @mysql_Result($result, $i, "unixdate");
   $replies =   @mysql_Result($result, $i, "childs");
  }

  echo "\n<item>\n  <title>$title</title>\n";
  echo "  <link>";
  echo "$wagoraurl?bn=$dbname&amp;key=";
  echo $key;
  echo "</link>\n";
#
# modify & uncomment below to add a description.  Note that the example only shows #
# of 1st level replies to the news item.  It's dumb so I didn't use it.  You can make
# it smarter, or have it use the first paragraph of your news item, or whatever. I
# think you're limited to 500 characters though.
#
#  echo "  <description>$replies replies</description>\n";
  echo "</item>";
  $i++;
}

echo $button;
?>

   </channel>
   
 </rss>
