<?php

/*
 *	W-AGORA 4.0
 *	-----------
 *	$Id: auth.php,v 1.25 2002/06/10 17:41:35 mdruilhe Exp $
 *	 Usage:		Authentication class
 *	 Author:	Marc Druilhe <mdruilhe@w-agora.com>
 */

if (!isset($AUTH)) {

  define('_AUTH', 1);
  $AUTH=1;



# Global variables & contants
# ---------------------------

# user privileges
#----------------
$user_privs ["root"]  = msg (173, "<font color='red'>" . LABEL_ROOT . "</font>");
$user_privs ["admin"] = msg (174, "<font color='red'>" . LABEL_ADMINISTRATOR . "</font>");
$user_privs ["moder"] = msg (175, "<font color='blue'>" . LABEL_MODERATOR . "</font>");
$user_privs ["user"]  = msg (176, LABEL_USER);


# Privilege levels
# ----------------

define('UNKNOWN', -1);
define('USER',  0);
define('MODER', 1);
define('ADMIN', 2);
define('ROOT',  3);

class wa_Auth {

var $type;		// user privilege
var $userid;	// user login
var $level;		// privilege level
var $user;		// user informations array
var $privs = array();	// current permissions (current forum)
var $perms = array();	// permissions cache

# generate a random password
# --------------------------
 function genPassword () {
	srand(time());
	$passet = 'abcdefghijkmnopqrstuvwxyzABCDEFGHJKLMNPQRSTUVWXYZ23456789';
	$max_rand =strlen($passet)-1;
	for ($i = 0; $i < 6; $i++) {
		$random_num = rand(0, $max_rand);
# Added for buggy rand() functions
		if ($random_num > $max_rand) {
			$random_num = $random_num % $max_rand;
		}
		$pass .= $passet[$random_num];
	}
	return $pass;
 }

# 'LOGOUT' this user -> reset the cookies
# -------------------------------------------------------------
 function logout ($site) {
	if (isset($GLOBALS["${site}_auth"])) {
		setCookie ("${site}_auth", '', 0, '/');
 	}
	if (isset($GLOBALS['agora_auth'])) {
		setCookie ('agora_auth', '', 0, '/');
 	}
	$GLOBALS['is_authenticated'] = false;
 }

# present login form to the user
# display the forum form defined in $bn_login_form if it exists
# else displays a default form
# -------------------------------------------------------------
 function login ($site, $title='', $action='') {
	global $WA_SELF, $HTTP_GET_VARS, $ext;
	global $bn, $key, $bn_dir, $bn_dir_default, $bn_login_form;
	global $loginuser, $frameset;
	global $register_url, $register_text, $register_link;

	$action = (empty($action) ) ? $WA_SELF : $action;
	$userid = (empty($GLOBALS['userid']) ) ? '' : $GLOBALS['userid'];
	$editsite = (empty($GLOBALS['editsite']) ) ? '' : $GLOBALS['editsite'];
	$loginuser = (isset($loginuser) ) ? $loginuser : '';

	$change_password_url = "change_password.$ext?site=$site&bn=$bn";
	$forgot_password_url = "forgot_password.$ext?site=$site&bn=$bn";

	$title1 = sprintf ("<center>%s</center><br>", (isset($GLOBALS["loginform"])) ? msg (89, ERROR_INVALID_LOGIN) : msg (90, LABEL_PLEASE_LOGIN) );

	echo "<FORM METHOD='post' ACTION='$action'>";

	hiddenField ('loginform', '1');
	hiddenField ('site', $site);
	hiddenField ('bn', $bn);
	hiddenField ('userid', $userid);		// this is for edituser.php?userid=user
	hiddenField ('editsite', $editsite);	// used in editlist !!

# carry on all variables passed to the URL (needs PHP_track_vars enabled)
# -----------------------------------------------------------------------
	while (is_array($HTTP_GET_VARS) && list ($k,$v) = each ($HTTP_GET_VARS) ) {
		if ( !empty($v) && ($k != 'site') && ($k != 'bn')  && ($k != 'force_login')) {
			hiddenField ($k, $v);
		}
	}

	$title = (empty($title)) ? msg(91, sprintf(LABEL_SITE_LOGIN, $site)) : $title;
	$form_title = $title;

	if (!empty($bn_login_form) && file_exists("${bn_dir}/${bn_login_form}") ) {
		include "${bn_dir}/${bn_login_form}";
	} elseif ( file_exists("${bn_dir_default}/login_form.$ext") ) {
		include "${bn_dir_default}/login_form.$ext";
	} else {
		echo $title1;
		table_header ($title, '400');
?>
<table width="100%" cellspacing=0 cellpadding=4>
 <tr valign=top align=left>
  <td class=label><?echo LABEL_USERNAME?>:</td>
  <td colspan=2><input type="text" name="loginuser" value="<?php echo $loginuser?>" size=20 maxlength=32></td>
 </tr>
  <tr valign=top align=left>
  <td class=label><?echo LABEL_PASSWORD?>:</td>
  <td colspan=2><input type="password" name="loginpassword" size=20 maxlength=32></td>
 </tr>
 <tr>
  <td valign=middle align=right colspan=3>
   <input type="submit" name="btnlogin" value="<?echo LABEL_DO_LOGIN ?>">
  </td>
 </tr>
 <tr>
  <td valign=middle align=center nowrap><a href="<?echo $register_url?>"><?echo LABEL_REGISTER?></a></td>
  <td valign=middle align=center nowrap><a href="<?echo $forgot_password_url?>"><?echo LABEL_FORGOT_PASSWORD?></a></td>
  <td valign=middle align=center nowrap><a href="<?echo $change_password_url?>"><?echo LABEL_CHANGE_PASSWORD?></a></td>
 </tr>
</table>
<?
		table_footer();
	}
	echo '</FORM>';
 }

 function authenticate ($userid='', $clearpw='', $encryptedpw='', $site='') {
	global $db;

	$this->userid = 'guest';
	$this->type = 'unregistered';
	$this->level = UNKNOWN;
	unset ($this->user);

	$setcookie=false;
	$site = (empty($site) ) ? $GLOBALS['site'] : $site;

# 1 -- Get Login info parameters in that order:
#				function arguments
#				w-agora Login Form
#				w-agora cookies
#				user defined
# --------------------------------------------------------
	if ( ! empty($userid) ) {
#		1. Take user/password from function arguments
#		---------------------------------------------
		$setcookie=true;

	} elseif (isset ($GLOBALS['loginform']) ) {
#		2. Take user/password from login form
#		-------------------------------------
		$userid = $GLOBALS['loginuser'];
		$clearpw = $GLOBALS['loginpassword'];
		$setcookie=true;

	} elseif (isset($GLOBALS["${site}_auth"]) ) {
#		3. Take user/password from cookies
#		----------------------------------
		$pairs = split ('&', $GLOBALS["${site}_auth"]);
		reset($pairs);
		while (list (,$pair) = each ($pairs) ) {
			$pair = split ('=', $pair);
			$var = $pair[0];
			$$var = $pair[1];
		}
		$userid=$uid;
		$encryptedpw=$pw;

	} elseif (isset($GLOBALS['agora_auth']) ) {
#		4. Check if user is authenticated at global level
#		-------------------------------------------------
		$pairs = split ('&', $GLOBALS['agora_auth']);
		reset($pairs);
		while (list (,$pair) = each ($pairs) ) {
			$pair = split ('=', $pair);
			$var = $pair[0];
			$$var = $pair[1];
		}
		$userid=$uid;
		$encryptedpw=$pw;
		$setcookie=true;
	} else {
#		5. Get site specific user login info
#		------------------------------------
		$logininfo = $this->getLoginInfo();
		if (!is_array ($logininfo)) {
			return false;
		}
		$userid = $logininfo['userid'];
		$encryptedpw = $logininfo['encryptedpw'];
		$clearpw = $logininfo['clearpw'];
		$setcookie=true;
	}
# 2 -- authenticate the user and retreive user information
# --------------------------------------------------------
	if ($userid == 'admin') {
		#admin user should always authenticate against the agora DB
		$encryptedpw = (empty($clearpw)) ? $encryptedpw : md5($clearpw);
		$this->user = $db->getUser($site, $userid);
		if (!is_array ($this->user)) {
			return false;
		}
		if ($encryptedpw != $this->user['password']) {
			return false;
		}
	} else {
		#authenticate against the user source for this site
		$encryptedpw = (empty($clearpw)) ? $encryptedpw : $this->encryptPassword($clearpw);
		if (!$this->authenticateUser($site, $userid, $encryptedpw)) {
			return false;
		};
	}

	$this->userid = $this->user['userid'];
	$this->type = $this->user['userpriv'];
	switch ($this->user['userpriv']) {
		case 'root':
			$this->level = ROOT;
			break;
		case 'admin':
			$this->level = ADMIN;
			break;
		case 'moder':
			$this->level = MODER;
			break;
		case 'user':
			$this->level = USER;
			break;
		default:
			$this->level = UNKNOWN;
			break;
	}

# 3 -- If it is a new w-agora session, then update user stats and infos
# ---------------------------------------------------------------------
	if ($setcookie) {
		$this->user['lastlogin'] = time();
		$this->user['totallogins'] += 1;

		// Update user record (create if it does not exist)
		if ($db->updateUserLogin($site, $userid) == ERR_NOTFOUND) {
			$db->insertUser($site, $this->user);
		}

		// set the w-agora cookie
		$userid = $this->user['userid'];
		$password = $this->user['password'];
		setCookie ("${site}_auth", "uid=$userid&pw=$password", 0, '/');
		if ( ($this->level == ROOT) && !isset($GLOBALS['agora_auth']) ) {
			setCookie ('agora_auth', "uid=$userid&pw=$password", 0, '/');
		}
		// (4.1.3) add entry to the LOG
		if (!$GLOBALS['bn_no_stats'] && ($site!='agora') ) {
			$db->addLogEntry ($GLOBALS['bn'], 'login', $userid);
		}

	}
	return true;
}

 function havePermission ($forum, $perm) {
	global $db, $site;

	if (empty($this->userid) ) {
		return false;
	}

	if ($this->level >= ADMIN) {
		$this->privs['modpriv'] = 1;
		$this->privs['state'] = 1;
		return true;
	}

	if (is_array($this->perms[$forum])) {
		$this->privs = $this->perms[$forum];
	} else {
		$privs = $db->getPrivs($site, $forum, $this->userid);
		if (is_array($privs) ) {
			$this->privs = $privs;
			$this->perms[$forum] = $this->privs;
		} else {
			$this->privs['modpriv']   = 0;
			$this->privs['listpriv']  = 0;
			$this->privs['readpriv']  = 0;
			$this->privs['writepriv'] = 0;
			$this->perms[$forum] = $this->privs;
			return false;
		}
	}

	switch ($perm) {
	 case 'L':
		if ($this->privs['listpriv']==1) {
			return true;
		}
		break;
	 case 'R':
		if ($this->privs['readpriv']==1) {
			return true;
		}
		break;
	 case 'W':
		if ($this->privs['writepriv']==1) {
			return true;
		}
		break;
	 case 'M':
		if ($this->privs['modpriv']==1) {
			return true;
		}
		break;
	 default:
		return false;
		break;
	}


	return false;
 }
} // end CLASS

} //defined AUTH
