<?php

/* 
 *	W-AGORA 4.0
 *	-----------
 *	$Id: config.php,v 1.21 2002/03/08 17:18:38 mdruilhe Exp $
 *	Usage:		include file - Configuration class
 *	Author:		Marc Druilhe <mdruilhe@w-agora.net>
 */

$databases = array (
//	"dbm" => "DBM",
	"mysql"  => "mySQL",
	"msql"   => "mini SQL (mSQL 2.0)",
	"mssql7" => "Microsoft SQL server 7",
//	"odbc" => "ODBC",
//	"oracle" => "Oracle 7",
	"oci8" => "Oracle 8 OCI",
	"postgres65" => "PostgreSQL version 6.5 or higher",
	"postgres"   => "PostgreSQL version 6.4 or older"
);

$search_engines = array (
	"none" => "None (database)",
	"swish" => "Swish-e",
	"namazu" => "Namazu"
);

class Config {

var $fd=0;

function open ($file) {
	global $ext;

	$ext = (empty($ext) ) ? "php" : $ext;

	if ($this->fd > 0) {
		print ("$file already opened");
		return false;
	}
	
	if (file_exists ("$file"))
		Copy ("$file", "${file}.bak.$ext");
	$this->fd = fopen ("$file", "w");
	if (!$this->fd)
		return false;
	fputs ($this->fd, "<?php\n");
	return true;
}

function close () {
	if ($this->fd == 0) {
		print ("no configuration file opened");
		return false;
	}
	fputs ($this->fd, "?>\n");	// <? help syntax highlighting
	fclose ($this->fd);
	return true;
}

function restore ($file) {
	global $ext;

	$ext = (empty($ext) ) ? "php" : $ext;

	if (file_exists ("${file}.bak.$ext")) {
		return copy ("${file}.bak.$ext", "$file");
	} else {
		return false;
	}
}

function writeString ($var, $val, $comment="") {
	if ($this->fd == 0) {
		print ("no configuration file opened");
		return false;
	}

	$value="";
	if (!empty($val)) {
		$value = ereg_replace (13, "", stripSlashes($val));
		$value = str_replace ('\\', '\\\\', $value);
		$value = ereg_replace("\{"."([a-zA-Z0-9_]+)"."}", "\$\\1", $value);
		$value = ereg_replace (10, "\\n", $value);
		$value = ereg_replace ('"', '\\"', $value);
		$value = ereg_replace ("\\$","\\$", $value);
	}
	
	if (!empty ($comment)) {
		$comment = "\t// $comment";
	}

	if(get_cfg_var("magic_quotes_runtime")) {
		$value = addSlashes($value);
	}
	fputs ($this->fd, "\$$var = \"$value\";$comment\n");
}

function writeInt ($var, $val, $comment="") {
	setType ($value, "integer");
	if (empty ($val)) {
		$value=0;
	}
	else {
		$value=$val;
	}
	if (!empty ($comment)) {
		$comment = "\t// $comment";
	}
	fputs ($this->fd, "\$$var = $value;$comment\n");
}

function writeLn () {
	fputs ($this->fd, "\n");
}

function writeComment ($comment) {
	fputs ($this->fd, "# $comment\n");
}

function writeArrayConfig($conf) {
	if (!is_array($conf))
		return false;

	while ( list( $var, $val) = each($conf) ) {
		if (is_int($val))
			fputs ($fp, "\$$var=$val;\n");
		else
			fputs ($fp, "\$$var=\"$val\";\n");
	}
	fputs ($fp, "?>\n"); // <? helps syntax editor
	fclose ($fp);
	return 0;
}

	/***********************************/
	/*  Initialize Configuration File  */
	/***********************************/

function writeConfig() {

	$this->writeString("site", $GLOBALS["site"]);
	$this->writeString("bn_dir", $GLOBALS["bn_dir"]);
	$this->writeString("bn_dir_notes", $GLOBALS["bn_dir_notes"]);
	$this->writeString("bn_dir_forums", $GLOBALS["bn_dir_forums"]);
	$this->writeString("bn_dir_default", $GLOBALS["bn_dir_default"]);

	$this->writeString("bn_access", $GLOBALS["bn_access"]);
	$this->writeString("dbname", $GLOBALS["dbname"]);
	$this->writeString("dbhost", $GLOBALS["dbhost"]);
	$this->writeString("dbport", $GLOBALS["dbport"]);
	$this->writeString("dbuser", $GLOBALS["dbuser"]);
	$this->writeString("dbpassword", $GLOBALS["dbpassword"]);
	$this->writeString("dbadmuser", $GLOBALS["dbadmuser"]);
	$this->writeString("dbadmpassword", $GLOBALS["dbadmpassword"]);

	$this->writeString("bn_usersource", $GLOBALS["bn_usersource"]);

	$this->writeString("bn_body", $GLOBALS["bn_body"]);
	$this->writeString("bn_date_format", $GLOBALS["bn_date_format"]);
	$this->writeInt("bn_tz_offset", $GLOBALS["bn_tz_offset"]);
	$this->writeString("bn_font_face", $GLOBALS["bn_font_face"]);

	$this->writeInt("bn_view_reply", $GLOBALS["bn_view_reply"]);
	$this->writeInt("bn_no_toolbar", $GLOBALS["bn_no_toolbar"]);
	$this->writeInt("bn_no_thread_list", $GLOBALS["bn_no_thread_list"]);
	$this->writeInt("bn_no_nav_bar", $GLOBALS["bn_no_nav_bar"]);
	$this->writeInt("bn_list_post", $GLOBALS["bn_list_post"]);
	$this->writeInt("bn_list_no_nav_bar", $GLOBALS["bn_list_no_nav_bar"]);
	$this->writeInt("bn_no_thanks_msg", $GLOBALS["bn_no_thanks_msg"]);
	$this->writeString("bn_post_return", $GLOBALS["bn_post_return"]);

	$this->writeInt("bn_cookies", $GLOBALS["bn_cookies"]);
	$this->writeInt("bn_popup", $GLOBALS["bn_popup"]);
	$this->writeInt("bn_no_form_button_bar", $GLOBALS["bn_no_form_button_bar"]);
	$this->writeInt("bn_frames", $GLOBALS["bn_frames"]);
	$this->writeString("bn_frameset", $GLOBALS["bn_frameset"]);
	$this->writeString("bn_frame1", $GLOBALS["bn_frame1"]);
	$this->writeString("bn_frame2", $GLOBALS["bn_frame2"]);

	$this->writeString("bn_style", $GLOBALS["bn_style"]);
	$this->writeString("bn_header", $GLOBALS["bn_header"]);
	$this->writeString("bn_footer", $GLOBALS["bn_footer"]);
	$this->writeString("bn_list_vars", $GLOBALS["bn_list_vars"]);
	$this->writeString("bn_msgs", $GLOBALS["bn_msgs"]);
	$this->writeString("bn_form", $GLOBALS["bn_form"]);
	$this->writeString("bn_search_form", $GLOBALS["bn_search_form"]);
	$this->writeString("bn_template", $GLOBALS["bn_template"]);
	$this->writeString("bn_fields", $GLOBALS["bn_fields"]);
	$this->writeString("bn_before_access", $GLOBALS["bn_before_access"]);
	$this->writeString("bn_login_form", $GLOBALS["bn_login_form"]);
	$this->writeString("bn_register_form", $GLOBALS["bn_register_form"]);
	$this->writeString("bn_show_profile", $GLOBALS["bn_show_profile"]);
	$this->writeString("bn_change_form", $GLOBALS["bn_change_form"]);
	$this->writeString("bn_forgot_form", $GLOBALS["bn_forgot_form"]);
	$this->writeString("bn_mail_template", $GLOBALS["bn_mail_template"]);

	$this->writeInt("bn_search", $GLOBALS["bn_search"]);
	$this->writeString("bn_search_engine", $GLOBALS["bn_search_engine"]);
	$this->writeString("bn_search_path", $GLOBALS["bn_search_path"]);

	$this->writeInt("bn_file_upload", $GLOBALS["bn_file_upload"]);
	$this->writeString("MAX_FILE_SIZE", $GLOBALS["MAX_FILE_SIZE"]);
	$this->writeString("bn_allowed_extensions", $GLOBALS["bn_allowed_extensions"]);
	$this->writeString("bn_banned_extensions", $GLOBALS["bn_banned_extensions"]);
	$this->writeString("bn_allowed_mimetypes", $GLOBALS["bn_allowed_mimetypes"]);
	$this->writeString("bn_banned_mimetypes", $GLOBALS["bn_banned_mimetypes"]);

	$this->writeInt("bn_browse_server", $GLOBALS["bn_browse_server"]);
	$this->writeString("bn_browse_dir", $GLOBALS["bn_browse_dir"]);

	$this->writeInt("bn_mail", $GLOBALS["bn_mail"]);
	$this->writeInt("bn_user_mail", $GLOBALS["bn_user_mail"]);
	$this->writeInt("bn_mail_attachment", $GLOBALS["bn_mail_attachment"]);

	$this->writeInt("bn_modify", $GLOBALS["bn_modify"]);
	$this->writeInt("bn_delete", $GLOBALS["bn_delete"]);
	$this->writeInt("bn_thread", $GLOBALS["bn_thread"]);
	$this->writeInt("bn_allow_html", $GLOBALS["bn_allow_html"]);
	$this->writeString ("bn_banned_tags", $GLOBALS["bn_banned_tags"]);
	$this->writeString ("bn_allowed_tags", $GLOBALS["bn_allowed_tags"]);
	$this->writeInt("bn_use_smileys", $GLOBALS["bn_use_smileys"]);
	$this->writeInt("bn_auto_url", $GLOBALS["bn_auto_url"]);
	$this->writeString ("bn_banned_ips", $GLOBALS["bn_banned_ips"]);
}

} // end class
?>
