<?PHP

/*
 *	W-AGORA 4.0
 *	-----------
 *	$Id: mail.php,v 1.29 2002/06/05 08:37:02 mdruilhe Exp $
 *	Usage:		send message to users
 *	Author:		Marc Druilhe <mdruilhe@w-agora.net>
 *
 */

// Credits for this function goes to fwancho <fwancho@whc.net>
// It can be found at the URL: http://www.zend.com/codex.php?id=307&single=1
function rfcDate() {
	// Translated from imap-4.7c/src/osdep/unix/env_unix.c
	// env-unix.c is Copyright 2000 by the University of Washington
	// localtime() not available in PHP3...

	$tn = time(0);
	$zone = gmdate("H", $tn) * 60 + gmdate("i", $tn);
	$julian = gmdate("z", $tn);
	$t = getdate($tn);
	$zone = $t["hours"] * 60 + $t["minutes"] - $zone;

	// julian can be one of:
	//  36x  local time is December 31, UTC is January 1, offset -24 hours
	//    1  local time is 1 day ahead of UTC, offset +24 hours
	//    0  local time is same day as UTC, no offset
	//   -1  local time is 1 day behind UTC, offset -24 hours
	// -36x  local time is January 1, UTC is December 31, offset +24 hours
	if ($julian = $t["yday"] - $julian)
	{
		$zone += (($julian < 0) == (abs($julian) == 1)) ? -24*60 : 24*60;
   	};

	$zone_sign = ($zone > 0 ? "+" : "-");

	return date('D, d M Y H:i:s ', $tn).$zone_sign.sprintf("%02d%02d", abs($zone)/60, abs($zone)%60)." (".strftime("%Z").")"; 
}

/**
 * Short description.
 *
 * Detail description
 * @param	string	$to			receiver (Multiple recipients can be specified by putting a comma between each address)
 * @param	string	$subject	subject
 * @param	string	$body		message to send
 * @param	array	$headers	additional headers (eg. Bcc:, From: ...) 
 *								can be an associate array or a (properly formated header) string
 * @since	4.1.2
 * @access	public
 * @see		mail()
 * @return	void
 */
function send_mail (&$to, &$subject, &$body, &$headers) {
	global $bn_mail_return;

	$m_headers = '';

	if (is_array($headers)) {
		reset($headers);
	    while (list($k, $v) = each($headers) ) {
			if (!empty($v)) {
				$m_headers .= "$k: $v\r\n";
			}
	    }
	} else {
	    $m_headers = $headers;
	}
	// Set fully-compliant RFC 822 date
	$m_headers .= 'Date: '. rfcDate() . "\r\n";

	// add X-mailer
	$m_headers .= 'X-Mailer: PHP ' . phpversion() . '/' . wa_version() ."\r\n" ;

	// Content-Type will be added by mb_send_mail()
	if (!extension_loaded('mbstring')) {
	    // add Content-Type (set in globals.inc)
	    if (!empty($GLOBALS['bn_charset']) ) {
	        $m_headers .= 'Content-Type: text/plain; charset="' . $GLOBALS['bn_charset'] . "\"\r\n" ;
	    }
	}

	// add the "Return-Path" header
	if (!empty($bn_mail_return)) {
		$m_headers .= "Return-Path: <$bn_mail_return>\r\n";
		$m_headers .= "Errors-To: <$bn_mail_return>\r\n";
	}

	if (extension_loaded('mbstring')) {
	    // code conversion for japanese multibyte code mail
	    if (mb_detect_encoding($body) == mb_internal_encoding()) {
		if ($GLOBALS["debug"]) {
		    printf ("<br><b>mb_convert_encoding body form:</b><tt>%s<br></tt>", nl2br($body) );
		}
		$body = mb_convert_encoding($body, 'iso-2022-jp');
	    }
	    // mime encode for japanese multibyte subject
	    if (mb_detect_encoding($subject) == mb_internal_encoding()) {
		if ($GLOBALS["debug"]) {
		    printf ("<br><b>mb_encode_mimeheader Subject form:</b><tt>%s<br></tt>", nl2br($subject) );
		}
		$subject = mb_encode_mimeheader($subject);
	    }
	}

	if ($GLOBALS["debug"]) {
	    if (extension_loaded('mbstring')) {
		printf ("<br><b>mb_convert_encoding body form:</b><br><tt>%s<br>To: %s<br>Subject: %s<br><br>%s<br></tt>", nl2br(htmlspecialchars($m_headers)), $to, $subject, nl2br($body) );
	        // use mb_send_mail() for multibyte content.
		return mb_send_mail ($to, $subject, $body, $m_headers);
	    } else {
		return mail ($to, $subject, $body, $m_headers);
	    }
	} else {
	    // hide warnings
	    if (extension_loaded('mbstring')) {
	        // use mb_send_mail() for multibyte content.
		return @mb_send_mail ($to, $subject, $body, $m_headers);
	    } else {
		return @mail ($to, $subject, $body, $m_headers);
	    }
	}
} // end func


function mail_note (&$note) {
	global $ext, $bn_dir, $bn_dir_default, $bn_mail_template;
	global $site, $bn, $bn_title, $bn_base_url, $main_page, $db;
	global $bn_mail, $bn_user_mail, $bn_action, $owneraddress;

	if (empty($bn_mail_template) ) {
		include ("$bn_dir_default/mail_template.$ext");
	} else {
		include "$bn_dir/$bn_mail_template";
	}

# export all variables in the current scope
# -----------------------------------------
	reset ($note);
	while ( list( $var, $val ) = each( $note)) {
		if (is_string ($var)) {
			$$var = unkill_html(stripSlashes(my_br2nl(strip_url(strip_smileys($val)))));
		}
	}

# Set the subject properly
# ------------------------
	if (empty($subject)) {
		$tpl = str_replace('"', '\"', $mail_no_subject);
		eval ("\$m_subject = \"$tpl\";");
	} else {
		$re = FALSE;
		if (eregi ("^re: *", $subject) ) {
			// Strip "Re: " from subject in order to append it later in front of subject
			$subject = eregi_replace ("^re: *", "", $subject);
			$re = TRUE;
		}
		$tpl = str_replace('"', '\"', $mail_subject);
		eval ("\$m_subject = \"$tpl\";");
		if ($re) {
			$m_subject = "Re: " . $m_subject;
		}
	}

# Set the URL to reply to this email (can be used in template)
# ------------------------------------------------------------
	$reply_url     = "$bn_base_url/$main_page?site=$site&bn=$bn&action=view&key=$cle";
	$moderate_url  = "$bn_base_url/moderate_notes.$ext?site=$site&bn=$bn";
	$subscribe_url = "$bn_base_url/subscribe.$ext?site=$site&bn=$bn";

# Initialize the headers
# ----------------------
	// set Message-Id and reference : (will be used to handle posts via email)
	$parsed_url = parse_url($bn_base_url);
	$host = $parsed_url["host"];

	if ($mod_date>$unixdate) {
		$msgid = "$bn.$cle.$mod_date@$host";
	} else {
		$msgid = "$bn.$cle@$host";
	}

	$headers['Message-ID'] = "<$msgid>";

	if ($parent>0) {
		$headers['References'] = "<$bn.$parent@$host>";
	} elseif ($mod_date>$unixdate) {
		$headers['References'] = "<$bn.$cle@$host>";
	}

	// track IP of initial poster (take IP address from the note)
	$headers['X-Posting-Client'] = $ip;

# First send the mail to the main moderator of this forum
# -------------------------------------------------------
	if ($bn_mail || $hidden) {

		// Always set the "From:" header to the original sender for moderator
		if (!empty($useraddress) ) {
			$headers['From'] = (empty($username)) ? $useraddress : '"' . stripSlashes($username)."\" <$useraddress>";
		} else {
			$headers['From'] = $bn_mail_from;
		}

		if ($hidden) {
			$tpl = str_replace('"', '\"', $mail_approve_body);
		} elseif ($bn_action=="update") {
			$tpl = str_replace('"', '\"', $mail_update_body);
		} else {
			$tpl = str_replace('"', '\"', $mail_newpost_body);
		}

		eval ("\$m_body = \"$tpl\";");
		$rc = send_mail ($owneraddress, $m_subject, $m_body, $headers );
	}

	// set the "From:" header according to the configuration for the user subscribers
	if ( ($bn_send_user_address==1) && !empty($useraddress) ) {
		$headers['From'] = (empty($username)) ? $useraddress : '"' . stripSlashes($username)."\" <$useraddress>";
	} else {
		$headers['From'] = $bn_mail_from;
	}

	// set the "Reply-To" header
	if (!empty($bn_reply_to)) {
		$headers['Reply-To'] = $bn_reply_to;
	}

# send the mail to all users that subscribed to this forum/thread (only if not moderated)
# ---------------------------------------------------------------------------------------
	if ( $bn_user_mail && ($hidden!=1) ) {

		if ($parent > 0) {
			// if it is a reply get all thread subscribers
			$users = $db->getSubscribedUsers ($site, $bn, $thread);
		} else {
			// new message get only forum subscribers
			$users = $db->getSubscribedUsers ($site, $bn, 0);
		}

		if (is_array ($users)) {
			reset ($users);
			$user_list = implode (",", $users);

			// don't send twice to moderator
			if (!empty($owneraddress)) {
				$user_list = eregi_replace ("$owneraddress", "", $user_list);
			}
			// don't send to original sender (Should be optional ??? )
			if (!empty($useraddress)) {
				$user_list = eregi_replace ("$useraddress", "", $user_list);
			}
			$user_list = str_replace (',,', ',', $user_list);

			if ($bn_action=="update") {
				$tpl = str_replace('"', '\"', $mail_update_body);
			} else {
				$tpl = str_replace('"', '\"', $mail_newpost_body);
			}
			eval ("\$m_body = \"$tpl\";");

			$headers['Precedence'] = 'bulk';
			$headers['Bcc'] = $user_list;

			$m_to = (isset ($bn_mail_to) ) ? $bn_mail_to : '';

			$rc = send_mail ($m_to, $m_subject, $m_body, $headers);
		}
	}

}

function mail_password ($userid, $password, $useraddress ) {
	global $ext, $bn_dir, $bn_dir_default, $bn_mail_template;
	global $site, $bn, $bn_title, $bn_base_url, $main_page, $db;
	global $bn_mail, $bn_user_mail, $bn_action;

	if (empty($bn_mail_template) ) {
		include ("$bn_dir_default/mail_template.$ext");
	} else {
		include "$bn_dir/$bn_mail_template";
	}

	$ip = get_remote_ip();

	$change_password_url = "$bn_base_url/change_password.$ext?site=$site&userid=$userid";
	$login_url = "$bn_base_url/login.$ext?site=$site";

	$tpl = str_replace('"', '\"', $mail_password_subject);
	eval ("\$m_subject = \"$tpl\";");

	$tpl = str_replace('"', '\"', $mail_password_body);
	eval ("\$m_body = \"$tpl\";");

	// set the "From" and "Reply-To" header
	$headers['From'] = $bn_mail_from;
	if (!empty($bn_reply_to)) {
		$headers['Reply-To'] = $bn_reply_to;
	}

	$rc = send_mail($useraddress, $m_subject, $m_body, $headers );

}

function mail_profile ($userid, $password, &$user_fields, &$moderators) {
	global $ext, $bn_dir, $bn_dir_default, $bn_mail_template;
	global $site, $bn, $bn_title, $bn_base_url, $main_page, $db;
	global $bn_mail, $bn_user_mail, $bn_action;
	global $registered_forums, $forums_list;

	if (empty($bn_mail_template) ) {
		include ("$bn_dir_default/mail_template.$ext");
	} else {
		include "$bn_dir/$bn_mail_template";
	}

# export all variables in the current scope
# -----------------------------------------
	reset ($user_fields);
	while ( list( $var, $val ) = each( $user_fields)) {
		if (is_string ($var)) {
			if ($var != "password") {	// do not override with crypted password
				$$var = stripSlashes(my_br2nl($val));
			}
		}
	}

	$change_password_url = "$bn_base_url/change_password.$ext?site=$site&bn=$bn&userid=".urlencode($userid);
	$login_url = "$bn_base_url/login.$ext?site=$site&bn=$bn&loginuser=".urlencode($userid);
	$edit_user_url = "$bn_base_url/edit_user.$ext?site=$site&userid=".urlencode($userid);

# Send email to the user
# ----------------------
	if ($bn_action=="register") {
		$tpl = str_replace('"', '\"', $mail_register_subject);
		eval ("\$m_subject = \"$tpl\";");

		$tpl = str_replace('"', '\"', $mail_register_body);
		eval ("\$m_body = \"$tpl\";");

		// set the "From" and "Reply-To" header
		$headers['From'] = $bn_mail_from;
		if (!empty($bn_reply_to)) {
			$headers['Reply-To'] = $bn_reply_to;
		}

		$rc = send_mail($useraddress, $m_subject, $m_body, $headers );
	}

# Send email to the moderator(s)
# ------------------------------
	if (is_array ($moderators)) {
		if ($bn_action=="register") {
			$mail_subject = str_replace('"', '\"', $mail_approve_user_subject);
			$mail_body = str_replace('"', '\"', $mail_approve_user_body);
		} else {
			$mail_subject = str_replace('"', '\"', $mail_change_profile_subject);
			$mail_body = str_replace('"', '\"', $mail_change_profile_body);
		}

		$headers['From'] = $useraddress;

		eval ("\$m_subject = \"$mail_subject\";");
		eval ("\$m_body = \"$mail_body\";");

		reset ($moderators);
		$recipients = implode (",", $moderators);

		$rc = send_mail ($recipients, $m_subject, $m_body, $headers);
	}

}

function mail_users ($users, $subject, $body, $from="", $reply_to="") {
	global $ext, $bn_dir, $bn_dir_default, $bn_mail_template;
	global $site, $bn, $bn_title, $bn_base_url, $main_page, $db;
	global $bn_mail, $bn_user_mail, $bn_action;

	if (!is_array($users) ) {
	    return FALSE;
	}

	if (empty($bn_mail_template) ) {
		include ("$bn_dir_default/mail_template.$ext");
	} else {
		include "$bn_dir/$bn_mail_template";
	}

	// set the "From:" and "Reply-To:" header
	$headers['From'] = (empty($from) ) ? $bn_mail_from : $from;
	if (!empty($reply_to)) {
		$headers['Reply-To'] = $reply_to;
	} elseif (!empty($bn_reply_to)) {
		$headers['Reply-To'] = $bn_reply_to;
	}

	// set recipients : "To: " and "Bcc: " headers
	$m_to = (isset ($bn_mail_to) ) ? $bn_mail_to : "";
	reset ($users);
	$headers['Bcc'] = implode (",", $users);

	$m_subject = stripslashes($subject);
	$m_body = stripslashes($body);

	return send_mail ($m_to, $m_subject, $m_body, $headers);
}

?>
