<?php

/*
 *	W-AGORA 4.0
 *	-----------
 *	$Id: mysql.php,v 1.27 2002/06/10 17:41:35 mdruilhe Exp $
 *	Usage:	include file - Database access functions (mySQL)
 *	Author:	Marc Druilhe <mdruilhe@w-agora.com>
 */

if (!defined('_GLOBALS')) {
	die('Hacking attempt');
}

if (!defined("_MYSQL_ACCESS")) {
 define("_MYSQL_ACCESS", 1);

if (!defined("_DBACCESS")) {
	include ("$inc_dir/dbaccess.$ext");
}

class mysql_access extends DBaccess {

/* private: link and query handles */
var $site;
var $dbname;
var $dblink;
var $Query_ID;

var $Auto_Free     = 0;     ## Set to 1 for automatic mysql_free_result()


#	------------------------------------------------------------------
#	General Database access implementation (cf  : phplib)
#	Copyright (c) 1998,1999 SH Online Dienst GmbH
#	Boris Erdmann, Kristian Koehntopp
#	------------------------------------------------------------------

/* public: perform a query */
function query($Query_String) {

	if ($this->Query_ID) {
		@mysql_free_result($this->Query_ID);
		$this->Query_ID = 0;
	}

	if ($this->debug) {
		printf("Debug: query = %s<br>\n", $Query_String);
		flush();
	}

	$this->Query_ID = @mysql_db_query($this->dbname, $Query_String, $this->dblink);
	$this->Row   = 0;
	if (!$this->Query_ID) {
		$this->Errno = mysql_errno($this->dblink);
		$this->Error = mysql_error($this->dblink);
		$this->halt("Invalid SQL: ".$Query_String);
	}

	return $this->Query_ID;
}

/* public: walk result set */
function next_record() {
	$this->Record = @mysql_fetch_array($this->Query_ID, MYSQL_ASSOC);
	$this->Row   += 1;
	$this->Errno  = mysql_errno();
	$this->Error  = mysql_error();

	$stat = is_array($this->Record);
	if (!$stat && $this->Auto_Free) {
		@mysql_free_result($this->Query_ID);
		$this->Query_ID = 0;
	}
	return $stat;
}

/* public: position in result set */
function seek($pos = 0) {
	$status = @mysql_data_seek($this->Query_ID, $pos);
	if ($status)
		$this->Row = $pos;
	else
		$this->halt("seek($pos) failed: result has ".$this->num_rows()." rows");

	return;
}

function affected_rows() {
	return @mysql_affected_rows($this->dblink);
}

function num_rows() {
	return @mysql_num_rows($this->Query_ID);
}

function num_fields() {
	return @mysql_num_fields($this->Query_ID);
}

#	------------------------------------------------------------------
#				End of PHPLIB copyright
#	------------------------------------------------------------------

#	------------------------------------------------------------------
#				General database access functions
#	------------------------------------------------------------------


// mysql uses auto-increment fields
function nextId ($seqname, $table="") {
	return 0;
}

/**
 * return the auto-generated ID returned by the last INSERT query performed
 * @returns		the id of the last autoincremented field
 */
function lastId($seqname, $table="") {
	return mysql_insert_id ($this->dblink);
}

function openDB ($dbhost="", $dbport="", $dbuser="", $dbpassword="", $dbname="agora", $site="", $persistent=0) {

	if (!function_exists('mysql_connect') ) {
		$this->halt(sprintf (ERROR_DB_NOT_SUPPORTED, 'mysql'));
		return ERR_ACCESS;
	}

	if (!empty ($dbhost)) {
		$host = $dbhost;
		if (!empty ($dbport)) {
			$host .= ":$dbport";
		}
	}

	if ($persistent == 1) {
		$this->dblink = mysql_pconnect ($host, $dbuser, $dbpassword);
	} else {
		$this->dblink = mysql_connect ($host, $dbuser, $dbpassword);
	}

	if (empty($this->dblink)) {
		return -3;
	}

	if (!mysql_select_db ($dbname, $this->dblink)) {
		echo "mySQL error: ".mysql_errno().": ".mysql_error()."<BR>";
		return -3;
	}

	$this->dbname = $dbname;

	if (!empty ($site)) {
		$this->site = $site;
	}

	return 0;
}

function closeDB () {
	if (!empty($this->dblink)) {
		return mysql_close($this->dblink);
	}
	return TRUE;
}

function createTable ($table, $field_defs) {

	$tmp = $this->Halt_On_Error;
	$this->Halt_On_Error = "report";

# Check if table exists
# ---------------------
	$result = @mysql_List_Tables ($this->dbname);
	if (!$result) {
		echo "mySQL error: ".mysql_errno().": ".mysql_error()."<BR>";
		$this->Halt_On_Error = $tmp;
		return -3;
	}

	$count = mysql_NumRows ($result);
	$i=0;
	while ($i < $count) {
		if ($table == mysql_TableName ($result, $i)) {
			$this->Halt_On_Error = $tmp;
			return -1;	/*  table already exist */
		}
		$i++;
	}

# Create Table
# ------------
	if (!is_array ($field_defs)) {
		$this->Halt_On_Error = $tmp;
		return -4;
	}

	reset ($field_defs);
	while (list($col, $size) = each($field_defs)) {
		if (ereg ("^[0-9+]+$", $size) ) {
			if ($size>255) {
				$desc .= ", $col TEXT";
			} else {
				$desc .= ", $col VARCHAR($size) NOT NULL DEFAULT ''";
			}
		} else {
			$type = strtoupper($size);
			switch ($type) {
				case "INT":
					$desc .= ", $col INT NOT NULL DEFAULT 0";
					if ( ($col == "id") || ($col == "cle") ) {
						$desc .= ", PRIMARY KEY ($col)";
					}
					if ( ($col == "thread") || ($col=="parent") || ($col == "newest") ) {
						$desc .= ", KEY ($col)";
					}
					break;
				case "AUTO":
					$desc .= ", $col INT DEFAULT '0' NOT NULL AUTO_INCREMENT, KEY $col ($col)";
					break;
				default:
					$desc .= ", $col $type";
					break;
			}
		}
	}

	$desc = ereg_replace ("^, ", "", $desc);
	$ret = $this->query ("CREATE TABLE $table ($desc)");
	if (!$ret) {
		$this->Halt_On_Error = $tmp;
		return -3;
	}

	$this->Halt_On_Error = $tmp;
	return 0;
}

function updateTable ($table, &$fields, $where="") {

	if (!is_array ($fields) ) {
		echo "warning: updateTable(): item to update is not an array";
		return -3;
	}

 #	gets fields name and type from table
 #	------------------------------------
	$result = mysql_List_fields($this->dbname, $table, $this->dblink);
	if (!$result) { /* access problem */
		$this->halt("could not list fields from $table");
		return -3;
	}

	mysql_field_seek($result, 0);

#	build columns/values list (set all matching column names)
#	---------------------------------------------------------
	while ($db_field = mysql_fetch_field($result)) {
		$colname = $db_field->name;
		$coltype = $db_field->type;
		if (isset($fields[$colname])) {
			if ($coltype == "int") {
				$values .= ", $colname=" . intVal($fields[$colname]);
			} else {
				$val = addSlashes($fields[$colname]);
				$values .= ", $colname='$val'";
			}
		}
	}

	@mysql_free_result($result);

	$values = ereg_replace ("^, ", "", $values);

	if (empty($values) ) {
		echo "warning: updateTable(): no value to update";
		return -3;
	}

	$q = "UPDATE $table SET $values";
	if (!empty($where) ) {
		$q .= " WHERE $where";
	}

	$result = $this->query($q);
	if (!$result) {
		return -3;
	}
	return 0;

}

/**
 * drop a column (field) from the specified table
 *
 * @param	string	$table	the table where the field must be deleted
 * @param	string	$col	the name of the field
 * @since	4.1
 * @access	public
 * @see		addField
 * @return	void
 */
function dropField ($table, $name) {
	$this->query ("ALTER TABLE $table DROP COLUMN $col");
}

function insertRow ($table, &$fields) {

	if (!is_array ($fields) ) {
		echo "warning: insertRow(): item to insert is not an array";
		return -3;
	}

 #	gets fields name and type from table
 #	------------------------------------
	$result = mysql_List_fields($this->dbname, $table, $this->dblink);
	if (!$result) { /* access problem */
		$this->halt("could not list fields from $table");
		return -3;
	}

	mysql_field_seek($result, 0);

#	build columns/values list (set all matching column names)
#	---------------------------------------------------------
	$cols = "";
	$values = "";
	while ($db_field = mysql_fetch_field($result)) {
		$colname = $db_field->name;
		$coltype = $db_field->type;
		if (isset($fields[$colname])) {
			$cols .= ", $colname";
			if ($coltype == "int") {
				$values .= ", " . IntVal($fields[$colname]);
			} else {
				$val = addSlashes($fields[$colname]);
				$values .= ", '$val'";
			}
		}
	}

	if (empty($values) ) {
		echo "warning: insertRow(): no value to update";
		return -3;
	}

	$cols = ereg_replace ("^, ", "", $cols);
	$values = ereg_replace ("^, ", "", $values);

	$q = "INSERT INTO $table ($cols) VALUES($values)";

	if ($this->debug)
		printf("Debug: query = %s<br>\n", $q);

	$result = mysql_db_query($this->dbname, $q, $this->dblink);
	if (!$result) {
		echo "mySQL error: ".mysql_errno().": ".mysql_error()."<BR>";
		return -3;
	}
	@mysql_free_result($result);

	return 0;
}

/**
 * returns the latest registered user from the site user database
 *
 * @param	string 	$site		The site where to find the user
 * @returns	array	"userid"	The user's id
 *			"username"	The user's name
 *			"useraddress"	The user's email address
 */
function getNewestUser($site) {
	$result = @mysql_db_query ($this->dbname, "SELECT unixdate, userid, username, useraddress  FROM ${site}_users WHERE lastlogin>0 ORDER BY unixdate DESC limit 1", $this->dblink);
	if (!$result) return -3;
	list ($unixdate, $userid, $username, $useraddress) = @mysql_fetch_row ($result);
	$u = array ('userid' => $userid, 'username' => $username, 'useraddress' => $useraddress);
	return $u;
}

#	------------------------------------------------------------------
#				LOG / STATS functions
#	------------------------------------------------------------------


/**
 * Gets monthly statistics.
 *
 * @param	site	the site 
 * @param	year	the year (YYYY) facultative
 * @param	month	the month (1-12) facultative (if set, year must also be set)
 * @since	4.1.3
 * @access	public
 * @return	array		A double dimension array : $array[month][action] = count 
 *						where month as the form YYYYMM, and action 
 *						can be one value of view|insert|subscribe|login
 */
function getMonthlyStats ($site, $year='', $month='') {
	$log_table = $site.'_log';

	$query = "SELECT YEAR(datestamp) AS y, MONTH(datestamp) AS m, action, count(action) AS cnt FROM $log_table";
	
	if (!empty($year)) {
		$y = sprintf('%04d', $year);
	    $query .= " WHERE year(datestamp)='$y'";
		if (!empty($month)) {
			$m = sprintf('%02d', $month);
			$query .= " AND month(datestamp)='$m'";
		}
	}

	$query .= ' GROUP BY y, m, action';

	$this->query($query);
	while ($this->next_record()) {
		$m = sprintf ('%04d%02d', $this->Record['y'], $this->Record['m']);
		$action = $this->Record['action'];
		$stats[$m][$action] = (int) $this->Record['cnt'];
	}
	return $stats;
}

/**
 * Gets monthly visitors.
 *
 * Returns an array indexed by months with the number of distinct visitors 
 * @param	site	the site 
 * @since	4.1.3
 * @access	public
 * @return	array		An array of the form: $array[month] = visits where month as the form YYYYMM
 */
function getMonthlyVisitors ($site, $year='', $month='') {
	$log_table = $site.'_log';

	$query = "SELECT YEAR(datestamp) AS y, MONTH(datestamp) AS m, count(DISTINCT userid) as visits FROM $log_table";

	if (!empty($year)) {
		$y = sprintf('%04d', $year);
	    $query .= " WHERE year(datestamp)='$y'";
		if (!empty($month)) {
			$m = sprintf('%02d', $month);
			$query .= " AND month(datestamp)='$m'";
		}
	}

	$query .= ' GROUP BY y, m';
	$this->query($query);
	while ($this->next_record()) {
		$m = sprintf ('%04d%02d', $this->Record['y'], $this->Record['m']);
		$visits[$m] = (int) $this->Record['visits'];
	}
	return $visits;
}


#	------------------------------------------------------------------
#				Messages (notes) management functions
#	------------------------------------------------------------------

function listThreads ($forum, $first=0, $last=0, $where="", $expanded=1, $limit=0) {
	global $list_var;

	if (empty($forum)) {
		echo "DBaccess error: listThreads() : forum not defined";
		return -3;
	}

	settype ($first, "integer");
	settype ($last, "integer");
	settype ($limit, "integer");

#	1) gets total count # of notes satisfying the query
#	---------------------------------------------------
	$whereClause = "hidden=0";
	if (!empty($where)) {
		$whereClause .= " AND $where";
	}
	$result = mysql_db_query($this->dbname, "SELECT count(*) as total FROM $forum WHERE $whereClause", $this->dblink);
	if (!$result) {
		echo "mySQL error: ".mysql_errno().": ".mysql_error()."<BR>";
		return (-3);
	}

	$ret["total"] = @mysql_result ($result, 0, "total");
	if ($ret["total"] == 0) {
		return ($ret);
	}
	mysql_FreeResult($result);

#	2) Find the first (and last) thread to be displayed in the page
#	and gets number of notes per thread
#	----------------------------------------------------------------
	if (!$last) {
		$order="DESC";
		$last=1;
	} else {
		$order="ASC";
	}

	$whereClause = "WHERE hidden=0 AND newest>=$last"; // $last default to 1: don't display hidden notes
	if ($first>0) {
		$whereClause .= " AND newest<=$first";
	}

	if (!empty($where)) {
		$whereClause .= " AND $where";
	}

# Set # of threads to be returned
# -------------------------------
	$limitClause = (empty($limit)) ? "" : "LIMIT $limit";

	$query = "SELECT thread, newest, count(*) FROM $forum $whereClause GROUP BY thread ORDER BY newest $order $limitClause";
if ($this->debug) printf("Debug: query = %s<br>\n", $query);
	$result = mysql_db_query($this->dbname, "$query", $this->dblink);
	$tcount = @mysql_num_rows ($result);

	if ($tcount > 0) {
		if ($order=="DESC") {
			$tfirst  = @mysql_result ($result, 0, "newest");
			$tlast = @mysql_result ($result, $tcount-1, "newest");
		} else {
			$tlast  = @mysql_result ($result, 0, "newest");
			$tfirst = @mysql_result ($result, $tcount-1, "newest");
		}

		mysql_data_seek($result, 0);
		$whereClause = "WHERE thread IN (";
		$ncount=0;
		while ($row = mysql_fetch_row($result)) {
			$t = $row[0];
			$whereClause .= "$t,";
			$replies[$t] = $row[2] - 1;
			$ncount += $row[2];
		}
		$whereClause = ereg_replace (",$", ")", $whereClause);
	}
	mysql_FreeResult($result);

	$ret["notes"]=$ncount;		// number of notes displayed
	$ret["threads"]=$tcount;	// number of threads displayed
	$ret["first"]=$tfirst;
	$ret["last"]=$tlast;

	if ($tcount < 1) {
		$ret["next"] = 0;
		$ret["prev"] = 0;
		return $ret;
	}
	
#	3) gets all threads
#	-------------------
	// $whereClause = "WHERE newest<=$tfirst AND newest>=$tlast";
	if (!empty($where) ) {
		$whereClause .= " AND $where";
	}

	if ($expanded == 1) {
		$limitClause = "LIMIT $ncount";
	} else {
		$whereClause .= " AND parent=0";
		$limitClause = "LIMIT $tcount";
	}

	$cols = "cle,parent,childs,thread,newest";
	reset($list_var);
	while (list($var,$val) = each($list_var)) {
		if ($val==1) $cols.=",$var";
	}

	$query = "SELECT $cols FROM $forum $whereClause ORDER BY newest DESC,unixdate ASC $limitClause";
if ($this->debug) printf("Debug: query = %s<br>\n", $query);
	$result = mysql_db_query($this->dbname, $query, $this->dblink);
	if (!$result) {
		echo "mySQL error: ".mysql_errno().": ".mysql_error()."<BR>";
		return (-3);
	}

	reset ($this->entries);
	reset ($this->children);
	if (isset($this->children[0]) ) {
		unset($this->children[0]);
	}

	while ($row = mysql_fetch_array($result, MYSQL_ASSOC)) {
		$key = (int) $row["cle"];
		$parent = (int) $row["parent"];
		if ($parent==0) {
			$row["replies"] = $replies[$key];
		}
		$this->entries[$key] = $row;
		$this->children[$parent][] = $key;
	}
	mysql_FreeResult($result);
	
#	4) gets next/previous count
#	---------------------------
	$whereClause = "WHERE hidden=0 AND newest>$tfirst";
	if (!empty($where)) {
		$whereClause .= " AND $where";
	}
	$result = mysql_db_query($this->dbname, "SELECT count(*) AS prev FROM $forum $whereClause", $this->dblink);
	if (!$result) {
		echo "mySQL error: ".mysql_errno().": ".mysql_error()."<BR>";
		return (-3);
	}
	$ret["prev"]  = @mysql_result ($result, 0, "prev");
	mysql_FreeResult($result);

	$whereClause = "WHERE hidden=0 AND newest<$tlast";
	if (!empty($where)) {
		$whereClause .= " AND $where";
	}
	$result = mysql_db_query($this->dbname, "SELECT count(*) AS next FROM $forum $whereClause", $this->dblink);
	if (!$result) {
		echo "mySQL error: ".mysql_errno().": ".mysql_error()."<BR>";
		return (-3);
	}
	$ret["next"]  = @mysql_result ($result, 0, "next");

	mysql_FreeResult($result);	
	return $ret;
}

function listNotes ($forum, $first=0, $last=0, $sort="", $where="", $limit) {
	global $list_var;

	if (empty($forum)) {
		echo "DBaccess error: listNotes() : forum not defined";
		return -3;
	}

	settype ($first, "integer");
	settype ($last, "integer");
	settype ($limit, "integer");

#	1) gets total count # of notes satisfying the query
#	---------------------------------------------------
	// skip administrative note (old format)
	// don't skip hidden notes (listed in moderate_notes.php)
	$whereClause = "WHERE cle<>0";
	if (!empty($where)) {
		$whereClause .= " AND $where";
	}
	$result = mysql_db_query($this->dbname, "SELECT count(*) as total FROM $forum $whereClause", $this->dblink);
	if (!$result) {
		echo "mySQL error: ".mysql_errno().": ".mysql_error()."<BR>";
		return -3;
	}

	$ret["total"] = @mysql_result ($result, 0, "total");
	if ($ret["total"] == 0) {
		return $ret;
	}
	mysql_FreeResult($result);

#	2) gets all notes sorted by $sort
#	---------------------------------
	$whereClause = "WHERE cle>0"; // skip administrative record
	if (!empty($where)) {
		$whereClause .= " AND $where";
	}
	
	$orderClause = (empty ($sort)) ? "ORDER BY unixdate DESC" : "ORDER BY $sort";
	
# Set first thread and # of threads to be returned
# ------------------------------------------------
	if ($limit>0) {
		if ($last > 0) {
			$start = ($last-$limit)+1;
			$start = ($start<0) ? 0 : $start;
		} else {
			$start = $first;
		}
		$limitClause = "LIMIT $start, $limit";
	} else {
		$start=0;
		$limitClause="";
	}
		
	$cols = "cle,parent,childs,thread,newest";
	reset($list_var);
	while (list($var,$val) = each($list_var)) {
		if ($val==1) $cols.=",$var";
	}

	$query = "SELECT $cols FROM $forum $whereClause $orderClause $limitClause";
	$result = mysql_db_query($this->dbname, "$query", $this->dblink);
	if (!$result) {
		echo "mySQL error: ".mysql_errno().": ".mysql_error()."<BR>";
		return (-3);
	}

	reset ($this->entries);
	reset ($this->children);
	$tcount=0;
	while ($row = mysql_fetch_array($result, MYSQL_ASSOC)) {
		$key = $row["cle"];
		$row["parent"]=0;
		$this->entries[$key] = $row;
		$this->children[0][] = $key;
		$tcount++;
	}
	mysql_FreeResult($result);

	$ret["notes"] = $tcount;
	$ret["threads"] = $tcount;
	$ret["first"] = $start;
	$ret["last"] = $start + $tcount - 1;

#	3) set next/previous (1 if TRUE)
#	--------------------------------
	$ret["next"] = ($ret["total"] > $ret["last"]+1) ? 1 : 0;
	$ret["prev"] = ($ret["first"] > 1) ? 1 : 0;
	
	return $ret;
}

}; // end class

} // defined MYSQL_ACCESS
?>
