<?php

/*
 *	W-AGORA 4.0
 *	-----------
 *	$Id: init.inc,v 1.70 2002/06/05 16:45:14 mdruilhe Exp $
 *	Usage:		Initialization file
 *	Author:		Marc Druilhe <mdruilhe@w-agora.com>
 */

require ("globals.inc");
// override cookie (take out $lang from URL)
if (isset($HTTP_GET_VARS['lang']) ) {
	$lang = $HTTP_GET_VARS['lang'];
	// echo "get: $lang";
} elseif (isset($HTTP_COOKIE_VARS['lang'])) {
	$lang = $HTTP_COOKIE_VARS['lang'];
	// echo "cookie: $lang";
} elseif (isset($HTTP_ACCEPT_LANGUAGE) ) {
	$lang = substr($HTTP_ACCEPT_LANGUAGE, 0, 2);
}

$lang = strtolower($lang);
if (!empty($lang) && file_exists("$lang_dir/lang_$lang.inc") ) {
	if (!isset($HTTP_COOKIE_VARS['lang']) || ($lang != $HTTP_COOKIE_VARS['lang']) ) {
		setcookie ('lang', $lang, 0, '/');
	}
} else {
	$lang = "ja";
	// echo "defaut: $lang"; 
}

require ("$lang_dir/lang_$lang.inc");


# display the headers and include the header file if required
# ----------------------------------------------------------
function display_header ($title='', $include_header) {
	global $WA_SELF, $bn_action, $site, $bn, $bn_dir, $bn_dir_default, $bn_header, $bn_body, $frameset;
	global $cat_id, $cat_title, $site_title, $bn_title, $bn_style, $bn_frames, $bn_popup, $bn_browse_server, $lynx, $bn_charset;
	global $bn_search, $main_page, $ext, $auth, $is_authenticated, $db, $bn_date_format;
	global $login_string, $login_user;
	global $admin_url, $admin_text, $admin_link;
	global $list_url, $list_text, $list_link;
	global $post_url, $post_text, $post_link;
	global $search_url, $search_text, $search_link;
	global $login_url, $login_text, $login_link;
	global $register_url, $register_text, $register_link;
	global $profile_url, $profile_text, $profile_link;
	global $subscribe_url, $subscribe_text, $subscribe_link;
	global $download_forum_url, $download_forum_text, $download_forum_link;
	global $forum_list_url, $forum_list_text, $forum_list_link;
	global $choose_forum_box, $choose_forum_form;
	global $bn_win_width, $bn_win_height;
	global $forum, $site_stats, $totalnotes;

	if (empty($frameset)) {
		echo '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">';
		printf ("<HTML>\n<HEAD>\n<TITLE>%s%s%s</TITLE>\n", strip_tags($bn_title),
			(empty($bn_title) || empty($title)) ? '' : " - ", strip_tags($title));
		printf ("<META NAME=\"GENERATOR\" Content=\"%s\">\n", wa_version() );

		if (!empty($bn_charset)) {
			printf ("<META http-equiv=\"Content-Type\" Content=\"text/html; charset=%s\">\n", $bn_charset);
		}

		if ( ($bn_popup == 1) || ($bn_browse_server==1) ):
?>
<SCRIPT type="text/javascript" language="JavaScript">
<!-- // Hide for old browsers
  var newWindow = null;
 function OpenWindow (Url,Title, Width, Height) {
  var win_opt= "toolbar=0,location=0,directories=0,status=0,menubar=0,";
  win_opt += "scrollbars=1,resizable=1,copyhistory=0,";
  win_opt += "width=" + Width + ",height=" + Height;
  newWindow = window.open('',Title,win_opt);
  if (newWindow != null) {
    if (newWindow.opener == null)
      newWindow.opener = self;
    newWindow.location.href = Url;
    if (newWindow.focus) newWindow.focus();
  }
 }
 // End of script -->
</SCRIPT>
<?PHP
		endif;

		if (!empty($bn_style) && file_exists ("$bn_dir/$bn_style")) {
			echo "<!-- STYLE -->\n";
			include "$bn_dir/$bn_style";
		} elseif (file_exists ("$bn_dir_default/style.$ext") ) {
			include "$bn_dir_default/style.$ext";
		}

		printf ("</HEAD>\n<BODY %s>\n", $bn_body);

	}

	if ($include_header) {
		echo "<!-- HEADER -->\n";
		if (!empty($bn_header) && file_exists ("$bn_dir/$bn_header") ) {
			include "$bn_dir/$bn_header";
		} elseif (file_exists ("$bn_dir_default/header.$ext")) {
			include ("$bn_dir_default/header.$ext");
		}
	}
}

# include the footer file if required and display the HTML footer
# ---------------------------------------------------------------
function display_footer($include_footer) {
	global $WA_SELF, $bn_action, $site, $bn, $bn_dir, $bn_dir_default, $bn_footer, $bn_body, $frameset;
	global $cat_id, $cat_title, $site_title, $bn_title, $bn_style, $bn_frames, $bn_popup, $lynx;
	global $bn_search, $main_page, $ext, $auth, $is_authenticated, $db, $bn_date_format;
	global $list_url, $list_text, $list_link;
	global $post_url, $post_text, $post_link;
	global $search_url, $search_text, $search_link;
	global $login_url, $login_text, $login_link;
	global $register_url, $register_text, $register_link;
	global $profile_url, $profile_text, $profile_link;
	global $subscribe_url, $subscribe_text, $subscribe_link;
	global $choose_forum_box, $choose_forum_form;

	if ($include_footer) {
		echo "<!-- FOOTER -->\n";
		if (!empty($bn_footer) && file_exists("$bn_dir/$bn_footer") ) {
			include "$bn_dir/$bn_footer";
		} elseif (file_exists ("$bn_dir_default/footer.$ext")) {
			include ("$bn_dir_default/footer.$ext");
		}
	}

	if (!isset($frameset)) {
		echo "</BODY>\n</HTML>\n";
		exit;
	}
}

# include general purpose functions
# ---------------------------------
	require ("$inc_dir/misc_func.$ext");

# --------------------------------------
# Initialize configuration file and site
# --------------------------------------
	if (empty($bn)) {
# No forum selected -> default to 'site' configuration
		$site = empty($site) ? "agora" : $site;
		$site_cfg_file = "${cfg_dir}/site_${site}.$ext";
		$cfg_file = $site_cfg_file;
		$expnd = "all";
	} else {
		$bn=trim(basename($bn));
		$site = strtok($bn, "_");
		$site_cfg_file = "${cfg_dir}/site_${site}.$ext";
		$cfg_file = "${cfg_dir}/${bn}.${ext}";
	}

# read configuration for this forum
# ---------------------------------
	if (file_exists ("${cfg_file}")) {
		include ("$cfg_file");
	} else {
		MsgWarning ("Cannot access configuration file: $cfg_file", "$main_page?site=$site");
		exit;
	}

# Change default directory if $theme variable is set
# --------------------------------------------------
	if (isset($HTTP_GET_VARS['theme']) ) {
		$theme = $HTTP_GET_VARS['theme'];
	} elseif (isset($HTTP_COOKIE_VARS['theme'])) {
		$theme = $HTTP_COOKIE_VARS['theme'];
	}

	if (isset($theme) && is_dir("$bn_dir_default/$theme") ) {
	    $bn_dir_default = "$bn_dir_default/$theme";
		if (!isset($HTTP_COOKIE_VARS['theme']) || ($lang != $HTTP_COOKIE_VARS['theme']) ) {
			setcookie ('theme', $theme, 0, '/');
		}
	}

	if ($lynx==1) {
		$bn_frames = 0;
		$bn_popup = 0;
	}

# Set current date
# ----------------
	$formated_date = date ("$bn_date_format", $now+($bn_tz_offset*3600) );

# ------------------------------------------
# Include forum specific configuration files
# ------------------------------------------

# --------
# messages
# --------
	if (empty($bn_msgs) ) {
		// override cookie (take out $lang from URL)
		if (isset($lang) && file_exists("$bn_dir_default/msgs_${lang}.$ext") ) {
			include ("$bn_dir_default/msgs_${lang}.$ext");
		} else {
			include ("$bn_dir_default/msgs.$ext");
		}
	}else {
		if (isset($lang) && file_exists("$bn_dir/msgs_${lang}.$ext") ) {
			include "$bn_dir/msgs_${lang}.$ext";
		} else {
			include "$bn_dir/$bn_msgs";
		}
	}

# -----------------
# fields definition
# -----------------

# loads customized fields
# --------------------------
	if (empty($bn_fields) ) {
		include ("$bn_dir_default/fields.$ext");
	} else {
		include "$bn_dir/$bn_fields";
	}

# Set core variables (managed by w-agora)
# ---------------------------------------
	if (isset($bn_var)) {
		unset ($bn_var);
	}

	$bn_var = array (
		'unixdate',		// timestamp (creation date)
		'userid',		// user ID
		'mod_date',		// modification date
		'mod_userid',	// userid of modifier
		'password',		// MD5 encoded password
		'filename',		// name of HTML note
		'att_size',		// total attachments size
		'mail_reply',	// set to '1' if replies to this note must be sent by email
		'hidden',		// set to 1 if note must be approved by the moderator
		'hits',			// hits count
		'closed',		// closed thread (RFU)
		'ip'			// logged IP address of sender
	);

# force w-agora variables to be listed
# ------------------------------------
	reset ($bn_var);
	while ( list(, $var) = each($bn_var) ) {
		$list_var[$var] = 1;
	}

# listing outline
# ---------------
	if (empty($bn_list_vars) ) {
		include ("$bn_dir_default/list.$ext");
	} else {
		include "$bn_dir/$bn_list_vars";
	}
	$bn_hot_threshold = (isset($bn_hot_threshold) ) ? (integer) $bn_hot_threshold : 15;

# Note template
# -------------
	if (!empty($bn_template) ) {
		include "$bn_dir/$bn_template";
	} elseif (file_exists ("$bn_dir_default/template.$ext") ) {
		include ("$bn_dir_default/template.$ext");
	}

# Define labels associated with the different values
# --------------------------------------------------
	$user_states =array(
		'0' => USER_STATE_LOCKED,
		'1' => USER_STATE_ACTIVE,
		'P' => USER_STATE_PENDING
	);

	$forum_types['pub'] = FORUM_TYPE_PUBLIC;
	$forum_types['reg'] = FORUM_TYPE_REGISTERED;
	$forum_types['rest'] = FORUM_TYPE_RESTRICTED;
	$forum_types['priv'] = FORUM_TYPE_PRIVATE;

	$forum_states = array (
		'0' => FORUM_STATE_INACTIVE,
		'1' => FORUM_STATE_ACTIVE,
		'L' => FORUM_STATE_LOCKED,
		'C' => FORUM_STATE_CLOSED
	);

# Include Database access then connect
# ------------------------------------
	require ("$inc_dir/$bn_access.$ext");
	$db_class = "${bn_access}_access";
	$db = new $db_class;
	$ret = $db->openDB($dbhost, $dbport, $dbuser, $dbpassword, $dbname, $site);
	if ($ret < 0) {
		msgForm (msg(6), "$main_page", '');
		exit;
	}

	$db->setDebug($debug);

# -----------------------
# gets forum informations
# -----------------------
	if (empty($bn)) {
		// default site parameters
		if ($site=="agora" ) {
			$forum = array ( "state" =>"1", "type" =>"pub", "bn_title" => "agora sites database");
		} else {
			$agora_dbparam = getDBaccess("$cfg_dir/site_agora.$ext");
			$agora_access = $agora_dbparam["bn_access"];
			$agora_dbhost = $agora_dbparam["dbhost"];
			$agora_dbname = $agora_dbparam["dbname"];
			if ($agora_access!= $bn_access) {
				include ("$inc_dir/$agora_access.$ext");
			}
			if ( ($agora_access != $bn_access) || ($agora_dbname != $dbname) || ($agora_dbhost != $dbhost) ) {
				$db_class = "${agora_access}_access";
				$agora_db = new $db_class;
				$db->closeDB();
				$ret = $agora_db->openDB($agora_dbhost, $agora_dbparam["dbport"], $agora_dbparam["dbuser"], $agora_dbparam["dbpassword"], $agora_dbname, "agora");
				$forum = $agora_db->getForum("agora", $site);
				$agora_db->closeDB();
				$ret = $db->openDB($dbhost, $dbport, $dbuser, $dbpassword, $dbname, $site);
			} else {
				$forum = $db->getForum("agora", $site);
			}

			if (!is_array($forum)) {
				// bypass the error if "agora" not found in the site database
				$forum = array ( 'state'=>'1', 'type'=>'rest', 'bn_title'=>"$site");
			}
		}
	} else {
		$forum = $db->getForum($site, $bn);
		if (!is_array($forum)) {
			msgForm ("could not access forum '$bn' in this site: '$site'", "$WA_SELF?site=$site", "back");
			exit;
		}
	}

# extract useful variables from forum infos read from the database
# ----------------------------------------------------------------
	$owneraddress = $forum['owneraddress'];
	$ownername = $forum['ownername'];
	$bn_title = $forum['bn_title'];
	$bn_db = $forum['bn_db'];
	$totalthreads = $forum['totalthreads'];
	$totalnotes = $forum['totalnotes'];

	$categories = $db->getCategories($site);
	$site_title = $categories[0];
	$cat_id = (isset($cat)) ? $cat : $forum['cat_id'];
	$cat_title = $categories[$cat_id];

# don't display header and footer in frameless mode, nor in the popup
# -------------------------------------------------------------------
	if (empty($popup) ) {
		$header_footer = ($bn_frames==0) ? true : false;
	} else {
		$header_footer = ( ($bn_popup==0) && ($bn_frames==0) ) ? true : false;
	}

# We authenticate the user in all cases in order to set the $auth object
#   (so that we can later know if he is a moderator)
# ----------------------------------------------------------------------
	$usersource = (empty($bn_usersource) )  ? 'agora_user' : $bn_usersource;
	include ("$user_dir/$usersource.$ext");
	$auth_class = "${usersource}_source";
	$auth = new $auth_class;

# force user to re-login if required
# ----------------------------------
	if (isset($force_login)) {
		$auth->logout($site);
		display_header ('login', $header_footer);
		$auth->login($site);
		exit;
	}

# -------------------------------------------
# Authenticate the user and check permissions
# -------------------------------------------
	$is_authenticated = $auth->authenticate();
	$check_perm = $auth->havePermission ($bn, $bn_action_mode);
	$login_user = $auth->user['userid'];

# -----------------------------------------------------------------------------------
#	Now we check the type access to this forum and authenticate the user
# -----------------------------------------------------------------------------------
	$check_auth = false;
	$haveperm = true;

	if (!defined('no_auth_required')) {
		switch ($forum['type']) {

		  // registered forum : need to be authenticated to post
		  case 'reg':
			if ($bn_action_mode=='W') {
				$check_auth=true;
				$haveperm = $is_authenticated;
			}
			break;

		  // restricted forum : check permission on this forum for this user
		  case 'rest':
			if ($bn_action_mode=='W') {
				$check_auth=true;
				$haveperm = $check_perm;
			}
			break;

		  // private forum : must be authenticated to access (read/write/list)
		  case 'priv':
			$check_auth=true;
			$haveperm = $check_perm;
			break;

		  default:
			$check_auth=false;
			break;
		}
	}

# Check if the current user is logged in as moderator for later usage
# -------------------------------------------------------------------
	$is_root = ($auth->level > ADMIN) ? true : false;
	$is_administrator = ($auth->level >= ADMIN) ? true : false;
	$is_moderator = ($is_administrator || (is_array($auth->privs) && ($auth->privs['modpriv'] == 1))) ? true : false;

# Allowed options for a moderator
# -------------------------------
	if ($is_moderator) {
		$bn_modify = 1;
		$bn_delete = 1;
		$bn_file_upload = 1;
		if (is_array($bn_html_var) ) {
			$bn_allow_html = 1;
		}
	}

	if ($is_root) {
		$bn_browse_server = 1;
	}

# set the URL variables
# ---------------------

	$target_frame = ($bn_frames && ($bn_action=='header') ) ? 'main' : '';
	$parent_frame = ($bn_frames==1 ) ? '_parent' : '';

	// LIST
	$list_url = "list.$ext?site=$site&bn=$bn";
	$list_text = msg(61, 'list');
	$list_link = anchor ($list_url, $target_frame, $list_text, msg(157, 'list messages'), $link_class );

	// POST
	$post_text = msg(62, 'post');

	if ( ($bn_action=='list') && $bn_list_post && ($forum['type']=='pub' || $auth->havePermission($bn, 'W')) ) {
		$post_url = '#FORM';
		$post_link = anchor ($post_url, '', $post_text, msg(158, 'post a new message'), $link_class);
	} elseif ($bn_popup) {
		$post_url = "post.$ext?bn=$bn";
		$post_link = anchorWindow ($post_url, $post_text, msg(158, 'post a new message'), $bn_win_width, $bn_win_height, $link_class);
	} else {
		$post_url = "post.$ext?bn=$bn";
		$post_link = anchor ($post_url, $target_frame, $post_text, msg(158, 'post a new message'), $link_class);
	}

	// SEARCH
	if ($bn_search) {
		$search_url = (empty($bn)) ? "search.$ext?site=$site" : "search.$ext?bn=$bn";
		$search_text = msg(63, 'search');
		$search_link = anchor ($search_url, $target_frame, $search_text, msg(27, 'search in forum'), $link_class );
	} else {
		$search_url = '';
		$search_text = '';
		$search_link = '';
	}

	// DOWNLOAD
	$download_forum_url = "download_forum.$ext?bn=$bn";
	$download_forum_text = msg(151, "download forum");
	$download_forum_link = anchor ($download_forum_url, $target_frame, $download_forum_text, msg(159,"download complete forum"), $link_class );

	// FORUM LIST
	$forum_list_url = "$main_page?site=$site&bn=";
	$forum_list_text = msg(152, "forum list");
	$forum_list_link = anchor ($forum_list_url, $parent_frame, $forum_list_text, msg(160, "back to the forum list"), $link_class );

	// LOGIN
	$login_url = "login.$ext?site=$site&bn=$bn";
	$login_text = msg(153, 'login');
	$login_link = anchor ($login_url, $target_frame, $login_text, msg(161, "login into $site"), $link_class );

	// LOGOUT
	$logout_url = "logout.$ext?site=$site&bn=$bn";
	$logout_text = msg(xx, 'logout');
	$logout_link = anchor ($logout_url, $target_frame, $logout_text, msg(xx, "logout from $site"), $link_class );

	// REGISTER
	$register_url = "register.$ext?site=$site&bn=$bn";
	$register_text = msg(154, 'register');
	$register_link = anchor ($register_url, $target_frame, $register_text, msg(162,"register as a new user"), $link_class );

	// PROFILE + SUBSCRIBE
	$profile_url = "profile.$ext?site=$site&bn=$bn";
	$profile_text = msg(155, 'profile');
	$profile_link = '';
	$subscribe_url = "subscribe.$ext?site=$site&bn=$bn";
	$subscribe_text = msg(156, 'subscribe');
	$subscribe_link = '';
	if ( $is_authenticated || ($bn_action=='header') ) {
		$profile_link = anchor ($profile_url, $target_frame, $profile_text, msg(163,"Change your profile"), $link_class );
		if ($bn_user_mail) {
			$subscribe_link = anchor ($subscribe_url, $target_frame, $subscribe_text, msg(164,"Subscribe to the mailing list"), $link_class );
		}
	}

	// ADMIN ACCESS
	if ($auth->level >= MODER) {
		$admin_url = "admin.$ext?site=$site&bn=$bn";
		$admin_text = LABEL_ADMIN;
		$admin_link = anchor ($admin_url, $parent_frame, $admin_text, ALT_ADMIN_SITE, $link_class );
	}

# Get newest user and site statistics
# -----------------------------------
	if (empty($bn) ) {
		$newestuser = $db->getNewestUser($site);
		if (is_array($newestuser)) {
			// extract $site_newest_userid, $site_newest_username, $site_newest_useraddress
			extract ($newestuser, EXTR_PREFIX_ALL, 'site_newest');

			// make blanks unbreakable to ease formatting
			$site_newest_username = str_replace (' ', '&nbsp;', $site_newest_username);

			// for compatibility
			$site_newestuser = $site_newest_userid;
		}
		$site_stats = $db->getSiteStats ($site);
		$site_totalforums = $site_stats['totalforums'];
		$site_totalthreads = $site_stats['totalthreads'];
		$site_totalnotes = $site_stats['totalnotes'];
		$site_totalusers = $site_stats['totalusers'];
		$site_totalfiles = $site_stats['totalfiles'];
		$site_totalfilesize = $site_stats['totalfilesize'];
	}

# set Select box with forums
# --------------------------
	$forums = $db->getForums($site);
	if (is_array($forums) && count ($forums)>1) {
		$forums[''] = '-- ' . msg(160, '--- $cat_title');
		$choose_forum_box = getListBox ('bn', $forums, $bn, 0, "window.location=('list.$ext?site=$site&bn='+this.options[this.selectedIndex].value)");
		$choose_forum_form = "<form action='list.$ext'><input type='hidden' name='site' value='$site'>".LABEL_JUMP_TO.": $choose_forum_box <input type=submit value='".LABEL_GO."'></form>";
	}

# Check if this forum is active so we can read/post
# ----------------------------------------------------
	if (!$is_moderator) {
		if ($forum['state']=='0') {
			display_header ('', $header_footer);
			unset ($bn);
		 	msgForm (msg(84, 'Sorry, this forum is temporary unavailable, please try later or contact the moderator'), $main_page, 'close');
			display_footer ($header_footer);
		} elseif ( (($forum['state'] =='C') || ($forum['state']=='L')) && ($bn_action_mode=='W')) {
			display_header ('', $header_footer);
			if ($forum['state'] =='C')	msgForm (msg(186, 'Sorry, this forum is now closed, posts are not allowed, please post your message in another forum or contact the moderator'), 'list.$ext', 'close');
			else				msgForm (msg(85, "Sorry, due to maintenance reason, posts to this forum are temporarily restricted, please try later or contact the moderator"), "list.$ext", 'close');

			display_footer ($header_footer);
		}
	}

# Check authentication if required
# --------------------------------
	if ($check_auth) {
		if ($is_authenticated) {
# user is authenticated, we check permissions & exit if is not authorized
			if (!$haveperm ) {
				display_header ('authentication', $header_footer);
				msgForm (msg(86, "Sorry, You do not have permission, to access this forum. Please contact the administrator"), "list.$ext?site=$site&bn=", 'close');
				display_footer ($header_footer);
			} elseif ($auth->privs['state'] == "P") {
				display_header ('authentication', $header_footer);
				msgForm (msg(87, "Sorry, Your account has not yet been approved, please contact the <a href='mailto:$owneraddress'>moderator of this forum</a>"), "list.$ext?site=$site&bn=", 'close');
				display_footer ($header_footer);
			} elseif ($auth->privs['state'] == "L") {
				display_header ('authentication', $header_footer);
				msgForm (msg(88, "Sorry, Your account is currently locked, please contact the <a href='mailto:$owneraddress'>moderator of this forum</a>"), "list.$ext?site=$site&bn=", 'close');
				display_footer ($header_footer);
			}
		} else {
# user is not authenticated
			$loginURL = $auth->getLoginURL();
			if (is_string($loginURL)) {
				header("Location: $loginURL");
			} else {
				display_header ('login', $header_footer);
				$auth->login($site);
				display_footer ($header_footer);
			}
		}
	}

# initialize and send cookies if cookies option is set
# ----------------------------------------------------
	if (($bn_cookies==1) && !isset($no_cookie)) {
		include ("$inc_dir/cookies.$ext");
	}

# force browser, proxies to refresh the page if required
# ------------------------------------------------------
	if (isset($force_refresh)) {
		// send headers to force expiration
		header("Expires: Mon, 2 Aug 1999 05:00:00 GMT"); // Date in the past
		header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT"); // always modified
		header("Cache-Control: no-cache, must-revalidate"); // HTTP/1.1
		header("Pragma: no-cache"); // HTTP/1.0
	}
?>
