<?php

/*
 *	W-AGORA 4.0
 *	-----------
 *	$Id: init_admin.inc,v 1.49 2002/06/10 17:41:23 mdruilhe Exp $
 *	Usage:	Initialization file (for administration stuff)
 *	Author:	Marc Druilhe <mdruilhe@w-agora.net>
 */
	
	require ('globals.inc');

	// override cookie (take out $lang from URL)
	if (isset($HTTP_GET_VARS['lang']) ) {
		$lang = $HTTP_GET_VARS['lang'];
	} elseif (isset($HTTP_COOKIE_VARS['lang'])) {
		$lang = $HTTP_COOKIE_VARS['lang'];
	} elseif (isset($HTTP_ACCEPT_LANGUAGE) ) {
		$lang = substr($HTTP_ACCEPT_LANGUAGE, 0, 2);
	}

	$lang = strtolower($lang);
	if (!empty($lang) && file_exists("$lang_dir/lang_$lang.inc") ) {
		if (!isset($HTTP_COOKIE_VARS['lang']) || ($lang != $HTTP_COOKIE_VARS['lang']) ) {
			setcookie ('lang', $lang, 0, '/');
		}
	} else {
		$lang = 'ja';
	}

	include ("$lang_dir/admin_$lang.inc");
	include ("$lang_dir/lang_$lang.inc");

	require ("$inc_dir/misc_func.$ext");

	$formated_date = date ($bn_date_format, $now+($bn_tz_offset*3600) );

# Define labels associated with the different values
# --------------------------------------------------
	$user_states =array(
		"0" =>USER_STATE_LOCKED,
		"1" =>USER_STATE_ACTIVE,
		"P" =>USER_STATE_PENDING
	);

	$forum_types = array (
		"pub"=>FORUM_TYPE_PUBLIC,
		"reg"=>FORUM_TYPE_REGISTERED,
		"rest"=>FORUM_TYPE_RESTRICTED,
		"priv"=>FORUM_TYPE_PRIVATE
	);

	$forum_states = array (
		"0"=>FORUM_STATE_INACTIVE,
		"1"=>FORUM_STATE_ACTIVE,
		"L"=>FORUM_STATE_LOCKED,
		"C"=>FORUM_STATE_CLOSED
	);

# Displays the HTML headers
# ---------------------------
function display_header ($title) {

	global $icon_dir, $img_dir;

	printf ("<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.0 Frameset//EN\">\n<HTML>\n<HEAD><TITLE>" . ADMINISTRATION_TITLE . " - %s</TITLE>\n", $title);
	include "style.css";
?>
<!-- link rel="stylesheet" href="style.css" -->
</head><body leftmargin=0 topmargin=0 bgcolor="#CCCCCC">
<?php
	if (!empty($title) ) {
		printf ("</HEAD>\n<BODY bgcolor=#CCCCCC>\n<h2 align=center>%s</h2>\n", $title);
	}
}

function frameset($left_url, $right_url) {
	echo "<FRAMESET cols='200,*' FRAMEBORDER='no' border=0>\n";
	echo "<FRAME SRC=\"$left_url\" NAME=\"menu_frame\" marginheight=0 marginwidth='0' NORESIZE SCROLLING='auto'>\n";
	echo "<FRAME SRC=\"$right_url\" NAME=\"edit_frame\" marginheight=0>\n";
	echo "</FRAMESET>\n";
}

function left_menu_header ($title) {
	print '<TABLE width="180" border=0 cellspacing=0 cellpadding=1 align="center">';
	print '<TR><TD BGCOLOR="#d0dae6" colspan=2><TABLE cellpadding=1 width="100%"><TR><TD bgcolor="#e0eaf6" class="label" align="center"><b>'.$title.'</b></TD></TR></TABLE></TD></TR>';
}

function left_menu_item ($url, $target, $item, $alt) {

	print '<TR><TD valign="top" align="right">&nbsp;&nbsp;<img src="images/fleche-s.gif" width=5 height=5 align="center" alt=".">&nbsp;</td><td width="100%" valign="top" class="item">';
	displayUrl ($url, $target, $item, $alt, "menu");
	print '</td></tr>';
}

function left_menu_footer () {
	print '</table>';
}

# Displays all selected users
# ---------------------------
function list_users (&$users, $action="", $first=0, $last=0, $sort="") {
	global $site, $bn, $WA_SELF, $bn_date_format, $bn_tz_offset;
	global $formuser, $state, $user_states, $user_privs;
	global $icon_dir, $img_dir;
	global $nb_users_list;

	$total_users = count($users);

	if ($last == 0)	{
		$last = $total_users - 1;
	}

	if (empty($action) ) {
		$action = $WA_SELF;
	}

	if (is_array($users)) {
		echo "<table width='100%' CELLPADDING='4' CELLSPACING='1'><tr><th align=left>";
		displayUrl ("$action?site=$site&bn=$bn&formuser=$formuser&state=$state&sort=userid", "", COLUMN_USER_ID, "sort by userid");
		echo "</th><th align=left>"; displayUrl ("$action?site=$site&bn=$bn&formuser=$formuser&state=$state&sort=username", "", COLUMN_USER_NAME, "sort by name");
		echo "</th><th align=left>"; displayUrl ("$action?site=$site&bn=$bn&formuser=$formuser&state=$state&sort=userpriv", "", COLUMN_USER_PRIVILEGE, "sort by privilege");
		echo "</th><th align=left>"; displayUrl ("$action?site=$site&bn=$bn&formuser=$formuser&state=$state&sort=unixdate", "", COLUMN_USER_REGISTERED, "sort by creation date");
		echo "</th><th align=left>"; displayUrl ("$action?site=$site&bn=$bn&formuser=$formuser&state=$state&sort=totallogins+desc", "", COLUMN_USER_LOGIN_COUNT, "sort by total logins");
		echo "</th><th align=left>"; displayUrl ("$action?site=$site&bn=$bn&formuser=$formuser&state=$state&sort=lastlogin", "", COLUMN_USER_LAST_LOGIN, "sort by last login date/time");
		echo "</th><th align=left>"; displayUrl ("$action?site=$site&bn=$bn&formuser=$formuser&state=$state&sort=totalposts+desc", "", COLUMN_USER_POST_COUNT, "sort by total posts");
		echo "</th><th align=left>"; displayUrl ("$action?site=$site&bn=$bn&formuser=$formuser&state=$state&sort=lastpost", "", COLUMN_USER_LAST_POST, "sort by last post date/time");
		echo "</th></tr>\n";

		reset ($users);

		// skip first records
		$i = 0;		// $i # users displayed
		while (($i < $first) && (list(,$user) = each ($users) )) {
			$i++;
		}

		while (($i <= $last) && (list(,$user) = each ($users) )) {

			$action_url = sprintf ("<a href='$action?site=$site&userid=%s'>%s</a>", 				urlencode($user["userid"]), ($user["userid"] == "admin") ? "<FONT COLOR='red'><b>admin</b></FONT>" : $user["userid"] );
			$username = $user["username"];
			$priv = $user["userpriv"];
			$user_priv = $user_privs[$priv];
			$created = date($bn_date_format, $user["unixdate"]+($bn_tz_offset*3600));
			$totallogins = $user["totallogins"];
			$lastlogin = ($user["lastlogin"] > 0) ? date($bn_date_format, $user["lastlogin"]+($bn_tz_offset*3600)) : "&nbsp;";
			$totalposts = $user["totalposts"];
			$lastpost = ($user["lastpost"] > 0) ? date($bn_date_format, $user["lastpost"]+($bn_tz_offset*3600)) : "&nbsp;";
			printf ("<tr><td class=label>%s</td><td class=label>%s</td><td class=label>%s</td><td NOWRAP class=label>%s</td><td align='right' class=label>%s</td><td NOWRAP class=label>&nbsp;%s</td><td align='right' class=label>%s</td><td NOWRAP class=label>%s</td></tr>\n", $action_url, $username, $user_priv, $created, $totallogins, $lastlogin, $totalposts, $lastpost);
			$i++;
		}

		printf ("<tr><td colspan=8 align=right class=label><B>%s %d - %d / %d</B>", LABEL_DISPLAY, $first+1, $i, $total_users);

		if ($first>0) {
			$prev_last = $first-1;
			$prev_first = $prev_last - ($nb_users_list-1);
			if ($prev_first < 0) {
				$prev_first = 0;
				$prev_last = $nb_users_list-1;
			}
			$first_last = ($i>$nb_users_list) ? $nb_users_list-1 :  $i-1;
			echo '&nbsp;';
			displayUrl ("$action?site=$site&bn=$bn&formuser=$formuser&state=$state&sort=$sort&first=0&last=$first_last", "", LABEL_BEGIN_USERS, "First page");
			echo '&nbsp;';
			displayUrl ("$action?site=$site&bn=$bn&formuser=$formuser&state=$state&sort=$sort&first=$prev_first&last=$prev_last", "", LABEL_PREV_USERS, "Previous users");
		}
		if ($total_users>$i) {
			$next_first = $last+1;
			$next_last = $last + $nb_users_list;
			$last_user = $total_users-1;
			$last_first = $last_user -  ($nb_users_list-1);
			if ($next_last>$last_user) {
				$next_last = $last_user;
			}
			echo '&nbsp;';

			displayUrl ("$action?site=$site&bn=$bn&formuser=$formuser&state=$state&sort=$sort&first=$next_first&last=$next_last", "", LABEL_NEXT_USERS, '');
			echo '&nbsp;';
			displayUrl ("$action?site=$site&bn=$bn&formuser=$formuser&state=$state&sort=$sort&first=$last_first&last=$last_user", "", LABEL_END_USERS, '');
		}
		print "</td></tr></table>\n";
	}
}

# Displays selected forums
# ------------------------
function list_forums ($forums, $title, $target="", $action="") {
	global $site, $db, $WA_SELF, $ext, $bn_date_format, $bn_tz_offset, $bn_frames;
	global $forum_types, $forum_states;
	global $icon_dir, $img_dir;

	if (empty($action) ) {
		$action = $WA_SELF;
	}

	if (is_array($forums)) {
		echo "<center><TABLE BORDER=0 CELLPADDING=1 CELLSPACING=0 WIDTH=90% align=center><TR><TD BGCOLOR=\"#d0dae6\">";
		echo "<TABLE BORDER=0 CELLPADDING=2 CELLSPACING=1 width=100%>";
		echo "<TR><TD align=center bgcolor=white><b><FONT color=black size=2>$title</FONT></b></TD></TR>\n<TR><TD>\n";
		echo "<TABLE BORDER=0 WIDTH='100%' CELLPADDING=4 CELLSPACING=1>\n";
		echo "<TR><th></th><TD class=label>" . COLUMN_FORUM_ADMIN  . "</TD><TD class=label>" . COLUMN_EDIT . "</TD><TD class=label>" . COLUMN_DELETE . "</TD><TD class=label>" . COLUMN_FORUM_STATE . "</TD><TD class=label>" . COLUMN_FORUM_ACCESS . "</TD><TD class=label>" . COLUMN_FORUM_MODERATED . "</TD><TD class=label>" . COLUMN_FORUM_MODERATORS . "</TD><TD class=label>" . COLUMN_FORUM_THREADS  . "</TD><TD class=label>" . COLUMN_FORUM_POSTS . "</TD><TD class=label>" . COLUMN_FORUM_ATTACHMENTS . "</TH><TD class=label>" . COLUMN_FORUM_LAST_POST . "</TD></TR>\n";
		$curcat = 0;
		reset($forums);
		while (list($name, $forum) = each($forums)) {
			$type = $forum_types[$forum["type"]];
			$state = $forum_states[$forum["state"]];
			switch ($forum["state"]) {
			 case "0":
				$state_icon=msg(130,"<img src='images/closedfolder.gif' alt='" . ALT_INACTIVE_FORUM . "'>");
				break;
			 case "L":
				$state_icon=msg(131,"<img src='images/locked_thread.gif' alt='" . ALT_LOCKED_FORUM . "'>");
				break;
			 case "1":
				$state_icon=msg(132,"<img src='images/openfolder.gif' alt='" . ALT_ACTIVE_FORUM . "'>");
				break;
			}

			$mod = ($forum["moderated"] == 1) ? YES : NO;
			$bn = $forum["bn_name"];
			$rank = $forum["rank"];
			$lastpost = ($forum["lastnote"]>0) ? date ($bn_date_format, $forum["lastnote"]+($bn_tz_offset*3600)) : "&nbsp;";

			$moders = "";

			$admins = $db->getAdministrators($site);
			if (is_array($admins) ) {
				reset ($admins);
				while (list (, $m) = each ($admins) )  {
					if ($forum["owner"] == $m["userid"]) {
						$moders .= "<font color='red'>". $m[userid] . "</font><br>";
					} else {
						$moders .= $m["userid"] . "<br>";
					}
				}
			}

			$mods = $db->getModerators($site, $bn);
			if (is_array($mods) ) {
				reset ($mods);
				while (list (, $m) = each ($mods) )  {
					if ($forum["owner"] == $m["userid"]) {
						$moders .= "<font color='red'>". $m[userid] . "</font><br>";
					} else {
						$moders .= $m["userid"] . "<br>";
					}
				}
			}

			$att_size = pretty_size($forum["att_size"]);
			$action_url = anchor ("$action?site=$site&bn=$bn", $target, $name, MSG_ADMINISTRATE_FORUM . " " . $bn);
			$delete_url = anchor ("delete_forum.${ext}?site=$site&bn=$bn", "", "<img src='$icon_dir/delete.gif' align='absmiddle' border=0 alt='" . MSG_DELETE_FORUM . " " . $name . "'>", MSG_DELETE_FORUM . " " . $bn);
			$edit_url = anchor ("edit_forum.${ext}?site=$site&bn=$bn", "", "<img src='$icon_dir/edit.gif' align='absmiddle' border=0 alt='" . MSG_EDIT_FORUM . " " . $name . "'>", MSG_EDIT_FORUM . " " . $bn);
			if ($forum["parent"] != $curcat) {
				// new category
				$curcat = $forum["parent"];
				$cat = $db->getCategory ($site, $forum["parent"]);
				printf ("\n<TR><td bgcolor=#e0eaf6 colspan=12><font color=black>%s</font></TD></TR>", $cat["cat_title"]);
			}

			printf ("\n<TR valign='top'><td>$state_icon</td><TD class=label>%s<br><font size=1>%s</font></td><td align='center'>%s</td><td align='center'>%s</td><td class=label>%s</td><td class=label>%s</td><td class=label>%s</td><td class=label>%s</td><td align=right class=label>%s</td><td align=right class=label>%s</td><td align=center class=label><font size=1>%s<br>(%s)</font></td><td nowrap class=label>%s</td></tr>\n", $action_url, $forum["bn_title"], $edit_url, $delete_url, $state, $type, $mod, $moders, $forum["totalthreads"], $forum["totalnotes"], $forum["att_count"], $att_size, $lastpost);
		}
		echo "</table></td></tr></table></td></tr></table></center>\n";
	}
}

# if site is not defined, then redirect to admin entry point
# ----------------------------------------------------------
	if (empty($site)) {
		MsgForm (ERROR_SITE_EMPTY, "admin.$ext", "");
		exit;
	}

# --------------------------------------------------
#	set configuration file variables:
#	$cfg_file:	forum configuration file
#	$site_cfg_file: site configuration file
# --------------------------------------------------

	$site_cfg_file = "${cfg_dir}/site_${site}.$ext";
	if (!file_exists ("$site_cfg_file")) {
		MsgForm ("Cannot access configuration file: $site_cfg_file", "admin.$ext", "");
		exit;
	}

	if (empty($bn)) {
		$bn = "";
		$cfg_file = $site_cfg_file;
	} else {
		$bn=basename($bn);
		$cfg_file = "${cfg_dir}/${bn}.${ext}";
		$forum_name = ereg_replace ("${site}_", "", $bn);
	}

# Set core variables (managed by w-agora)
# ---------------------------------------
	$bn_var = array (
		'unixdate',		// timestamp (creation date)
		'userid',		// user ID
		'mod_date',		// modification date
		'mod_userid',	// userid of modifier
		'password',		// MD5 encoded password
		'filename',		// name of HTML note
		'att_size',		// total attachments size
		'mail_reply',	// set to '1' if replies to this note must be sent by email
		'hidden',		// set to 1 if note must be approved by the moderator
		'hits',			// hits count
		'closed',		// closed thread (RFU)
		'ip'			// logged IP address of sender
	);

	if (!is_array($bn_var_size) ) {
		$bn_var_size = array ();
	}

	$bn_var_size['unixdate']	= 'INT';
	$bn_var_size['userid']		= '32';
	$bn_var_size['mod_date']	= 'INT';
	$bn_var_size['mod_userid']	= '32';
	$bn_var_size['password']	= '32';
	$bn_var_size['filename']	= '64';
	$bn_var_size['att_size']	= 'INT';
	$bn_var_size['mail_reply']	= '1';
	$bn_var_size['hidden']		= 'INT';
	$bn_var_size['hits']		= 'INT';
	$bn_var_size['closed']		= 'INT';
	$bn_var_size['ip']			= '32';

# force w-agora variables to be listed
# ------------------------------------
	reset ($bn_var);
	while ( list(, $var) = each($bn_var) ) {
		$list_var[$var] = 1;
	}

# -----------------------------------------------------------
#	Get DB access type, create a DB object and open database
# -----------------------------------------------------------
	$site_dbparam = getDBaccess($site_cfg_file);
	$site_access = $site_dbparam['bn_access'];
	$site_dbname = $site_dbparam['dbname'];
	$site_dbhost = $site_dbparam['dbhost'];
	$site_dbport = $site_dbparam['dbport'];
	$site_dbuser = $site_dbparam['dbuser'];
	$site_dbpassword = $site_dbparam['dbpassword'];
	$site_dbadmuser = $site_dbparam['dbadmuser'];
	$site_dbadmpassword = $site_dbparam['dbadmpassword'];

	include ("$inc_dir/$site_access.$ext");
	$db_class = "${site_access}_access";
	$db = new $db_class;
	$ret = $db->openDB($site_dbhost, $site_dbport, $site_dbadmuser, $site_dbadmpassword, $site_dbname, $site);
	if ($ret != 0) {
		include "$site_cfg_file";
		include "$bn_dir/$bn_msgs";
		MsgForm (Msg(6), "$WA_SELF?site=$site", ""); /* access PB */
		exit;
	}

	$db->setDebug($debug);

# -----------------------------------------------------------------------------------
#	Now authenticate the user
# -----------------------------------------------------------------------------------
	$usersource = $site_dbparam['usersource'];
	include ("$user_dir/$usersource.$ext");
	$auth_class = "${usersource}_source";
	$auth = new $auth_class;

# force user to re-login
# ----------------------
	if (isset($force_login)) {
		$auth->logout($site);
		display_header (TITLE_ADMINISTRATION_LOGIN);
		$auth->login($site);
		exit;
	}

	if (!defined("no_auth_required")) {
		if ($auth->authenticate() ) {
# user is authenticated, we check permissions & exit if is not an admin user
			$is_administrator = ($auth->level >= ADMIN);
			if ($auth->level < MODER) {
				msgForm (ERROR_NO_ADMIN, "$WA_SELF?force_login=1", "", "_top");
				exit;
			}
			if (empty($bn) )  {
				$is_owner = ($auth->level >= ADMIN);
			} else {
			 	$is_owner = $auth->havePermission($bn, "M");
				if (! $is_owner) {
					msgForm (ERROR_NO_MODERATOR, "$WA_SELF?force_login=1", "", "_top");
					exit;
				}
			}
		} else {
# user is not authenticated
			if (isset($loginform)) {
				$auth->logout($site);
				display_header (TITLE_INVALID_LOGIN);
			} else {
				display_header (TITLE_ADMINISTRATION_LOGIN);
			}
			$auth->login($site);
			exit;
		}
	}

	require ("$inc_dir/config.$ext");

?>
