<?php

/*
 *	W-AGORA 4.0
 *	-----------
 *	$Id: list.php,v 1.33 2002/06/11 09:43:17 mdruilhe Exp $
 *	Usage:		display listing of notes
 *	Author:		Marc Druilhe <mdruilhe@w-agora.com>
 */

	$bn_action="list";
	$bn_action_mode="L";

	require ("init.inc");

	$where = (empty($where)) ? "" : stripSlashes($where);

	if (empty($sort)) {
		$sort = (empty($bn_sort)) ? "thread" : stripSlashes($bn_sort);
	} else {
		$sort = stripSlashes($sort);
	}

# Execute before_access program
# -----------------------------
	if (!empty($bn_before_access)) {
		if (file_exists ("$bn_dir/$bn_before_access") ) {
			include "$bn_dir/$bn_before_access";
		} else {
			include "$bn_dir_default/$bn_before_access";
		}
	} elseif (file_exists ("$bn_dir_default/before_access.$ext") ) {
		include ("$bn_dir_default/before_access.$ext");
	}

	$daysprune = (isset($daysprune) ) ? (integer) $daysprune : 0;
	$first = (isset($first) ) ? (integer) $first : 0;
	if (empty($last)) {
		$last = (empty($daysprune)) ? 0 : $now-($daysprune*86400);
	}

	if ($daysprune>0) {
		$bn_maxthreads = 0;
	}

# if forum is not defined then list active forums into this site
# --------------------------------------------------------------
	if (empty($bn)) {

		$total = $site_totalthreads;
		$notes = $site_totalforums;
		$threads = $site_totalthreads;

		$hide_inactive = ($auth->level < MODER); // hide forums for end users
		$forums = $db->listForums ($site, "", $sort, $hide_inactive, $cat);

# Display the header
# ------------------
		display_header ("", $header_footer);

# Display the list
# ----------------
		if ($site_totalforums > 0) {
			$db->displayForumList ();
		} else {
			dspMsg (16);
		}

# Display the footer
# ------------------
		display_footer ($header_footer);
		exit;

	}

# list order by threads (default) or order by $sort
# -------------------------------------------------
	if ($sort == "thread") {
		$ret = $db->listThreads ($bn_db, $first, $last, $where, ($expnd=="none") ? 0 : 1, $bn_maxthreads);
	} else {
		$ret = $db->listNotes ($bn_db, $first, $last, $sort, $where, $bn_maxthreads);
	}

	if (!is_array ($ret) || ($ret < 0)) {
		display_header ("", $header_footer);
		MsgForm (msg(6), "list.$ext", "");
		display_footer ($header_footer);
	} else {
		$notes = $ret["notes"];
		$total = $ret["total"];
		$threads = $ret["threads"];
	}

# Set all variables used for the navigation toolbar
# -------------------------------------------------
	if ($notes > 0) {
		$first = (int) $ret["first"];
		$last = (int) $ret["last"];
		$prev = (int) $ret["prev"];
		$next = ($daysprune==0) ? (int) $ret["next"] : "";

		$list_prev_text = msg(65);
		if ($prev) {
			$list_prev_url = "$WA_SELF?bn=$bn&expnd=$expnd&last=$first&sort=$sort&where=$where";
			$list_prev_link = anchor ($list_prev_url, "", $msg[79], $list_prev_text);
		} else {
			$list_prev_url = "";
			$list_prev_link = "";
		}

		$list_next_text = msg(66);
		if ($next ) {
			$list_next_url = "$WA_SELF?bn=$bn&expnd=$expnd&first=$last&sort=$sort&where=$where";
			$list_next_link = anchor ($list_next_url, "", $msg[80], $list_next_text);
		} else {
			$list_next_url = "";
			$list_next_link = "";
		}
	}

# Display the header
# ------------------
	display_header ("List", $header_footer);
	DspMsg (11);

# Display the list
# ----------------
	if ($notes > 0) {
		print "<!-- LIST HEADER -->\n";
		$l = str_replace ('"', '\"', $bn_list_header);
		eval ("echo stripSlashes(\"$l\");");
		$db->getChild (0, "list");
		print "<!-- LIST FOOTER -->\n";
		$l = str_replace ('"', '\"', $bn_list_footer);
		eval ("echo stripSlashes(\"$l\");");
	} else {
		dspMsg (16);
	}

# Display the navigation bar
# --------------------------
	if (($prev || $next) && !$bn_list_no_nav_bar) {
		printf ("<!-- NAV BAR -->\n<br><CENTER><TABLE><TR><TD width='60'>%s &nbsp;</TD>", $list_prev_link);
		printf ("<TD width='60'>%s &nbsp;</TD></TR></TABLE></CENTER>\n<!-- /NAV BAR -->\n", $list_next_link);
	}

# Display form if option set
# ----------------------------
	if ($bn_list_post && ($forum['type']=='pub' || $auth->havePermission($bn, "W") ) ) {
		$bn_action="post";
		$bn_action_mode="L";

		$setUserField = true;		// Set username and password in form fields
		$form_action = "insert.$ext";
		$back_form="list";
		$bn_popup=0;

		if (!empty($bn_before_access)) {
			if (file_exists ("$bn_dir/$bn_before_access") ) {
				include "$bn_dir/$bn_before_access";
			} else {
				include "$bn_dir_default/$bn_before_access";
			}
		} elseif (file_exists ("$bn_dir_default/before_access.$ext") ) {
			include ("$bn_dir_default/before_access.$ext");
		}

		include "$inc_dir/form.$ext";
	}

# Display the footer
# ------------------
	display_footer ($header_footer);
?>
