<?PHP 

/*
 *	W-AGORA 4.0
 *	-----------
 *	$Id: moderate_notes.php,v 1.19 2002/05/13 08:48:04 mdruilhe Exp $
 *	Usage:	Allows the moderator to accept/reject incoming messages in a moderated forum
 *	Author:	Marc Druilhe <mdruilhe@w-agora.net>
 */

require ("init_admin.inc");
require ("$cfg_file");

# include messages
# ----------------
	if (!empty($bn_msgs) && file_exists ("$bn_dir/$bn_msgs") ) {
		include "$bn_dir/$bn_msgs";
	} elseif (file_exists ("$bn_dir_default/msgs.$ext") ) {
		include ("$bn_dir_default/msgs.$ext");
	}

# fields definition
# -----------------
	if (!empty($bn_fields) && file_exists ("$bn_dir/$bn_fields") ) {
		include "$bn_dir/$bn_fields";
	} elseif (file_exists ("$bn_dir_default/fields.$ext") ) {
		include ("$bn_dir_default/fields.$ext");
	}

# listing outline
# ---------------
	if (!empty($bn_list_vars) && file_exists ("$bn_dir/$bn_list_vars") ) {
		include "$bn_dir/$bn_list_vars";
	} elseif (file_exists ("$bn_dir_default/list.$ext") ) {
		include ("$bn_dir_default/list.$ext");
	}

# Note template
# -------------
	if (!empty($bn_template) && file_exists ("$bn_dir/$bn_template") ) {
		include "$bn_dir/$bn_template";
	} elseif (file_exists ("$bn_dir_default/template.$ext") ) {
		include ("$bn_dir_default/template.$ext");
	}

$this_forum = $db->getForum($site, $bn);
$bn_db = $this_forum["bn_db"];
$owneraddress = $this_forum["owneraddress"];

display_header (TITLE_MODERATE_NOTES);

# If key is set then display message
# ----------------------------------
if (isset($key) ) {

# read note in order to insure that this note exists and to get userid/password of the owner
# ---------------------------------------------------------------------------------------
	$note = $db->getNote ($bn_db, $key);
	if (is_array($note) ) {

		$display_note=false;

		if (isset($confirmdelete) ) {
# displays form (ask for confirmation)
# --------------------------------
			beginForm();
			hiddenField ("key", $key);

			echo "<CENTER>";
			echo "<h3>" . LABEL_MESSAGE_DELETE_CONFIRMATION . "</h3>";
			submitButton ("delete", LABEL_DELETE);
			backButton ("cancel", LABEL_CANCEL);
			echo "</p></CENTER></FORM>";
			echo "<HR SIZE=4>";
			$display_note=true;

		} elseif (isset($delete)) {
			$db->deleteNote($bn_db, $key, $bn_dir_notes);

		} elseif (isset($validate)) {
			$note["hidden"] = 0;	// reset hidden flag (checked in mail_note()
			$validate_note = array ("hidden"=>0);
			$ret = $db->updateTable ($bn_db, $validate_note, "cle=$key");
			if ($ret==0) {
				$db->updateNewest ($bn_db, $note["thread"]);
				$db->updateForumStats ($site, $bn_db);

				if ($note["userid"] != "guest") {
					$db->updateUserStats ($site, $bn, $note["userid"], $note["unixdate"]);
				}

				if ($bn_user_mail) {
					include ("$inc_dir/mail.$ext");
					mail_note ($note);
				}
			}

		} else {
# displays form (choose action)
# --------------------------------
			beginForm();
			hiddenField ("key", $key);

			echo "<CENTER>";
			echo "<H3>" . CAPTION_MESSAGE_ACTION . "</H3>";
			submitButton ('validate', LABEL_VALIDATE);
			submitButton ('confirmdelete', LABEL_DELETE);
			backButton ('cancel', LABEL_CANCEL);
			echo "</p></CENTER></FORM>";
			echo "<HR noshade width=80% color=black>";
			$display_note=true;
		}

# displays note
# -------------
		if ($display_note) {
			extract ($note);
			$viewkey = $key;
			include "$inc_dir/viewnote.$ext";
			echo "</body></html>";
			exit;
		}
	} else {
		MsgWarning (Msg(10));
	}
}

# Displays notes to be deleted
# ----------------------------

$ret = $db->listNotes ($bn_db, 0, 0, "unixdate DESC", "hidden=1", 0);

if (!is_array ($ret) || ($ret < 0)) {
	msgWarning (msg(6));

} elseif ($ret["notes"] == 0) {
	msgWarning (ERROR_NO_INCOMING);

} else {
	table_header (CAPTION_VALIDATE_DELETE_MESSAGE);
	echo "<ul>\n";
	reset ($db->children[0]);
	while ( list( , $key ) = each($db->children[0])) {
		$note = $db->entries[$key];
		printf ("<li> %s <a href=$WA_SELF?site=$site&bn=$bn&key=$key>%s</a> (%s)", 
			date ($bn_date_format, $note["unixdate"]+($bn_tz_offset*3600)), $note["subject"], $note["username"]);
	}
	echo "</ul>";
	table_footer();
}
?>
</BODY>
</HTML>
