<?php

/* 
 *	W-AGORA 4.0
 *	-----------
 *	$Id: profile.php,v 1.19 2002/06/10 17:41:23 mdruilhe Exp $
 *	Usage:		allows user to edit his profile and to register/unregister new forums
 *	Author:		Markus Inger <privat@markus-inger.de>
 *				Marc Druilhe <mdruilhe@w-agora.com>
 *
 */

	$no_cookie=1;
	require ("init.inc");

	# Send to profile page if defined
   # --------------------------------
	$newURL = $auth->getEditProfileURL();
	if (is_string($newURL)) {
		if (empty($newURL))
			msgForm (msg(185, "This feature has been disabled in this site"), "$WA_SELF", "back");
		else
        		header("Location: $newURL");
		exit;
	}

	if ($site == "agora") {
		display_header ("", $header_footer);
		msgForm (msg(107, "Please, Choose a site in order to access a user profile"), "$main_page", "");
		display_footer($header_footer);
		exit;
	}

	if (!empty($showuser) ) {
		$bn_action="show_profile";
		$u = $db->getUser($site, $showuser);
		if (is_array($u) ) {
			while ( list( $var, $val ) = each( $u)) {
				if (is_string ($var)) {
					$$var = kill_quotes(stripSlashes(my_br2nl($val)));
				}
			}
		} else {
			display_header ("", $header_footer);
			msgForm (msg(101, "user $userid doesn't exists"), "$main_page", "", ($bn_frames==1)?"_parent":"");
			display_footer($header_footer);
			exit;
		}

		$register_date = formated_date ($unixdate);
		$lastpost_date = ($lastpost>0) ? formated_date ($lastpost) : "";
		$userpriv = $user_privs[$userpriv];

		$edit_user_url = "edit_user.$ext?site=$site&userid=$showuser";

		$form_title = msg(xx, "$showuser profile");

		if (!empty($bn_before_access)) {
			if (file_exists ("$bn_dir/$bn_before_access") ) {
				include "$bn_dir/$bn_before_access";
			} else {
				include "$bn_dir_default/$bn_before_access";
			}
		} elseif (file_exists ("$bn_dir_default/before_access.$ext") ) {
			include ("$bn_dir_default/before_access.$ext");
		}

		display_header ("profile", $header_footer);

		if (!empty($bn_show_profile) && file_exists("${bn_dir}/${bn_show_profile}") ) {
			include "${bn_dir}/${bn_show_profile}";
		} elseif ( file_exists("${bn_dir_default}/show_profile.$ext") ) {
			include "${bn_dir_default}/show_profile.$ext";
		} else {
			include "${tmpl_dir}/default/en/show_profile.$ext";
		}
		display_footer($header_footer);
		exit;
	}

	$form_title = msg(163, "Change your profile");

# Execute before_access program
# -----------------------------
	if (!empty($bn_before_access)) {
		if (file_exists ("$bn_dir/$bn_before_access") ) {
			include "$bn_dir/$bn_before_access";
		} else {
			include "$bn_dir_default/$bn_before_access";
		}
	} elseif (file_exists ("$bn_dir_default/before_access.$ext") ) {
		include ("$bn_dir_default/before_access.$ext");
	}

	display_header ("profile", $header_footer);

# Check if the user is authenticated in this site otherwise redirect him to the login form
# ----------------------------------------------------------------------------------------
	if (!$is_authenticated) {
		msgForm (sprintf(ERROR_LOGIN_REGISTER, "login.$ext?site=$site&bn=$bn", "register.$ext?site=$site&bn=$bn") , $main_page, "");
		display_footer($header_footer);
		exit;
	}

# gets all registered/restricted forums in this site
# --------------------------------------------------
	$forums = $db->listForums ($site);

# A dirty way to list only forums which are registered or restricted !!!
# ----------------------------------------------------------------------
	reset($forums);
	while (list($name) = each ($forums) ) {
		if ($forums[$name]["type"] != "rest") {
			unset ($forums[$name]);
		}
	}

# Force userid (cannot be changed here)
# -------------------------------------
	$userid = $auth->userid;
	$input_userid = $userid;

# If Creation form have been submitted
# ------------------------------------
if (isset($go)) {

	$go=0;

# Check for a valid email
# -----------------------
	if (!validate_email ($useraddress)) {
		msgForm (msg (47, "invalid email address"), "$WA_SELF", "back");
		display_footer($header_footer);
		exit;
	}

#	Check for required fields
#	-------------------------
	include "$tmpl_dir/admin/user_fields.$ext";

	$bn_bind_var["username"] = 1;
	$bn_bind_var["useraddress"] = 1;

	reset ($bn_bind_var);
	while (list($field, $required) = each($bn_bind_var)) {
		if ($required && ($$field=="") ) {
			$mess = "$field : " . msg(5);
			msgForm ("$mess", "$WA_SELF?site=$site", "back");
			display_footer($header_footer);
			exit;
		}
	}

#	Initialize user array with form values
#	--------------------------------------
	for (reset ($bn_var); $form_field=current($bn_var); next($bn_var)) {
		if (isset ($$form_field) ) {
			$$field=stripSlashes($$form_field);
			$u_fields[$form_field]=$$field;
		}
	}

#	Strip HTML tags in signature
#	----------------------------
	if (!empty($signature) ) {
		$u_fields['signature'] = strip_tags($signature);
	}

# Check that email address is not already used
# --------------------------------------------
	if ($useraddress != $auth->user["useraddress"]) {
		$tmp = $db->getUser($site, $useraddress, "useraddress");
		if (is_array($tmp)) {
			msgForm (msg(177, "Sorry, the email address '$useraddress' is already used"), "$WA_SELF", "back");
			echo "</body></html>";
			exit;
		}
	}


#  Update user infos for this user in the users table
#  --------------------------------------------------

#	1. for the current site
#	-----------------------
	$ret = $db->updateUser ($site, $userid, $u_fields);

	if ($ret < 0) {
		msgForm ("could not change profile for the user $userid, please contact the administrator", "$WA_SELF?site=$site", "back");
		display_footer($header_footer);
		exit;
	}

#	2. then the main site for administrators.
#	-----------------------------------------
	if ( ($u["userpriv"] == "admin") || ($u["userpriv"] == "root") ) {
		$db->updateUser ("agora", $userid, $u_fields);
	}

#	3. then for all sites for system administrators
#	---------------------------------
	if ($u["userpriv"] == "root") {
		$sites = $db->listForums ("agora");
		while (is_array($sites) && list(, $s) = each($sites)) {
			$db->updateUser ($s["bn_name"], $userid, $u_fields);
		}
	}


# ----------------------------------------------------------
# Now register / unregister the users to the selected forums
# ----------------------------------------------------------

# initialize default values
# -------------------------
	$uf_fields["unixdate"]  = $now;
	$uf_fields["userid"]    = $userid;
	$uf_fields["lastlogin"] = 0;
	$uf_fields["lastpost"]  = 0;
	$uf_fields["listpriv"]  = 1;
	$uf_fields["readpriv"]  = 1;
	$uf_fields["writepriv"] = 1;
	$uf_fields["modpriv"]   = 0;

# For each registered/restricted forum in this site
# -------------------------------------------------
	if (is_array ($forums) ) {
		reset ($forums);
		while (list($name) = each ($forums) ) {
			$forum = $forums[$name]["bn_name"];
# check if user already subscribed to this forum
			$privs = $db->getPrivs ($site, $forum, $userid);
			if (is_array ($privs) ) {
# user already subscribed to this forum, check if checkbox was unchecked
				if (!is_array($subscribeforums) || ($subscribeforums[$name] != 1)) {
					$ret = $db->deletePrivs ($site, $forum, $userid);
					if ($ret < 0) {
						msgForm ("Sorry, could not unsubscribe $userid to forum $name, try again or contact the site administrator", "$WA_SELF?site=$site", "back");
						display_footer($header_footer);
						exit;
					}
				}
			} else {
				if (is_array($subscribeforums) && ($subscribeforums[$name] == 1) ) {
# add permission -> insert into userforum
# ---------------------------------------
					$uf_fields["bn_name"]=$forum;
# set state to pending for a restricted forum, active for a registered one
					$uf_fields["state"] = ($forums[$name]["type"] == "rest") ? "P" : "1";
					$ret = $db->InsertPrivs ($site, $forum, $userid, $uf_fields);
					if ($ret < 0) {
						msgForm ("Sorry, could not subscribe $userid to forum $name, try again or contact the site administrator", "$WA_SELF?site=$site", "back");
						display_footer($header_footer);
						exit;
					}
# add owner address on the recipient list in order to send them an email
# ----------------------------------------------------------------------
					if ($forums[$name]["type"] == "rest") {
						$forums_list .= "\n [ $name ] : " . $forums[$name]["bn_title"];
						$moderators[] = $forums[$name]["owneraddress"];
					}
				}
			}
		}
	}

# --------------------------------------------
# send mail back to the user and to moderators
# --------------------------------------------
	include "$inc_dir/mail.$ext";
	mail_profile ($userid, $password, $u_fields, $moderators);
	msgForm (msg(170, "Your profile has been changed"), "$main_page?site=$site&bn=$bn", "", ($bn_frames==1)?"_parent":"");
	display_footer($header_footer);
} else {
	#  evaluate all fields from $user 
	#  ------------------------------
	while ( list( $var, $val ) = each( $auth->user)) {
		if (is_string ($var)) {
			$$var = kill_quotes(stripSlashes(my_br2nl($val)));
		}
	}

}

	beginForm();
	hiddenField ("go", "1");

	if (!empty($bn_register_form) && file_exists("${bn_dir}/${bn_register_form}") ) {
		include "${bn_dir}/${bn_register_form}";
	} elseif ( file_exists("${bn_dir_default}/register_form.$ext") ) {
		include "${bn_dir_default}/register_form.$ext";
	} else {
		include "${tmpl_dir}/default/en/register_form.$ext";
	}
	echo "</FORM>";
	display_footer($header_footer);
?>
