<?PHP

/*
 *	W-AGORA 4.0
 *	-----------
 *	$Id: register.php,v 1.22 2002/06/10 17:41:23 mdruilhe Exp $
 *	Usage:		register a new user into a site
 *	Author:		Marc Druilhe <mdruilhe@w-agora.net>
 *
 */

$no_cookie=1;
$bn_action="register";
require ("init.inc");

# Send to register page if defined
# --------------------------------
$newURL = $auth->getRegisterURL();
if (is_string($newURL)) {
	if (empty($newURL))
		msgForm (msg(185, "This feature has been disabled in this site"), "$WA_SELF", "back");
	else
			header("Location: $newURL");
	exit;
}

# Include mail template
# ---------------------
if (empty($bn_mail_template) ) {
	include ("$bn_dir_default/mail_template.$ext");
} else {
	include "$bn_dir/$bn_mail_template";
}

$form_title = msg(162, "Register as a new user");

# Execute before_access program
# -----------------------------
if (!empty($bn_before_access)) {
	if (file_exists ("$bn_dir/$bn_before_access") ) {
		include "$bn_dir/$bn_before_access";
	} else {
		include "$bn_dir_default/$bn_before_access";
	}
} elseif (file_exists ("$bn_dir_default/before_access.$ext") ) {
	include ("$bn_dir_default/before_access.$ext");
}

display_header ("User registration", $header_footer);

if ($site == "agora") {
	msgForm (msg(107, "Please, Choose a site in order to register"), "$main_page", "");
	exit;
}

# gets all registered/restricted forums in this site
# --------------------------------------------------
$forums = $db->listForums ($site);

# A dirty way to list only forums which are restricted !!!
# --------------------------------------------------------
if (is_array ($forums) ) {
	reset ($forums);
	while (list($name) = each ($forums) ) {
		if ($forums[$name]["type"] != "rest") {
			unset ($forums[$name]);
		}
	}
}

# If Creation form have been submitted
# ------------------------------------
if (isset($go)) {

	$go=0;

# Check for a valid email
# -----------------------
	if (!validate_email ($useraddress, true)) {
		msgForm (msg (47, "invalid email address"), "$WA_SELF", "back");
		exit;
	}

#	Check for required fields
#	-------------------------

	include "$tmpl_dir/admin/user_fields.$ext";

	if (is_array ($bn_bind_var)) {
		reset($bn_bind_var);
		while (list($field, $required) = each($bn_bind_var)) {
			if ($required && !$$field) {
				$mess = "$field : " . msg(5);
				msgForm ("$mess", "$WA_SELF", "back");
				exit;
			}
		}
	}

#	Check that userid is valid (no spaces in it)
#	--------------------------------------------
	$userid = trim($userid);	// remove spaces at beginning and end
	if (ereg (" ", $userid) ) {
		msgForm (msg (108, "The user id must not contains spaces"), "$WA_SELF", "back");
		display_footer($header_footer);
		exit;
	}

#	Check if users already exists
#	-----------------------------
	$u = $db->getUser($site, $userid);
	if (is_array($u)) {
		msgForm (msg(109, "Sorry, this user: $userid has already be picked for this site, please choose another one"), "$WA_SELF", "back");
		display_footer($header_footer);
		exit;
	}

	$u = $db->getUser($site, $useraddress, "useraddress");
	if (is_array($u)) {
		msgForm (msg(177, "Sorry, the email address '$useraddress' is already used"), "$WA_SELF", "back");
		echo "</body></html>";
		exit;
	}

# -------------------------------------------------------------------
# Create user privileges (user->forums relation) for each forum
# -------------------------------------------------------------------

# initialize default values
# --------------------------
	$uf_fields["unixdate"]  = $now;
	$uf_fields["userid"]    = $userid;
	$uf_fields["lastlogin"] = 0;
	$uf_fields["lastpost"]  = 0;
	$uf_fields["listpriv"]  = 1;
	$uf_fields["readpriv"]  = 1;
	$uf_fields["writepriv"] = 1;
	$uf_fields["modpriv"]   = 0;

# For each registered/restricted forum in this site
# -------------------------------------------------
	if (is_array ($forums) && is_array($subscribeforums)) {
		reset ($forums);
		while (list($name) = each ($forums) ) {
			$forum = $forums[$name]["bn_name"];
			if ($subscribeforums[$name] == 1) {
# if user has subscribed to this forum
# ------------------------------------
				$uf_fields["bn_name"]=$forum;
# set state to pending for a restricted forum, active for a registered one
				$uf_fields["state"] = ($forums[$name]["type"] == "rest") ? "P" : "1";
			
# insert into userforum
# ---------------------
				$ret = $db->InsertPrivs ($site, $forum, $userid, $uf_fields);
				if ($ret < 0) {
					msgForm (msg(110, "Sorry, could not insert user $userid into database, try again or contact the site administrator"), "$WA_SELF?site=$site", "back");
					exit;
				}
			}
		}
	}

# generate a random password
# --------------------------
	$password = $auth->genPassword();

#  insert this user in users table
#  -------------------------------
	
	for (reset ($bn_var); $form_field=current($bn_var); next($bn_var)) {
		$$field=stripSlashes($$form_field);
		$u_fields[$form_field]=$$field;
	}

#	Strip HTML tags in signature
#	----------------------------
	if (!empty($signature) ) {
		$u_fields['signature'] = strip_tags($signature);
	}
	$u_fields["password"] = md5($password);
	$u_fields["userpriv"] = "user";
	$u_fields["lastlogin"] = 0;
		
	$ret = $db->insertUser ($site, $u_fields);

	if ($ret < 0) {
		msgForm (msg(110, "Sorry, could not insert user $userid into database, try again or contact the site administrator"), "$WA_SELF?site=$site", "back");
		exit;
	}

# Gets forum list for which the user want to register
# ---------------------------------------------------
	$moderators = array();
	$owners = array();
	while (is_array($subscribeforums) && list($name) = each ($subscribeforums) ) {
		$registered_forums .= "  [ $name ] " . $forums[$name]["bn_title"];
		if ($forums[$name]["type"] == "rest") {
			$registered_forums .= "\t [*]\n";
		} else {
			$registered_forums .= "\n";
		}
		$owner = $forums[$name]['owneraddress'];
		if (!isset($owners[$owner]) ) {
			$owners[$owner] = 1;
			$moderators[] = $owner;
		}
	}

# send mail back to the user and to moderators
# --------------------------------------------
	include "$inc_dir/mail.$ext";
	mail_profile ($userid, $password, $u_fields, $moderators);

# Now display the confirmation then exit
# --------------------------------------
	msgForm (msg(111, "The user '$userid' has been reserved<br>You should be receiving an email shortly with your password. Thanks for registering."), "$main_page?site=$site", ($bn_frames==1)?"_parent":"");
	display_footer($header_footer);
	exit;
} // End $go


#  -------------------------------------------
#  Initialize default values then display FORM
#  -------------------------------------------

	$userid = (isset($userid)) ? $userid : "";
	$username = (isset($username)) ? $username : "";
	$useraddress = (isset($useraddress)) ? $useraddress : "";
	$homepage = (isset($homepage)) ? $homepage : "";
	$details = (isset($details)) ? $details : "";
	$mailok = (isset($mailok)) ? $mailok : "Y";

	$input_userid = getTextField ('userid', $userid);
?>

 <SCRIPT type="text/javascript" LANGUAGE="JavaScript">
<!-- // Hide for old browsers
  function CheckForm(form) {
<?PHP 
	include "$tmpl_dir/admin/user_fields.$ext";
	/* Check for required fields */
	if (isset($bn_bind_var)) {
		reset($bn_bind_var);
		while (list($field, $required) = each($bn_bind_var)) {
			if ($required) {
?>
    if (form.<?PHP echo $field?>.value.length == 0) {
      alert ("<?PHP dspMsg(56)?>");
      form.<?PHP echo $field?>.focus();
      return false;
    }
<?PHP 
			}
		}
	}
?>
    return true;
  }
// End of script -->
 </SCRIPT>

<FORM NAME="form_post" METHOD="post" ACTION="<?PHP echo $WA_SELF?>" onSubmit="return CheckForm(this);" >

<?PHP 
	hiddenField ("site", $site);
	hiddenField ("bn", $bn);
	hiddenField ("go", "1");

	if (!empty($bn_register_form) && file_exists("${bn_dir}/${bn_register_form}") ) {
		include "${bn_dir}/${bn_register_form}";
	} elseif ( file_exists("${bn_dir_default}/register_form.$ext") ) {
		include "${bn_dir_default}/register_form.$ext";
	} else {
		include "${tmpl_dir}/default/en/register_form.$ext";
	}

	echo "</FORM>";
	display_footer($header_footer);

?>
