<?

/*
 *	W-AGORA 4.0
 *	-----------
 *	$Id: subscribe.php,v 1.15 2002/06/05 08:55:51 mdruilhe Exp $
 *	Usage:		subscribe a user to one or more forums (allowing him to receive emails)
 *	Author:		Marc Druilhe <mdruilhe@w-agora.net>
 *
 */

# User must have read access in order to subscribe to the mailing list
# --------------------------------------------------------------------
	$bn_action_mode="R";	
	$bn_action="subscribe";
	require ("init.inc");

# A site must be selected in order to subscribe
# ---------------------------------------------
	if ($site == "agora") {
		header ("Location: $main_page");
		exit;
	}

# A forum must be selected in order to subscribe
# ---------------------------------------------
	if (empty($bn)) {
		msgForm (msg(119, "Please, Choose a forum"), "$main_page", "");
		exit;
	}

# Check if the user is authenticated in this site otherwise redirect him to the login form
# ----------------------------------------------------------------------------------------
	if (!$is_authenticated) {
		$loginURL = $auth->getLoginURL();
		if (is_string($loginURL)) {
			header("Location: $loginURL");
		} else {
			display_header ("login", $header_footer);
			$auth->login($site);
			display_footer ($header_footer);
		}
		exit;
	}

	$userid = $auth->userid;
	$useraddress = $auth->user["useraddress"];

# Execute before_access program
# -----------------------------
	if (!empty($bn_before_access)) {
		if (file_exists ("$bn_dir/$bn_before_access") ) {
			include "$bn_dir/$bn_before_access";
		} else {
			include "$bn_dir_default/$bn_before_access";
		}
	} elseif (file_exists ("$bn_dir_default/before_access.$ext") ) {
		include ("$bn_dir_default/before_access.$ext");
	}

	display_header ("Forum Subscription", $header_footer);

# If Subscription form have been submitted
# ------------------------------------
if (isset($go)) {

	$go=0;

	if ($subscribe == 1) {
		$db->subscribeUser ($site, $bn_db, $useraddress, 0);
		msgWarning (msg(133, "You have subscribed to this forum, you should now receive all posts by email."));
	} else {
		$db->unSubscribeUser ($site, $bn_db, $useraddress, 0);
		msgWarning (msg(134, "You have unsubscribed from this forum, you should no longer receive emails."));
	}

# (4.1.3) add entry to the LOG
# ----------------------------
	if (!$bn_no_stats) {
		$action = ($subscribe == 1) ? 'subscribe' : 'unsubscribe';
		$db->addLogEntry ($bn, $action, $auth->userid);
	}

	display_footer ($header_footer);

} // End $go

# Check if the user has already subscribed to this forum
# ------------------------------------------------------
	$subscribed = $db->checkSubscribedUser ($site, $bn_db, $useraddress, 0);

	$current = ($subscribed == TRUE) ? "1" : "0";

	$subscribe_query = msg(135, "Do you want to receive all posts by email from this forum ?");
	$subscribe_radio = getRadioButton ("subscribe", "1", $current, YES );
	$unsubscribe_radio = getRadioButton ("subscribe", "0", $current, NO );
	$submit_button = getSubmitButton ("submit", msg(156,"submit"));
	$input_useraddress = $useraddress;

	beginForm();
	hiddenField("go", "go");

	if (!empty($bn_subscribe_form) && file_exists("${bn_dir}/${bn_subscribe_form}") ) {
		include "${bn_dir}/${bn_subscribe_form}";
	} elseif ( file_exists("${bn_dir_default}/subscribe_form.$ext") ) {
		include "${bn_dir_default}/subscribe_form.$ext";
	} else {
		echo "<BR><BR>";
		table_header ($subscribe_query, 500);
		print "<BR><center>";
		print "<B>e-mail address : </B>$input_useraddress";
		print "<br><BR>$subscribe_radio &nbsp;&nbsp; $unsubscribe_radio";
		echo "<br><br>$submit_button</center>";
		table_footer ();
	}
	endForm();
	display_footer ($header_footer);
?>
