<?

/*
 *	W-AGORA 4.0
 *	-----------
 *	$Id: subscribe_thread.php,v 1.9 2002/06/05 08:55:51 mdruilhe Exp $
 *	Usage:		subscribe a user to a thread (allowing him to receive emails)
 *	Authors:	Laurent Aufrere <laurent.aufrere@free.fr>
 *				Marc Druilhe <mdruilhe@w-agora.com>
 *			
 */

# User must have read access in order to subscribe to the mailing list
# --------------------------------------------------------------------
	$bn_action_mode="R";
	$popup=1;				// Opened in a separated window
	require ("init.inc");


# A site must be selected in order to subscribe
# ---------------------------------------------
	if ($site == "agora") {
		die (msg(107, "Please, Choose a site in order to subscribe to a thread"));
	}

# A site must be selected in order to subscribe
# ---------------------------------------------
	if (empty($bn)) {
		die (msg(119, "Please, Choose a forum"));
	}

# Check if the user is authenticated in this site otherwise redirect him to the login form
#----------------------------------------------------------------------------------------
	if (($forum["type"] != "pub") && !$is_authenticated) {
		header ("Location: login.${ext}?site=$site&bn=$bn");
		exit;
	}

# Set useraddress if user is authenticated
# ----------------------------------------
	if ($is_authenticated) {
		$userid = $auth->userid;
		$useraddress = $auth->user["useraddress"];
	}

# Execute before_access program
# -----------------------------
	if (!empty($bn_before_access)) {
		if (file_exists ("$bn_dir/$bn_before_access") ) {
			include "$bn_dir/$bn_before_access";
		} else {
			include "$bn_dir_default/$bn_before_access";
		}
	} elseif (file_exists ("$bn_dir_default/before_access.$ext") ) {
		include ("$bn_dir_default/before_access.$ext");
	}

	display_header ("Thread Subscription", $header_footer);

# If Subscription form have been submitted
# ----------------------------------------
	if (isset($go)) {
		$go=0;
		if (($forum["type"] == "pub") && !$is_authenticated) {
			# Check that the user email address is valid if set
			# --------------------------------------------------
			$useraddress=ereg_replace (" ", "", $useraddress);
			if (empty($useraddress) || !validate_email ($useraddress)) {
				msgForm (msg(47), "$WA_SELF", "back", "", "list");
				display_footer ($header_footer);
				exit;		
			}
		}

		if ($subscribe == 1) {
			$db->subscribeUser ($site, $bn_db, $useraddress, $thread);
			msgForm (msg(136, "You have subscribed to this thread, you should now receive all posts by email."), "view.$ext?bn=$bn&key=$thread", "close");		
		} else {
			$db->unSubscribeUser ($site, $bn_db, $useraddress, $thread);
			msgForm (msg(137, "You have unsubscribed from this thread, you should no longer receive emails."), "view.$ext?bn=$bn&key=$thread", "close");		
		}
		display_footer ($header_footer);
		exit;

	} // End $go

# Check if the user has already subscribed to this thread
# ------------------------------------------------------
	if ($is_authenticated) {
		$subscribed = $db->checkSubscribedUser ($site, $bn_db, $useraddress, $thread);
	} else {
		$subscribed=FALSE;
	}

	$current = ($subscribed == TRUE) ? "1" : "0";

	$subscribe_query = msg(138, "Do you want all messages posted this thread sent to you by email ?");
	$subscribe_radio = getRadioButton ("subscribe", "1", $current, YES );
	$unsubscribe_radio = getRadioButton ("subscribe", "0", $current, NO );
	$submit_button = getSubmitButton ("submit", msg(156,"submit"));
	$input_useraddress = ($is_authenticated) ? "$useraddress" : "<INPUT NAME=\"useraddress\" VALUE=\"$useraddress\" size=30>";

	beginForm();
	hiddenField("go", "go");
 	hiddenField("thread",$thread);

	if (!empty($bn_subscribe_form) && file_exists("${bn_dir}/${bn_subscribe_form}") ) {
		include "${bn_dir}/${bn_subscribe_form}";
	} elseif ( file_exists("${bn_dir_default}/subscribe_form.$ext") ) {
		include "${bn_dir_default}/subscribe_form.$ext";
	} else {
		echo "<BR><BR>";
		table_header ($subscribe_query, 500);
		print "<BR><center>";
		print "<B>e-mail address : </B>$input_useraddress";
		print "<br><BR>$subscribe_radio &nbsp;&nbsp; $unsubscribe_radio";
		echo "<br><br>$submit_button</center>";
		table_footer ();
	}
	endForm();
	display_footer ($header_footer);
?>
