<?php

/*
 *  W-AGORA 4.1
 *  -----------
 *  $Id: view.php,v 1.45 2002/06/11 09:43:17 mdruilhe Exp $
 *  Usage:	display a note
 *  Author:	Marc Druilhe <mdruilhe@w-agora.net>
 */

function exit_error ($title="", $msg="") {
	global $ext, $header_footer;

	display_header ($title, $header_footer);
	msgForm ($msg, "list.$ext", "");
	display_footer ($header_footer);
	exit;
}


# Initialization stuff
# --------------------
	$bn_action="view";
	$bn_action_mode="R";
	require ("init.inc");

	// Some installations (multimania.fr..) seems to lose/unset $key and $bn
	if (isset ($HTTP_POST_VARS['key'])) {
		$key = $HTTP_POST_VARS['key'];
	} elseif (isset ($HTTP_GET_VARS['key'])) {
		$key = $HTTP_GET_VARS['key'];
	}


# if note to display is not defined then return to the list
# ------------------------------------------------------
	if (empty($key)) {
		exit_error ("error", msg(3));
	}

# read note from database, exit if error
# --------------------------------------
	$note = $db->getNote ($bn_db, $key);
	if ($note < 0) {
		exit_error ("error", msg(10));
	}

# set all fields as global variables
# ----------------------------------
	extract ($note);

# (4.0) Exit with error if this note is hidden
# --------------------------------------------
	if (!$is_moderator && ($note['hidden'] == '1') ) {
		exit_error ('forbidden', msg(48));
	}

# set URLs to be displayed in the toolbar
# ---------------------------------------

	// DOWNLOAD THREAD
	if ( ($childs>0) || ($parent>0) ) {
		$download_thread_url = "download_thread.$ext?site=$site&bn=$bn&thread=$thread";
		$download_thread_text = msg(118, "expand");
		$download_thread_link = anchor ($download_thread_url, "", $download_thread_text, msg(171, "show complete thread"), $link_class);
	}

	// SUBSCRIBE TO THREAD
	if ($bn_user_mail && $bn_thread) {
		$subscribe_thread_url = "subscribe_thread.$ext?site=$site&bn=$bn&thread=$thread";
		$subscribe_thread_text = msg(117, "subscribe");
		$subscribe_thread_link = anchorWindow ($subscribe_thread_url, $subscribe_thread_text, msg(172, "receive updates to this thread"), 620, 460, $link_class);
	}

	$bn_view_reply = ($bn_thread && ( ($forum["type"]=="pub") || $auth->havePermission($bn, "W") ) ) ? $bn_view_reply :  false;

	// CLOSE
	$close_url = "";
	if ($is_moderator && $bn_thread) {
		$close_url = "close.$ext?bn=$bn&key=$key";
		$close_text = msg(141, "close/reopen thread");
		$close_link = anchor ($close_url, "", $close_text, $close_text, $link_class );
	}

	// set extra parameters to query string
	$nav = (empty($first) ) ? "" : "&first=$first";
	$nav = (empty($last) ) ? $nav : "&last=$last";
	$s = (empty($sort) ) ? "" : "&sort=$sort";
	$w = (empty($where) ) ? "" : "&where=$where";

	// LIST
	$e = (empty($expnd) ) ? "&expnd=$thread" : "&expnd=$expnd";
	$list_url = "list.$ext?bn=$bn&key=$key&here=$key".$nav.$s.$w.$e;
	$list_text = msg(61, "list");
	$list_link = anchor ($list_url, "", $list_text, msg(51, "return to list"), $link_class );

	

	// PREVIOUS / NEXT MESSAGE
	$tprev = $note["tprev"];
	$view_prev_text = msg(77);
	if ($tprev) {
		$view_prev_url = "$WA_SELF?bn=$bn&key=$tprev".$nav.$s.$w;
		$view_prev_link = anchor ($view_prev_url, "", $msg[79], $view_prev_text, $link_class);
	} else {
		$view_prev_url = "";
		$view_prev_link = "";
	}

	$tnext = $note["tnext"];
	$view_next_text = msg(78);
	if ($tnext) {
		$view_next_url = "$WA_SELF?bn=$bn&key=$tnext".$nav.$s.$w;
		$view_next_link = anchor ($view_next_url, "", $msg[80], $view_next_text, $link_class);
	} else {
		$view_next_url = "";
		$view_next_link = "";
	}

# save reply body (before formatting it)
# --------------------------------------
	if ($bn_view_reply) {
		$reply_body = strip_url(strip_smileys ($body));
		$reply_subject = (eregi ("^re:", $subject)) ? $subject : "Re: $subject";
		$reply_subject = kill_quotes($reply_subject);
	}

# read complete thread
# --------------------
	if ($bn_thread && !$bn_no_thread_list) {
		$expnd="all";
		$list_var["body"]=1;    // forces body to be listed
		$ret = $db->getThread ($bn_db, $key, $thread);
	}

# Execute before_access program
# -----------------------------
	if (!empty($bn_before_access)) {
		if (file_exists ("$bn_dir/$bn_before_access") ) {
			include "$bn_dir/$bn_before_access";
		} else {
			include "$bn_dir_default/$bn_before_access";
		}
	} elseif (file_exists ("$bn_dir_default/before_access.$ext") ) {
		include ("$bn_dir_default/before_access.$ext");
	}

# Increments hits count
# ---------------------
	if (!$bn_no_stats) { 
		$hits++;
		$db->query("UPDATE $bn_db SET hits=hits+1 WHERE cle='$key'");
		$db->addLogEntry ($bn, 'view', $auth->userid, $thread, $key);
	}

# Display HTML headers and  header include file if any
# ----------------------------------------------------
	display_header ($subject, $header_footer);

# Display note and attachments (using template)
# ---------------------------------------------
	$viewkey = $key;
	include "$inc_dir/viewnote.$ext";

# Display toolbar (optional)
# --------------------------
if (!$bn_no_toolbar): ?>
	<!-- TOOLBAR -->
	<P>
	<CENTER>
	<TABLE CELLSPACING="2" CELLPADDING="2" >
	<TR>
	<?PHP if ($download_thread_link): ?>
		<TD ALIGN="center" WIDTH="70">
		<?PHP echo $download_thread_link?>
		</TD>
	<?PHP endif?>
	<?PHP if ($subscribe_thread_link): ?>
		<TD ALIGN="center" WIDTH="70">
		<?PHP echo $subscribe_thread_link?>
		</TD>
	<?PHP endif?>
	<?PHP if ($reply_link): ?>
		<TD ALIGN="center" WIDTH="70">
		<?PHP echo $reply_link?>
		</TD>
	<?PHP endif?>
	<?PHP if ($edit_link): ?>
		<TD ALIGN="center" WIDTH="70">
		<?PHP echo $edit_link?>
		</TD>
	<?PHP endif?>
	<?PHP if ($delete_link): ?>
		<TD ALIGN="center" WIDTH="70">
		<?PHP echo $delete_link?>
		</TD>
	<?PHP endif?>
	<?PHP if ($close_link): ?>
		<TD ALIGN="center" WIDTH="70">
		<?PHP echo $close_link?>
		</TD>
	<?PHP endif?>
	<TD ALIGN="center" WIDTH="70">
	<?PHP echo $list_link?>
	</TD>
	</TR>
	</TABLE>
	</CENTER>
	<!-- END TOOLBAR -->
<?PHP endif;?>
<?PHP

# display navigation bar
# ----------------------
	if (!$bn_no_nav_bar) {
		comment ("NAV BAR");
		print "<table border='0' width='100%'>\n<TR>";
		printf ("<TH WIDTH='20'>%s&nbsp;</TH><TH>%s</TH><TH WIDTH='20'>%s&nbsp;</TH>", $view_prev_link, msg(64), $view_next_link);
		print "</TR></table>";
		comment (" /NAV BAR");
	}

# display current thread
# ----------------------
	if ($bn_thread && !$bn_no_thread_list) {
		comment ("THREAD LIST");
		$here=$key;
		$expnd="all";

		// display header
		$l=str_replace('"','\"', $bn_view_header);
		eval ("echo stripSlashes(\"$l\");");

		$ret = $db->getChild ($thread, "view");

		// display footer
		$l=str_replace('"','\"', $bn_view_footer);
		eval ("echo stripSlashes(\"$l\");");
		comment (" /THREAD LIST");
	}

# Display form reply if option set
# --------------------------------
	if ($bn_view_reply) {
		$bn_action="reply";
		$bn_action_mode="W";
		comment ("REPLY FORM");

		// set user's name and e-mail
		$reply_name = $username;
		$reply_address = $useraddress;
		$username = "";
		$useraddress = "";

		$subject = $reply_subject;
		if ($reply_body) {
			if ($reply_name != "") {
				$quoted_text = $reply_name . msg(45, " wrote:") . "\n";
			}
			$quoted_text .= quote_text($reply_body);
			$quoted_text = kill_quotes($quoted_text);
			$body = "";
		}

#	Displays the FORM
# -----------------
		$setUserField = true;       // Set username and password in form fields
		$mail_reply = $default_mail_reply; //	reset to default value
		$form_action = "insert.$ext";
		$back_form="view";
		$bn_popup=0;

		include "$inc_dir/form.$ext";
	}

# Display footer
# --------------
	display_footer ($header_footer);
?>
